declare module '@sage/x3-finance-data-api-partial' {
    import type {
        CustomerInvoiceHeaderBillToCustomerAddressLines,
        CustomerInvoiceHeaderBillToCustomerAddressLinesBinding,
        CustomerInvoiceHeaderBillToCustomerAddressLinesInput,
        CustomerInvoiceHeaderBillToCustomerCompanyNames,
        CustomerInvoiceHeaderBillToCustomerCompanyNamesBinding,
        CustomerInvoiceHeaderBillToCustomerCompanyNamesInput,
        CustomerInvoiceHeaderComments,
        CustomerInvoiceHeaderCommentsBinding,
        CustomerInvoiceHeaderCommentsInput,
        CustomerInvoiceHeaderInput,
        CustomerInvoiceHeaderPayByBusinessPartnerAddressLines,
        CustomerInvoiceHeaderPayByBusinessPartnerAddressLinesBinding,
        CustomerInvoiceHeaderPayByBusinessPartnerAddressLinesInput,
        CustomerInvoiceHeaderPayByBusinessPartnerCompanyNames,
        CustomerInvoiceHeaderPayByBusinessPartnerCompanyNamesBinding,
        CustomerInvoiceHeaderPayByBusinessPartnerCompanyNamesInput,
        CustomerInvoiceHeaderTaxes,
        CustomerInvoiceHeaderTaxesBinding,
        CustomerInvoiceHeaderTaxesInput,
        CustomerInvoicingElements,
        CustomerInvoicingElementsBinding,
        CustomerInvoicingElementsInput,
        EarlyDiscountLateCharge,
        InvoicingTerm,
        Mandate,
        Package as SageX3InvoicingData$Package,
        PaymentMethod,
        PaymentTerm,
        ProductCategoryTaxLevels,
        ProductCategoryTaxLevelsBinding,
        ProductCategoryTaxLevelsInput,
        ProductTaxLevels,
        ProductTaxLevelsBinding,
        ProductTaxLevelsInput,
        SupplierInvoiceHeaderBillBySupplierAddressLines,
        SupplierInvoiceHeaderBillBySupplierAddressLinesBinding,
        SupplierInvoiceHeaderBillBySupplierAddressLinesInput,
        SupplierInvoiceHeaderBillBySupplierCompanyNames,
        SupplierInvoiceHeaderBillBySupplierCompanyNamesBinding,
        SupplierInvoiceHeaderBillBySupplierCompanyNamesInput,
        SupplierInvoiceHeaderComments,
        SupplierInvoiceHeaderCommentsBinding,
        SupplierInvoiceHeaderCommentsInput,
        SupplierInvoiceHeaderInput,
        SupplierInvoiceHeaderPayToBusinessPartnerAddressLines,
        SupplierInvoiceHeaderPayToBusinessPartnerAddressLinesBinding,
        SupplierInvoiceHeaderPayToBusinessPartnerAddressLinesInput,
        SupplierInvoiceHeaderPayToBusinessPartnerCompanyNames,
        SupplierInvoiceHeaderPayToBusinessPartnerCompanyNamesBinding,
        SupplierInvoiceHeaderPayToBusinessPartnerCompanyNamesInput,
        SupplierInvoiceHeaderTaxes,
        SupplierInvoiceHeaderTaxesBinding,
        SupplierInvoiceHeaderTaxesInput,
        TaxRule,
    } from '@sage/x3-invoicing-data-api';
    import type {
        Package as SageX3ManufacturingData$Package,
        StockJournalImportInput,
    } from '@sage/x3-manufacturing-data-api';
    import type {
        BomCodes,
        BusinessPartner,
        BusinessPartnerAddress,
        BusinessPartnerAddressInput,
        BusinessPartnerBankDetail,
        BusinessPartnerBankDetailInput,
        BusinessPartnerCompanyException,
        BusinessPartnerCompanyExceptionInput,
        BusinessPartnerCompanyNames,
        BusinessPartnerCompanyNamesBinding,
        BusinessPartnerCompanyNamesInput,
        BusinessPartnerContact,
        BusinessPartnerContactInput,
        BusinessPartnerInput,
        Carrier,
        Currency,
        Customer,
        CustomerAddress,
        CustomerAddressInput,
        CustomerBankDetail,
        CustomerBankDetailInput,
        CustomerCashTaxRules,
        CustomerCashTaxRulesBinding,
        CustomerCashTaxRulesInput,
        CustomerCategory,
        CustomerContact,
        CustomerContactInput,
        CustomerInput,
        CustomerPaymentDays,
        CustomerPaymentDaysBinding,
        CustomerPaymentDaysInput,
        CustomerProduct,
        CustomerProductInput,
        CustomerSalesReps,
        CustomerSalesRepsBinding,
        CustomerSalesRepsInput,
        CustomerStatisticalGroups,
        CustomerStatisticalGroupsBinding,
        CustomerStatisticalGroupsInput,
        Incoterm,
        Mapping,
        Package as SageX3MasterData$Package,
        PrintTemplate,
        Product,
        ProductCategory,
        ProductCategoryInput,
        ProductCategoryStatisticalGroups,
        ProductCategoryStatisticalGroupsBinding,
        ProductCategoryStatisticalGroupsInput,
        ProductInput,
        ProductPackingUnits,
        ProductPackingUnitsBinding,
        ProductPackingUnitsInput,
        ProductSite,
        ProductStatisticalGroups,
        ProductStatisticalGroupsBinding,
        ProductStatisticalGroupsInput,
        ShipToCustomerAddress,
        ShipToCustomerAddressInput,
        Supplier,
        SupplierAddress,
        SupplierAddressInput,
        SupplierCategory,
        SupplierContact,
        SupplierContactInput,
        SupplierInput,
        SupplierProduct,
        SupplierProductInput,
        TechnicalSheet,
        UnavailablePeriods,
        UnitOfMeasure,
    } from '@sage/x3-master-data-api';
    import type {
        CostType,
        Package as SageX3ProjectManagementData$Package,
        ProjectLink,
    } from '@sage/x3-project-management-data-api';
    import type {
        LicensePlateNumber,
        Location,
        MajorVersionStatus,
        Package as SageX3StockData$Package,
        ProductCategoryDefaultLocations,
        ProductCategoryDefaultLocationsBinding,
        ProductCategoryDefaultLocationsInput,
        ProductCategoryOverheads,
        ProductCategoryOverheadsBinding,
        ProductCategoryOverheadsInput,
        ProductCategoryPackingUnits,
        ProductCategoryPackingUnitsBinding,
        ProductCategoryPackingUnitsInput,
        StockJournalInput,
        StockManagementRules,
        StockManagementRulesInput,
        StockStatus,
        Warehouse,
    } from '@sage/x3-stock-data-api';
    import type { Country, Package as SageX3Structure$Package, SiteGroupings } from '@sage/x3-structure-api';
    import type {
        Access,
        Company,
        GenericPrintReport,
        Language,
        MiscellaneousTable,
        Package as SageX3System$Package,
        Site,
        User,
    } from '@sage/x3-system-api';
    import type { Package as SageXtremAppMetadata$Package } from '@sage/xtrem-app-metadata-api';
    import type { Package as SageXtremX3SystemUtils$Package, SysUser } from '@sage/xtrem-x3-system-utils-api';
    import type {
        AggregateQueryOperation,
        AggregateReadOperation,
        BinaryStream,
        ClientCollection,
        ClientNode,
        ClientNodeInput,
        GetDefaultsOperation,
        QueryOperation,
        ReadOperation,
        TextStream,
        VitalClientNode,
        VitalClientNodeInput,
        decimal,
        integer,
    } from '@sage/xtrem-client';
    export interface AccSequenceNos$Enum {
        accountingSequenceNumber: 1;
        commitments: 2;
        lots: 3;
        noVatDeclarationQueryDebits: 4;
        noVatDeclarationQueryPayments: 5;
        precommitments: 6;
        budgetMOs: 7;
        financialDataExtraction: 8;
        projects: 9;
        budgetApproval: 10;
        reviewApproval: 11;
        intercompanyDocumentNumber: 12;
        annualVat: 13;
        periodicVat: 14;
        europeanServicesVat: 15;
        finalNumber: 16;
        annualCustomerListing: 17;
        euVatStatement: 18;
        auGstTaxReport: 19;
        auWthTaxReport: 20;
        fifoConversionsRecords: 21;
        vatDeclarationNumber: 22;
    }
    export type AccSequenceNos = keyof AccSequenceNos$Enum;
    export interface AcceptanceCode$Enum {
        billOfExchangeNotAccepted: 1;
        billOfExchangeAccepted: 2;
        promissoryNote: 3;
        billOfExchangeToAccept: 4;
    }
    export type AcceptanceCode = keyof AcceptanceCode$Enum;
    export interface AccountCategory1$Enum {
        unspecified: 1;
        fixed: 2;
        variable: 3;
    }
    export type AccountCategory1 = keyof AccountCategory1$Enum;
    export interface AccountCategory2$Enum {
        unspecified: 1;
        direct: 2;
        indirect: 3;
    }
    export type AccountCategory2 = keyof AccountCategory2$Enum;
    export interface AccountCategory$Enum {
        normal: 1;
        offBalanceSheet: 2;
        unused: 3;
    }
    export type AccountCategory = keyof AccountCategory$Enum;
    export interface AccountDimensionValue$Enum {
        accountsDimensions: 1;
        dimensionsAccounts: 2;
    }
    export type AccountDimensionValue = keyof AccountDimensionValue$Enum;
    export interface AccountSetupSort$Enum {
        byAccountRoot: 1;
        byAccount: 2;
    }
    export type AccountSetupSort = keyof AccountSetupSort$Enum;
    export interface AccountSort676$Enum {
        number: 1;
        title: 2;
        shortTitle: 3;
    }
    export type AccountSort676 = keyof AccountSort676$Enum;
    export interface AccountSort$Enum {
        number: 1;
        title: 2;
        shortTitle: 3;
        classification: 4;
        reporting1Debit: 5;
        reporting1Credit: 6;
        reporting2Debit: 7;
        reporting2Credit: 8;
        consolidationCode: 9;
    }
    export type AccountSort = keyof AccountSort$Enum;
    export interface AccountSpecificText853$Enum {
        test: 1;
        additionalLineToUseForAutoJournalFasvatreg: 2;
    }
    export type AccountSpecificText853 = keyof AccountSpecificText853$Enum;
    export interface AccountStatus$Enum {
        active: 1;
        inactive: 2;
    }
    export type AccountStatus = keyof AccountStatus$Enum;
    export interface AccountType2668$Enum {
        account: 1;
        dimension: 2;
        bp: 3;
    }
    export type AccountType2668 = keyof AccountType2668$Enum;
    export interface AccountType605$Enum {
        expense: 1;
        revenue: 2;
        investment: 3;
    }
    export type AccountType605 = keyof AccountType605$Enum;
    export interface AccountingJournalStatus$Enum {
        temporary: 1;
        final: 2;
    }
    export type AccountingJournalStatus = keyof AccountingJournalStatus$Enum;
    export interface AccountingSign$Enum {
        paymentSign: 1;
        expense: 2;
        revenue: 3;
    }
    export type AccountingSign = keyof AccountingSign$Enum;
    export interface AccountingTypes$Enum {
        niCsN: 1;
        ncrFsS: 2;
        ncrfPeS: 3;
        ncMeM: 4;
    }
    export type AccountingTypes = keyof AccountingTypes$Enum;
    export interface AccrualsGenerationType$Enum {
        substituteValue1: 1;
        substituteValue2: 2;
    }
    export type AccrualsGenerationType = keyof AccrualsGenerationType$Enum;
    export interface ActionType8341$Enum {
        post: 1;
        reverse: 2;
    }
    export type ActionType8341 = keyof ActionType8341$Enum;
    export interface ActivateDeactivate$Enum {
        activate: 1;
        deactivate: 2;
    }
    export type ActivateDeactivate = keyof ActivateDeactivate$Enum;
    export interface ActualBudgeted$Enum {
        actual: 1;
        budgeted: 2;
    }
    export type ActualBudgeted = keyof ActualBudgeted$Enum;
    export interface ActualSimulation$Enum {
        actual: 1;
        activeSimulation: 2;
        inactiveSimulation: 3;
    }
    export type ActualSimulation = keyof ActualSimulation$Enum;
    export interface Aligning$Enum {
        accounts: 1;
        dimension: 2;
    }
    export type Aligning = keyof Aligning$Enum;
    export interface AllocatedDocument$Enum {
        customerOrder: 1;
        supplierOrder: 2;
        accountingJournal: 3;
        supplierProforma: 4;
        unallocated: 5;
    }
    export type AllocatedDocument = keyof AllocatedDocument$Enum;
    export interface AllocatedJournal$Enum {
        customerOrder: 1;
        supplierOrder: 2;
        accountingJournal: 3;
        supplierProforma: 4;
    }
    export type AllocatedJournal = keyof AllocatedJournal$Enum;
    export interface AmountType686$Enum {
        base: 1;
        amount: 2;
    }
    export type AmountType686 = keyof AmountType686$Enum;
    export interface AmountsQuantities$Enum {
        amounts: 1;
        quantities: 2;
    }
    export type AmountsQuantities = keyof AmountsQuantities$Enum;
    export interface AmountsToBeDisplayed3606$Enum {
        balances: 1;
        movementsAndBalances: 2;
    }
    export type AmountsToBeDisplayed3606 = keyof AmountsToBeDisplayed3606$Enum;
    export interface AmountsToBeDisplayed$Enum {
        balancesInLedgerCurrency: 1;
        movementsAndBalancesInLedgerCurrency: 2;
        balancesInTransactionCurrency: 3;
        movementsAndBalancesInTransactionCurrency: 4;
    }
    export type AmountsToBeDisplayed = keyof AmountsToBeDisplayed$Enum;
    export interface AnalyticalAxisEntry$Enum {
        entered: 1;
        mandatory: 2;
        notEntered: 3;
    }
    export type AnalyticalAxisEntry = keyof AnalyticalAxisEntry$Enum;
    export interface AnalyticalBalanceSort$Enum {
        dimensionsAccounts: 1;
        accountsDimensions: 2;
    }
    export type AnalyticalBalanceSort = keyof AnalyticalBalanceSort$Enum;
    export interface AnalyticalBalances$Enum {
        unused: 1;
        debits: 2;
        credits: 3;
        balanceDrCr: 4;
        balanceCrDr: 5;
        commitments: 6;
        precommitments: 7;
        actualCommitted: 8;
        actualCommittedPrecommitted: 9;
        budget: 10;
        quantity: 11;
        committedQuantity: 12;
        precommittedQuantity: 13;
        quantityCommitted: 14;
        quantityCommittedPrecommitted: 15;
        budgetQuantity: 16;
        bAAmt: 17;
        bACAmt: 18;
        bACPAmt: 19;
        bAQty20: 20;
        bACQty21: 21;
        bACPQty22: 22;
        bA: 23;
        bAC: 24;
        bACP: 25;
        bAQty: 26;
        bACQty: 27;
        bACPQty: 28;
        aBAmt: 29;
        aCBAmt: 30;
        aCPBAmt: 31;
        aBQty32: 32;
        aCBQty33: 33;
        aCPBQty34: 34;
        aB: 35;
        aCB: 36;
        aCPB: 37;
        aBQty: 38;
        aCBQty: 39;
        aCPBQty: 40;
        unit: 41;
    }
    export type AnalyticalBalances = keyof AnalyticalBalances$Enum;
    export interface AnalyticalCategory$Enum {
        general: 1;
        analytical: 2;
    }
    export type AnalyticalCategory = keyof AnalyticalCategory$Enum;
    export interface AnalyticalDataEntry$Enum {
        allJournalEntries: 1;
        noDimensionTypeValue: 2;
        oneDimensionTypeWithNoValue: 3;
        noValueOnDimensionType: 4;
    }
    export type AnalyticalDataEntry = keyof AnalyticalDataEntry$Enum;
    export interface AnalyticalPyramids$Enum {
        unused: 1;
        loads: 2;
        products: 3;
        balance: 4;
        commitments: 5;
        precommitments: 6;
        realCommitments: 7;
        realCommitmentsPrecommitments: 8;
        budget: 9;
        quantity: 10;
        committedQuantity: 11;
        qtyPrecommitments: 12;
        qtyCommitments: 13;
        qtyCommitmentsPrecommitments: 14;
        budgetQuantity: 15;
        bRAmt: 16;
        bRCAmt: 17;
        bRCPAmt: 18;
        bRQty19: 19;
        bRCQty20: 20;
        bRCPQty21: 21;
        bR: 22;
        bRC: 23;
        bRCP: 24;
        bRQty: 25;
        bRCQty: 26;
        bRCPQty: 27;
        unit: 28;
    }
    export type AnalyticalPyramids = keyof AnalyticalPyramids$Enum;
    export interface AnalyticalResyncType$Enum {
        balanceComparison: 1;
        resynchronization: 2;
    }
    export type AnalyticalResyncType = keyof AnalyticalResyncType$Enum;
    export interface AnalyticalSense$Enum {
        expense: 1;
        revenue: 2;
    }
    export type AnalyticalSense = keyof AnalyticalSense$Enum;
    export interface ApprovalLevel$Enum {
        envelope: 1;
        fiscalYearBudget: 2;
        budgetLine: 3;
        multiple: 4;
    }
    export type ApprovalLevel = keyof ApprovalLevel$Enum;
    export interface ApprovalProcessing$Enum {
        none: 1;
        approve: 2;
        reject: 3;
    }
    export type ApprovalProcessing = keyof ApprovalProcessing$Enum;
    export interface AssessmentMethod$Enum {
        none: 1;
        byJournalEntry: 2;
        byAccountBalance: 3;
    }
    export type AssessmentMethod = keyof AssessmentMethod$Enum;
    export interface AutomaticLineType$Enum {
        unique: 1;
        repetitive: 2;
        linkedTable: 3;
    }
    export type AutomaticLineType = keyof AutomaticLineType$Enum;
    export interface AuxiliaryAccountSort$Enum {
        accountingDate: 1;
        dueDate: 2;
        valueDate: 3;
    }
    export type AuxiliaryAccountSort = keyof AuxiliaryAccountSort$Enum;
    export interface BadDebtManagementRules$Enum {
        doubtfulDebts: 1;
        impairment: 2;
        writeOffs: 3;
        all: 4;
    }
    export type BadDebtManagementRules = keyof BadDebtManagementRules$Enum;
    export interface BalancePaymentAccountType$Enum {
        internalBankAccount: 1;
        externalBankAccount: 2;
        otherExternalAccount: 3;
        compensationAccount: 4;
        withoutAccountTransactions: 5;
    }
    export type BalancePaymentAccountType = keyof BalancePaymentAccountType$Enum;
    export interface BalanceSort$Enum {
        code: 1;
        companyName: 2;
        shortTitle: 3;
        siteRegistrationNumber: 4;
        groupCode: 5;
    }
    export type BalanceSort = keyof BalanceSort$Enum;
    export interface BalanceUpdate$Enum {
        no: 1;
        customer: 2;
        supplier: 3;
    }
    export type BalanceUpdate = keyof BalanceUpdate$Enum;
    export interface BankAssignmentMethod$Enum {
        closestDueDate: 1;
        highestAmount: 2;
    }
    export type BankAssignmentMethod = keyof BankAssignmentMethod$Enum;
    export interface BankChargeBearer$Enum {
        shared: 1;
        beneficiary: 2;
        applicant: 3;
    }
    export type BankChargeBearer = keyof BankChargeBearer$Enum;
    export interface BankReconciliationOption$Enum {
        substituteValue1: 1;
        substituteValue2: 2;
    }
    export type BankReconciliationOption = keyof BankReconciliationOption$Enum;
    export interface BankSort$Enum {
        accountingDate: 1;
        valueDate: 2;
    }
    export type BankSort = keyof BankSort$Enum;
    export interface BankStatementSource$Enum {
        imported: 1;
        entered: 2;
    }
    export type BankStatementSource = keyof BankStatementSource$Enum;
    export interface BatchFieldDescription$Enum {
        numeric: 1;
        total: 2;
        alphabetical: 3;
        valueN1: 4;
        formula: 5;
    }
    export type BatchFieldDescription = keyof BatchFieldDescription$Enum;
    export interface BenefitType$Enum {
        expenseAccruals: 1;
        revenueAccruals: 2;
    }
    export type BenefitType = keyof BenefitType$Enum;
    export interface BoxType$Enum {
        amount: 1;
        text: 2;
        checkbox: 3;
    }
    export type BoxType = keyof BoxType$Enum;
    export interface BudgetCategory2692$Enum {
        annual: 1;
        multiannual: 2;
    }
    export type BudgetCategory2692 = keyof BudgetCategory2692$Enum;
    export interface BudgetCategory$Enum {
        period: 1;
        account: 2;
        dimension: 3;
    }
    export type BudgetCategory = keyof BudgetCategory$Enum;
    export interface BudgetControlLevel$Enum {
        line: 1;
        fiscalYear: 2;
        envelope: 3;
    }
    export type BudgetControlLevel = keyof BudgetControlLevel$Enum;
    export interface BudgetDefinitionLevel$Enum {
        company: 1;
        site: 2;
    }
    export type BudgetDefinitionLevel = keyof BudgetDefinitionLevel$Enum;
    export interface BudgetDocumentType$Enum {
        all: 1;
        purchaseRequests: 2;
        orders: 3;
    }
    export type BudgetDocumentType = keyof BudgetDocumentType$Enum;
    export interface BudgetOverrun$Enum {
        noOverrun: 1;
        withinTheLimitsOfTheBudgetRemainingToBeAllocated: 2;
        withinTheLimitsOfTheBudgetReserve: 3;
        withinTheLimitsOfTheEnvelopeRemainingToBeAllocated: 4;
        withinTheLimitsOfTheEnvelopeReserve: 5;
        envelopeOverrun: 6;
    }
    export type BudgetOverrun = keyof BudgetOverrun$Enum;
    export interface BudgetStatisticalGroup$Enum {
        mcl1A: 1;
        mcl2B: 2;
        mcl3C: 3;
        mcl4D: 4;
        notUsed: 5;
    }
    export type BudgetStatisticalGroup = keyof BudgetStatisticalGroup$Enum;
    export interface BudgetaryControlType648$Enum {
        none: 1;
        blocking: 2;
        notBlocking: 3;
    }
    export type BudgetaryControlType648 = keyof BudgetaryControlType648$Enum;
    export interface BudgetaryControlType$Enum {
        none: 1;
        holding: 2;
        notHolding: 3;
        accordingToOperator: 4;
    }
    export type BudgetaryControlType = keyof BudgetaryControlType$Enum;
    export interface BudgetaryGlManagement$Enum {
        none: 1;
        manual: 2;
        complete: 3;
    }
    export type BudgetaryGlManagement = keyof BudgetaryGlManagement$Enum;
    export interface BuildingLocation$Enum {
        locatedOnNationalTerritory: 1;
        locatedInBasqueCountryOrNavarre: 2;
        withoutCadastreReference: 3;
        locatedAbroad: 4;
    }
    export type BuildingLocation = keyof BuildingLocation$Enum;
    export interface BusinessPartnerJournalType$Enum {
        unique: 1;
        byDiscountType: 2;
    }
    export type BusinessPartnerJournalType = keyof BusinessPartnerJournalType$Enum;
    export interface BusinessPartnerType672$Enum {
        payByBp: 1;
        billToBp: 2;
    }
    export type BusinessPartnerType672 = keyof BusinessPartnerType672$Enum;
    export interface BusinessPartnerType$Enum {
        customer: 1;
        supplier: 2;
    }
    export type BusinessPartnerType = keyof BusinessPartnerType$Enum;
    export interface CashFlowInterface$Enum {
        dope: 1;
        trans: 2;
        budg: 3;
        lcr: 4;
        ref: 5;
    }
    export type CashFlowInterface = keyof CashFlowInterface$Enum;
    export interface CashInterface2675$Enum {
        descr: 1;
        trans: 2;
        budg: 3;
    }
    export type CashInterface2675 = keyof CashInterface2675$Enum;
    export interface CashInterface$Enum {
        none: 1;
        notesPayableReceivablePosting: 2;
        intermediatePosting: 3;
        bankPosting: 4;
    }
    export type CashInterface = keyof CashInterface$Enum;
    export interface CategoryFormats$Enum {
        general: 1;
        analytical: 2;
        byLot: 3;
    }
    export type CategoryFormats = keyof CategoryFormats$Enum;
    export interface ChartOfAccountsEnum$Enum {
        masterChart: 1;
        localChart: 2;
        consolidatedChart: 3;
    }
    export type ChartOfAccountsEnum = keyof ChartOfAccountsEnum$Enum;
    export interface CheckType$Enum {
        localCheck: 1;
        outstationCheck: 2;
        foreign: 3;
        euro: 4;
    }
    export type CheckType = keyof CheckType$Enum;
    export interface ChildUnitInDeclaration$Enum {
        no: 1;
        wholeUnit: 2;
        halfUnit: 3;
    }
    export type ChildUnitInDeclaration = keyof ChildUnitInDeclaration$Enum;
    export interface ClosingType$Enum {
        generalAccounting: 1;
        dimensional: 2;
        complete: 3;
    }
    export type ClosingType = keyof ClosingType$Enum;
    export interface ColumnInformation$Enum {
        quantity: 1;
        amount: 2;
        actualQuantity: 3;
        actualAmount: 4;
        quantityCommitted: 5;
        amountCommitted: 6;
        quantityPrecommitted: 7;
        amountPrecommitted: 8;
        formula: 9;
        text: 10;
    }
    export type ColumnInformation = keyof ColumnInformation$Enum;
    export interface ColumnType$Enum {
        debitCredit1: 1;
        debitCredit: 2;
        creditDebit: 3;
    }
    export type ColumnType = keyof ColumnType$Enum;
    export interface CommitmentType631$Enum {
        precommitment: 1;
        commitment: 2;
    }
    export type CommitmentType631 = keyof CommitmentType631$Enum;
    export interface CompanyActivityType$Enum {
        other: 1;
        retail: 2;
    }
    export type CompanyActivityType = keyof CompanyActivityType$Enum;
    export interface ControlAccount$Enum {
        supplier: 1;
        customer: 2;
        indifferent: 3;
    }
    export type ControlAccount = keyof ControlAccount$Enum;
    export interface ControlType2600$Enum {
        none: 1;
        annual: 2;
        period: 3;
        sliding: 4;
        accumulated: 5;
    }
    export type ControlType2600 = keyof ControlType2600$Enum;
    export interface ControlType2625$Enum {
        blocking: 1;
        notBlocking: 2;
    }
    export type ControlType2625 = keyof ControlType2625$Enum;
    export interface CountryAddressCode$Enum {
        bpAddress: 1;
        paymentAddress: 2;
    }
    export type CountryAddressCode = keyof CountryAddressCode$Enum;
    export interface CreSendingMediumTypeCode$Enum {
        email: 1;
        paperMaterialByPostalMail: 2;
    }
    export type CreSendingMediumTypeCode = keyof CreSendingMediumTypeCode$Enum;
    export interface CrystalReportsAccContd$Enum {
        days1: 1;
        weeks: 2;
        substituteValue3: 3;
        fortnights: 4;
        months: 5;
        fixed: 6;
        file: 7;
        criteria: 8;
        empty: 9;
        s: 10;
        p: 11;
        d: 12;
        rBVariance13: 13;
        rEBVariance14: 14;
        rEPBVariance15: 15;
        rBQtyVariance16: 16;
        rEBQtyVariance17: 17;
        rEPBQtyVariance18: 18;
        rBVariance: 19;
        rEBVariance: 20;
        rEPBVariance: 21;
        rBQtyVariance: 22;
        rEBQtyVariance: 23;
        rEPBQtyVariance: 24;
        balanceChgRev: 25;
        balancePdtRev: 26;
        achievedQty: 27;
        days28: 28;
        notDue: 29;
        dueDate: 30;
        telephone: 31;
        days: 32;
        byBpCode: 33;
        typeDocumentNumber: 34;
        tradeName: 35;
        preparatoryReportForTheTaxDeclarationOnPayments: 36;
        reprintPreparatoryReportForTheTaxDeclarationOnPayments: 37;
        txsOn: 38;
        debitTotal: 39;
        creditTotal: 40;
        generalTotal: 41;
        siteTotal: 42;
        reportInPreparationToTheEuropeanServicesDeclaration: 43;
        reprintingTheReportInPreparationToTheEuropeanServicesDeclaration: 44;
        ledgerTotal: 45;
        total: 46;
    }
    export type CrystalReportsAccContd = keyof CrystalReportsAccContd$Enum;
    export interface Currency2606$Enum {
        transaction: 1;
        company: 2;
    }
    export type Currency2606 = keyof Currency2606$Enum;
    export interface Currency3643$Enum {
        originalTransactionCurrency: 1;
        ledgerCurrency: 2;
    }
    export type Currency3643 = keyof Currency3643$Enum;
    export interface CurrencyEnum$Enum {
        company: 1;
        reporting: 2;
    }
    export type CurrencyEnum = keyof CurrencyEnum$Enum;
    export interface CustomerAgedBalanceField$Enum {
        customerSince: 1;
        lastQuote: 2;
        lastOrder: 3;
        lastShipment: 4;
        lastInvoice: 5;
        lastPayment: 6;
        lastLatePayment: 7;
        lastReminder: 8;
    }
    export type CustomerAgedBalanceField = keyof CustomerAgedBalanceField$Enum;
    export interface DateBasisForAging$Enum {
        ageByInvoiceDate: 1;
        ageByDueDate: 2;
    }
    export type DateBasisForAging = keyof DateBasisForAging$Enum;
    export interface DatevAccountModification3655$Enum {
        right: 1;
        left: 2;
    }
    export type DatevAccountModification3655 = keyof DatevAccountModification3655$Enum;
    export interface DatevAccountModification$Enum {
        shorten: 1;
        lengthen: 2;
    }
    export type DatevAccountModification = keyof DatevAccountModification$Enum;
    export interface DatevBpCopy$Enum {
        allBPs: 1;
        customer: 2;
        supplier: 3;
    }
    export type DatevBpCopy = keyof DatevBpCopy$Enum;
    export interface DatevInvoiceFields$Enum {
        documentNo: 1;
        sourceDocumentNo: 2;
        notUsed: 3;
    }
    export type DatevInvoiceFields = keyof DatevInvoiceFields$Enum;
    export interface DebitCredit$Enum {
        debit: 1;
        credit: 2;
    }
    export type DebitCredit = keyof DebitCredit$Enum;
    export interface DeclarationType$Enum {
        normal1099: 1;
        additionalDeclaration: 2;
    }
    export type DeclarationType = keyof DeclarationType$Enum;
    export interface DefinitionLevel2696$Enum {
        groupOfCompanies: 1;
        groupOfSites: 2;
        company: 3;
        site: 4;
    }
    export type DefinitionLevel2696 = keyof DefinitionLevel2696$Enum;
    export interface DelayCalculationDate$Enum {
        valueDate: 1;
        accountingDate: 2;
    }
    export type DelayCalculationDate = keyof DelayCalculationDate$Enum;
    export interface DepositType$Enum {
        receipt: 1;
        discount: 2;
        receiptInValue: 3;
        discountInValue: 4;
    }
    export type DepositType = keyof DepositType$Enum;
    export interface DetailLevel$Enum {
        project: 1;
        envelope: 2;
        budget: 3;
        line: 4;
    }
    export type DetailLevel = keyof DetailLevel$Enum;
    export interface DimensionViewSetupSort$Enum {
        byAccountRoot: 1;
        byDimensionType: 2;
    }
    export type DimensionViewSetupSort = keyof DimensionViewSetupSort$Enum;
    export interface DiscountCalculationDate$Enum {
        openItemDueDate: 1;
        invoiceDate: 2;
    }
    export type DiscountCalculationDate = keyof DiscountCalculationDate$Enum;
    export interface DiscountFormType$Enum {
        bankDeposits: 1;
        paymentOrder: 2;
        payment: 3;
    }
    export type DiscountFormType = keyof DiscountFormType$Enum;
    export interface DisplayMode$Enum {
        value: 1;
        title: 2;
        formula: 3;
    }
    export type DisplayMode = keyof DisplayMode$Enum;
    export interface DocumentReason$Enum {
        purchaseRequest: 1;
        order: 2;
        invoice: 3;
        grniGoodsReceivedNotInvoiced: 4;
        receivableCreditMemos: 5;
        carryforward: 6;
        creditMemo: 7;
        accountingDocument: 8;
    }
    export type DocumentReason = keyof DocumentReason$Enum;
    export interface DueDateCancellation$Enum {
        notToPlaceOnAnotherStatement: 1;
        toPlaceOnAnotherStatement: 2;
    }
    export type DueDateCancellation = keyof DueDateCancellation$Enum;
    export interface DueDateItemType$Enum {
        order: 1;
        invoice: 2;
        payment: 3;
        others: 4;
    }
    export type DueDateItemType = keyof DueDateItemType$Enum;
    export interface EnteredCalculated$Enum {
        entry: 1;
        calculatedAmount: 2;
        calculatedQuantity: 3;
    }
    export type EnteredCalculated = keyof EnteredCalculated$Enum;
    export interface EntryOrigin$Enum {
        directEntry: 1;
        automaticGeneration: 2;
        import: 3;
    }
    export type EntryOrigin = keyof EntryOrigin$Enum;
    export interface EntryType2646$Enum {
        column: 1;
        row: 2;
        tab: 3;
    }
    export type EntryType2646 = keyof EntryType2646$Enum;
    export interface EntryType628$Enum {
        all: 1;
        matched: 2;
        notMatched: 3;
    }
    export type EntryType628 = keyof EntryType628$Enum;
    export interface EntryType692$Enum {
        selected: 1;
        notSelected: 2;
        all: 3;
    }
    export type EntryType692 = keyof EntryType692$Enum;
    export interface Enum1099Account$Enum {
        feesAndVacations: 1;
        commissions: 2;
        brokerages: 3;
        rebates: 4;
        attendanceTokens: 5;
        royalties: 6;
        inventorRights: 7;
        otherPayments: 8;
        indemnitiesAndReimbursements: 9;
        perquisites: 10;
        withholdingTaxOnIncome: 11;
        netTaxOnRoyalties: 12;
    }
    export type Enum1099Account = keyof Enum1099Account$Enum;
    export interface Enum1099DeclarationMode$Enum {
        substituteValue1: 1;
        substituteValue2: 2;
    }
    export type Enum1099DeclarationMode = keyof Enum1099DeclarationMode$Enum;
    export interface Enum1099Form$Enum {
        none: 1;
        misc: 2;
        int: 3;
        div: 4;
        nec: 5;
    }
    export type Enum1099Form = keyof Enum1099Form$Enum;
    export interface Enum1099RecordType$Enum {
        alphanumeric: 1;
        numeric: 2;
        date: 3;
    }
    export type Enum1099RecordType = keyof Enum1099RecordType$Enum;
    export interface Enum1099RecordUsage$Enum {
        mandatory: 1;
        conditional: 2;
        optional: 3;
    }
    export type Enum1099RecordUsage = keyof Enum1099RecordUsage$Enum;
    export interface Enum2815Category$Enum {
        commissionBrokerageRebate: 1;
        feesOrSessionalPayments: 2;
        benefitsInKind: 3;
        expensesIncurredOnBehalfOfTheBeneficiary: 4;
    }
    export type Enum2815Category = keyof Enum2815Category$Enum;
    export interface Enum2815TypeOfDeclaredAmounts$Enum {
        invoicedAmounts: 1;
        paidAmounts: 2;
    }
    export type Enum2815TypeOfDeclaredAmounts = keyof Enum2815TypeOfDeclaredAmounts$Enum;
    export interface EnvelopeStatus$Enum {
        entered: 1;
        toBeApproved: 2;
        approved: 3;
        closed: 4;
        commitmentsCarriedForward: 5;
    }
    export type EnvelopeStatus = keyof EnvelopeStatus$Enum;
    export interface ExcelExport$Enum {
        saveOnClientWorkstation: 1;
        activateExcel: 2;
    }
    export type ExcelExport = keyof ExcelExport$Enum;
    export interface ExpenseRevenueIndeterminate$Enum {
        expense: 1;
        revenue: 2;
        unspecified: 3;
    }
    export type ExpenseRevenueIndeterminate = keyof ExpenseRevenueIndeterminate$Enum;
    export interface ExpenseRevenue$Enum {
        expense: 1;
        revenue: 2;
    }
    export type ExpenseRevenue = keyof ExpenseRevenue$Enum;
    export interface ExportOption$Enum {
        balanceOfControlAccounts: 1;
        sumOfIndividualBalances: 2;
    }
    export type ExportOption = keyof ExportOption$Enum;
    export interface ExtractDas2Fees$Enum {
        das2FlagAssociatedWithJournalType: 1;
        das2FlagAssociatedWithInvoiceJournal: 2;
    }
    export type ExtractDas2Fees = keyof ExtractDas2Fees$Enum;
    export interface FdeAmountType2662$Enum {
        achieved: 1;
        committed: 2;
        precommitted: 3;
    }
    export type FdeAmountType2662 = keyof FdeAmountType2662$Enum;
    export interface FdeAmountType2663$Enum {
        balances: 1;
        debtorBalances: 2;
        creditorBalances: 3;
        debtorAmounts: 4;
        creditorAmounts: 5;
    }
    export type FdeAmountType2663 = keyof FdeAmountType2663$Enum;
    export interface FdeAmountType2665$Enum {
        movementsCFwdClosing: 1;
        movementsCFwd: 2;
        movementsClosing: 3;
        movementsOnly: 4;
        cFwdOnly: 5;
        closingOnly: 6;
    }
    export type FdeAmountType2665 = keyof FdeAmountType2665$Enum;
    export interface FdeAmountType$Enum {
        generalAccounting: 1;
        analyticalAccounting: 2;
        budgetAccounting: 3;
        sumOfCells: 4;
        expression: 5;
        variable: 6;
    }
    export type FdeAmountType = keyof FdeAmountType$Enum;
    export interface FdeExtractionType$Enum {
        accountRoot: 1;
        controlAccount: 2;
        reportingCode: 3;
        pyramid: 4;
    }
    export type FdeExtractionType = keyof FdeExtractionType$Enum;
    export interface FeesDeclaration$Enum {
        none: 1;
        das2: 2;
        substituteValue3: 3;
        substituteValue4: 4;
    }
    export type FeesDeclaration = keyof FeesDeclaration$Enum;
    export interface FileTypeRecapitulativeSt$Enum {
        csvForSageElsterClient: 1;
        csvForElsterOnline: 2;
    }
    export type FileTypeRecapitulativeSt = keyof FileTypeRecapitulativeSt$Enum;
    export interface FinancialStatementPages$Enum {
        substituteValue1: 1;
        substituteValue2: 2;
        substituteValue3: 3;
        substituteValue4: 4;
        substituteValue5: 5;
        substituteValue6: 6;
        substituteValue7: 7;
        substituteValue8: 8;
        substituteValue9: 9;
        substituteValue10: 10;
        substituteValue11: 11;
        substituteValue12: 12;
        substituteValue13: 13;
        substituteValue14: 14;
        substituteValue15: 15;
        substituteValue16: 16;
        substituteValue17: 17;
        dgi2059F18: 18;
        dgi2059G19: 19;
        dgi206520: 20;
        dgi2065Bis21: 21;
        dgi2065Ter22: 22;
        dgi206723: 23;
        ediDgi24: 24;
        otherTable25: 25;
        dgiCa18Chapay26: 26;
        ediDgi27: 27;
        otherTable28: 28;
        dgiCa20Chaava29: 29;
        dgiCa21Proava30: 30;
        ediDgi31: 31;
        otherTable32: 32;
        dgi2057: 33;
        dgi2058A: 34;
        dgi2058B: 35;
        dgi2058C: 36;
        dgi2058Is: 37;
        dgi2059A: 38;
        dgi2059B: 39;
        dgi2059C: 40;
        dgi2059D: 41;
        dgi2059E: 42;
        dgi2059F: 43;
        dgi2059G: 44;
        dgi2059H: 45;
        dgi2059I: 46;
        dgi2065: 47;
        dgi2065Bis: 48;
        dgi2065Ter: 49;
        dgi2066: 50;
        dgi2067: 51;
        dgiAnnexlib02: 52;
        dgiAnnexlib03: 53;
        dgiCa17Prorec: 54;
        dgiCa18Chapay: 55;
        dgiCa19Charep: 56;
        dgiCa20Chaava: 57;
        dgiCa21Proava: 58;
        ediDgi: 59;
        otherTable: 60;
    }
    export type FinancialStatementPages = keyof FinancialStatementPages$Enum;
    export interface FiscalYearOrPeriod$Enum {
        fullFiscalYear: 1;
        period: 2;
    }
    export type FiscalYearOrPeriod = keyof FiscalYearOrPeriod$Enum;
    export interface FiscalYearReport$Enum {
        notOpen: 1;
        open: 2;
        closed: 3;
    }
    export type FiscalYearReport = keyof FiscalYearReport$Enum;
    export interface FlagAutoManual$Enum {
        manual: 1;
        auto: 2;
    }
    export type FlagAutoManual = keyof FlagAutoManual$Enum;
    export interface FlowManagement$Enum {
        notEntered: 1;
        optional: 2;
        mandatory: 3;
    }
    export type FlowManagement = keyof FlowManagement$Enum;
    export interface FormulaCondition$Enum {
        none: 1;
        positiveBalance: 2;
        negativeBalance: 3;
    }
    export type FormulaCondition = keyof FormulaCondition$Enum;
    export interface FormulaType3726$Enum {
        tableExtraction: 1;
        expression: 2;
        operation: 3;
    }
    export type FormulaType3726 = keyof FormulaType3726$Enum;
    export interface FormulaType874$Enum {
        budgeted: 1;
        actual: 2;
        commited: 3;
        precommitted: 4;
    }
    export type FormulaType874 = keyof FormulaType874$Enum;
    export interface GeneralAnalytical$Enum {
        general: 1;
        analytical: 2;
    }
    export type GeneralAnalytical = keyof GeneralAnalytical$Enum;
    export interface GeneralJournalSort$Enum {
        sitePeriod: 1;
        periodSite: 2;
    }
    export type GeneralJournalSort = keyof GeneralJournalSort$Enum;
    export interface GenerationType2601$Enum {
        actual: 1;
        simulation: 2;
    }
    export type GenerationType2601 = keyof GenerationType2601$Enum;
    export interface GenerationType2678$Enum {
        actual: 1;
        simulation: 2;
        regeneration: 3;
    }
    export type GenerationType2678 = keyof GenerationType2678$Enum;
    export interface GenerationType651$Enum {
        global: 1;
        byBp: 2;
    }
    export type GenerationType651 = keyof GenerationType651$Enum;
    export interface IndicateurOperations$Enum {
        create: 1;
        delete: 2;
        modify: 3;
    }
    export type IndicateurOperations = keyof IndicateurOperations$Enum;
    export interface InstructionKeysDta$Enum {
        none: 1;
        salaryPension: 2;
    }
    export type InstructionKeysDta = keyof InstructionKeysDta$Enum;
    export interface InstructionKeysEzag$Enum {
        none: 1;
        personally: 2;
        urgent: 3;
    }
    export type InstructionKeysEzag = keyof InstructionKeysEzag$Enum;
    export interface InvoiceHeaderAmountControl$Enum {
        exTaxAndTaxInclAmountsOptional: 1;
        exTaxAndTaxInclAmountsToBeEntered: 2;
    }
    export type InvoiceHeaderAmountControl = keyof InvoiceHeaderAmountControl$Enum;
    export interface JournalCategory$Enum {
        normal: 1;
        carryforward: 2;
        closing: 3;
    }
    export type JournalCategory = keyof JournalCategory$Enum;
    export interface JournalGenerationType$Enum {
        payment: 1;
        remittancePaymentOrder: 2;
        dueDate: 3;
    }
    export type JournalGenerationType = keyof JournalGenerationType$Enum;
    export interface JournalType613$Enum {
        sales: 1;
        purchasing: 2;
        treasury: 3;
        miscOperations1: 4;
        miscOperations2: 5;
        miscOperations3: 6;
        carryforward: 7;
        miscOperations4: 8;
        generalJournal: 9;
        miscOperations6: 10;
    }
    export type JournalType613 = keyof JournalType613$Enum;
    export interface JournalTypes$Enum {
        bank: 1;
        checkToCash: 2;
        notesPayableToReceive: 3;
        notesPayableOnPurchases: 4;
        notesPayableOnFixedAssets: 5;
        remittanceForCollection: 6;
        remittanceForDiscount: 7;
        notesPRRiskClosing: 8;
        none: 9;
    }
    export type JournalTypes = keyof JournalTypes$Enum;
    export interface LaunchPeriodicity$Enum {
        everyDay: 1;
        everyWeek: 2;
        everyMonth: 3;
    }
    export type LaunchPeriodicity = keyof LaunchPeriodicity$Enum;
    export interface LedgerAuthorizations$Enum {
        none: 1;
        authorized: 2;
        mandatory: 3;
    }
    export type LedgerAuthorizations = keyof LedgerAuthorizations$Enum;
    export interface LedgerInCurrencies$Enum {
        currencyCompany: 1;
        currencyReporting: 2;
        companyReporting: 3;
    }
    export type LedgerInCurrencies = keyof LedgerInCurrencies$Enum;
    export interface LedgerType$Enum {
        notApplicable: 1;
        sncBase: 2;
        iasIfrsStandards: 3;
        snsMicroEntities: 4;
        others: 5;
    }
    export type LedgerType = keyof LedgerType$Enum;
    export interface LocalMenu601$Enum {
        dummyValue: 0;
    }
    export type LocalMenu601 = keyof LocalMenu601$Enum;
    export interface MandatoryNo$Enum {
        mandatory: 1;
        optional: 2;
        notEntered: 3;
    }
    export type MandatoryNo = keyof MandatoryNo$Enum;
    export interface MatchingMethod$Enum {
        byAmount: 1;
        byAmountInCurrencies: 2;
        transferToTheBalance: 3;
        searchForBalance: 4;
        byReferenceField: 5;
        byDescriptionField: 6;
        byFreeReferenceField: 7;
    }
    export type MatchingMethod = keyof MatchingMethod$Enum;
    export interface MatchingType$Enum {
        uppercaseLetter: 1;
        lowercaseLetter: 2;
        uppercaseAndLowercaseLetter: 3;
    }
    export type MatchingType = keyof MatchingType$Enum;
    export interface MediumType$Enum {
        telematic: 1;
        cdR: 2;
        form: 3;
    }
    export type MediumType = keyof MediumType$Enum;
    export interface NoYesUnspecified$Enum {
        no: 1;
        yes: 2;
        unspecified: 3;
    }
    export type NoYesUnspecified = keyof NoYesUnspecified$Enum;
    export interface NotesPrPortfolioUpdate$Enum {
        no: 1;
        notesPR1: 2;
        notesPR2: 3;
        notesPR3: 4;
    }
    export type NotesPrPortfolioUpdate = keyof NotesPrPortfolioUpdate$Enum;
    export interface Orientation3645$Enum {
        creditIncomingAndDebitOutgoing: 1;
        creditOutgoingAndDebitIncoming: 2;
    }
    export type Orientation3645 = keyof Orientation3645$Enum;
    export interface PartialPayment$Enum {
        proportional: 1;
        onTheFirstPayment: 2;
    }
    export type PartialPayment = keyof PartialPayment$Enum;
    export interface PaymentBalanceLineFlag$Enum {
        create: 1;
        delete: 2;
        modify: 3;
    }
    export type PaymentBalanceLineFlag = keyof PaymentBalanceLineFlag$Enum;
    export interface PaymentMode$Enum {
        inCash: 1;
        debitedFromBankAccount: 2;
    }
    export type PaymentMode = keyof PaymentMode$Enum;
    export interface PaymentStatus$Enum {
        entered: 1;
        accepted: 2;
        postedNotesPayableReceivable: 3;
        stage4: 4;
        slipEntered: 5;
        slipOnFile: 6;
        paymentOrderEntered: 7;
        onIntermediateAccount: 8;
        inTheBank: 9;
        notesPRRiskClosing: 10;
        unpaid: 11;
    }
    export type PaymentStatus = keyof PaymentStatus$Enum;
    export interface PaymentTransactionType$Enum {
        none: 1;
        lcr: 2;
        pre: 3;
        vir: 4;
        sct: 5;
        sdd: 6;
    }
    export type PaymentTransactionType = keyof PaymentTransactionType$Enum;
    export interface PeriodType$Enum {
        normal: 1;
        opening: 2;
        closing: 3;
    }
    export type PeriodType = keyof PeriodType$Enum;
    export interface Periodicity$Enum {
        monthly: 1;
        quarterly: 2;
        yearly: 3;
        biMonthly: 4;
        notPeriodic: 5;
    }
    export type Periodicity = keyof Periodicity$Enum;
    export interface PostingLevel$Enum {
        summary: 1;
        detail: 2;
    }
    export type PostingLevel = keyof PostingLevel$Enum;
    export interface PostingStatus$Enum {
        notManaged: 1;
        toBePosted: 2;
        posted: 3;
    }
    export type PostingStatus = keyof PostingStatus$Enum;
    export interface PostingVatEntities$Enum {
        notManaged: 1;
        toBePosted: 2;
        withMatching: 3;
    }
    export type PostingVatEntities = keyof PostingVatEntities$Enum;
    export interface PrintCurrency$Enum {
        ledgerCurrency: 1;
        selectionCurrency: 2;
    }
    export type PrintCurrency = keyof PrintCurrency$Enum;
    export interface PrintEffect$Enum {
        normal: 1;
        strikethrough: 2;
        underlined: 3;
    }
    export type PrintEffect = keyof PrintEffect$Enum;
    export interface PrintFormat872$Enum {
        normal: 1;
        bold: 2;
        italic: 3;
        boldItalic: 4;
    }
    export type PrintFormat872 = keyof PrintFormat872$Enum;
    export interface PrintFormat$Enum {
        normal: 1;
        bold: 2;
        italic: 3;
        underlined: 4;
        boldUnderlined: 5;
        italicUnderlined: 6;
    }
    export type PrintFormat = keyof PrintFormat$Enum;
    export interface Printing$Enum {
        printing: 1;
        inquiry: 2;
    }
    export type Printing = keyof Printing$Enum;
    export interface ProcessType3644$Enum {
        payments: 1;
        openItems: 2;
        both: 3;
    }
    export type ProcessType3644 = keyof ProcessType3644$Enum;
    export interface ProcessedRecordsSelection$Enum {
        process: 1;
        doNotProcess: 2;
        all: 3;
    }
    export type ProcessedRecordsSelection = keyof ProcessedRecordsSelection$Enum;
    export interface ProrataType$Enum {
        e: 1;
        g: 2;
    }
    export type ProrataType = keyof ProrataType$Enum;
    export interface ReasonForAction$Enum {
        creation: 1;
        modification: 2;
        deletion: 3;
        closing: 4;
        reversal: 5;
        closingCancellation: 6;
        carryforward: 7;
        resynchronization: 8;
    }
    export type ReasonForAction = keyof ReasonForAction$Enum;
    export interface ReceiptCommunicationStatus$Enum {
        entered: 1;
        printed: 2;
        communicated: 3;
    }
    export type ReceiptCommunicationStatus = keyof ReceiptCommunicationStatus$Enum;
    export interface ReceiptStatus$Enum {
        normalReceipt: 1;
        receiptCanceled: 2;
    }
    export type ReceiptStatus = keyof ReceiptStatus$Enum;
    export interface RecordType2652$Enum {
        enteredLine: 1;
        extractedLine: 2;
    }
    export type RecordType2652 = keyof RecordType2652$Enum;
    export interface RecurringJournalType$Enum {
        fixed: 1;
        variable: 2;
    }
    export type RecurringJournalType = keyof RecurringJournalType$Enum;
    export interface RenewalType$Enum {
        normal: 1;
        commitmentCarriedForward: 2;
    }
    export type RenewalType = keyof RenewalType$Enum;
    export interface ReportTypeVatReporting$Enum {
        vatDeclaration: 1;
        recapitulativeStatement: 2;
    }
    export type ReportTypeVatReporting = keyof ReportTypeVatReporting$Enum;
    export interface ReportingCodeSort$Enum {
        byAccountRoot: 1;
        debitCode: 2;
        creditCode: 3;
    }
    export type ReportingCodeSort = keyof ReportingCodeSort$Enum;
    export interface ReportingPeriod$Enum {
        monthly: 1;
        quarterly: 2;
    }
    export type ReportingPeriod = keyof ReportingPeriod$Enum;
    export interface ReportingStatus$Enum {
        inReview: 1;
        validated: 2;
        closed: 3;
    }
    export type ReportingStatus = keyof ReportingStatus$Enum;
    export interface RestrictionType$Enum {
        dimensionDimensionRestriction: 1;
        accountDimensionRestriction: 2;
        accountAccountRestriction: 3;
    }
    export type RestrictionType = keyof RestrictionType$Enum;
    export interface ResynchronizationType$Enum {
        balanceVerification: 1;
        glVerification: 2;
        resynchronization: 3;
    }
    export type ResynchronizationType = keyof ResynchronizationType$Enum;
    export interface RevenueRecognitionColTypes$Enum {
        estRevenueAtCompletion: 1;
        actualRevenue: 2;
        actualCosts: 3;
        estCostAtCompletion: 4;
        projectMarginPercentage: 5;
        percentageOfCompletionInitial: 6;
        percentageOfCompletion: 7;
        grossRecognizedRevenue: 8;
        netRecognizedRevenueInitial: 9;
        netRecognizedRevenue: 10;
        grossRecognizedCost: 11;
        netRecognizedCostInitial: 12;
        netRecognizedCost: 13;
        freeColumnType: 14;
        invoicesToBeIssued: 15;
        salesAccruals: 16;
        invoicesToBeReceived: 17;
        costAccruals: 18;
    }
    export type RevenueRecognitionColTypes = keyof RevenueRecognitionColTypes$Enum;
    export interface RevenueRecognitionMethod$Enum {
        notApplicable: 1;
        manualPercentageEntry: 2;
        percentageOfCostsWithEstimatedMarginAtCompletion: 3;
        percentageOfCostsWithoutEstimatedMarginAtCompletion: 4;
    }
    export type RevenueRecognitionMethod = keyof RevenueRecognitionMethod$Enum;
    export interface RevenueRecognitionValidation$Enum {
        toBeProcessed: 1;
        awaitingValidation: 2;
        validated: 3;
        posted: 4;
        postingSimulation: 5;
    }
    export type RevenueRecognitionValidation = keyof RevenueRecognitionValidation$Enum;
    export interface RevenueRecognitonType$Enum {
        project: 1;
        dimension: 2;
    }
    export type RevenueRecognitonType = keyof RevenueRecognitonType$Enum;
    export interface ReverseCode$Enum {
        no: 1;
        yes: 2;
        reversed: 3;
    }
    export type ReverseCode = keyof ReverseCode$Enum;
    export interface ReviewProcessing$Enum {
        none: 1;
        review: 2;
        reject: 3;
    }
    export type ReviewProcessing = keyof ReviewProcessing$Enum;
    export interface ReviewStatus$Enum {
        rejected: 1;
        requested: 2;
        approved: 3;
        cancelled: 4;
    }
    export type ReviewStatus = keyof ReviewStatus$Enum;
    export interface Sage50ImportTranscribe$Enum {
        site: 1;
        account: 2;
        employeeDimension: 3;
        costCentreDimension: 4;
        departmentDimension: 5;
        aCCodeDimension: 6;
    }
    export type Sage50ImportTranscribe = keyof Sage50ImportTranscribe$Enum;
    export interface SenseOfBalance$Enum {
        debitCredit: 1;
        creditDebit: 2;
    }
    export type SenseOfBalance = keyof SenseOfBalance$Enum;
    export interface SignByDefault$Enum {
        debit: 1;
        credit: 2;
        unspecified: 3;
    }
    export type SignByDefault = keyof SignByDefault$Enum;
    export interface SignType$Enum {
        debitCredit: 1;
        negativeAmount: 2;
    }
    export type SignType = keyof SignType$Enum;
    export interface SimulationScreenDisplay$Enum {
        no: 1;
        yesAlways: 2;
        yesIfError: 3;
    }
    export type SimulationScreenDisplay = keyof SimulationScreenDisplay$Enum;
    export interface SingleMulti$Enum {
        mono: 1;
        multi: 2;
    }
    export type SingleMulti = keyof SingleMulti$Enum;
    export interface SiteCompany$Enum {
        site: 1;
        company: 2;
    }
    export type SiteCompany = keyof SiteCompany$Enum;
    export interface Sort2640$Enum {
        dimensionsAccounts: 1;
        accountsDimensions: 2;
    }
    export type Sort2640 = keyof Sort2640$Enum;
    export interface SortCriteria$Enum {
        date: 1;
        match: 2;
        dueDate: 3;
    }
    export type SortCriteria = keyof SortCriteria$Enum;
    export interface SortCriterionDueDates$Enum {
        dueDate: 1;
        businessPartners: 2;
        bpName: 3;
        invoiceNumber: 4;
    }
    export type SortCriterionDueDates = keyof SortCriterionDueDates$Enum;
    export interface SortEngagenat$Enum {
        date: 1;
        dim1: 2;
        dim2: 3;
        dim3: 4;
        dim4: 5;
        dim5: 6;
        dim6: 7;
        dim7: 8;
        dim8: 9;
        dim9: 10;
        businessPartner: 11;
    }
    export type SortEngagenat = keyof SortEngagenat$Enum;
    export interface SortEngagesec$Enum {
        date: 1;
        dim1: 2;
        dim2: 3;
        dim3: 4;
        dim4: 5;
        dim5: 6;
        dim6: 7;
        dim7: 8;
        dim8: 9;
        dim9: 10;
        businessPartner: 11;
        account: 12;
    }
    export type SortEngagesec = keyof SortEngagesec$Enum;
    export interface SortOpenItems2605$Enum {
        dueDate: 1;
        accountingDocumentDate: 2;
    }
    export type SortOpenItems2605 = keyof SortOpenItems2605$Enum;
    export interface SortOrder2608$Enum {
        date: 1;
        nature: 2;
        dimension: 3;
    }
    export type SortOrder2608 = keyof SortOrder2608$Enum;
    export interface SortSequence$Enum {
        ascending: 1;
        descending: 2;
    }
    export type SortSequence = keyof SortSequence$Enum;
    export interface Sort$Enum {
        date: 1;
        account: 2;
        dimension: 3;
    }
    export type Sort = keyof Sort$Enum;
    export interface SourceDocumentType$Enum {
        order: 1;
        deliveryRequest: 2;
        purchaseRequest: 3;
        direct: 4;
    }
    export type SourceDocumentType = keyof SourceDocumentType$Enum;
    export interface SpanishSetupValues$Enum {
        company: 1;
        site: 2;
        date: 3;
        employee: 4;
        description: 5;
        currency: 6;
        dimension1: 7;
        dimension2: 8;
        dimension3: 9;
        dimension4: 10;
        dimension5: 11;
    }
    export type SpanishSetupValues = keyof SpanishSetupValues$Enum;
    export interface Status880$Enum {
        inProgress: 1;
        validated: 2;
        submitted: 3;
        rejected: 4;
        completed: 5;
    }
    export type Status880 = keyof Status880$Enum;
    export interface SubmissionModeForRecapSt$Enum {
        noChangeInSubmissionMode: 1;
        submissionOfMonthlyReportsAccordingTo18AAbs1UStG: 2;
        withdrawalOfMonthlyReportsAccordingTo18AAbs1UStG: 3;
    }
    export type SubmissionModeForRecapSt = keyof SubmissionModeForRecapSt$Enum;
    export interface SubmitterVatDeclarationGer$Enum {
        legalEntity: 1;
    }
    export type SubmitterVatDeclarationGer = keyof SubmitterVatDeclarationGer$Enum;
    export interface SupplierAgedBalanceField$Enum {
        lastRfq: 1;
        lastOrder: 2;
        lastReceipt: 3;
        lastInvoice: 4;
        lastPayment: 5;
    }
    export type SupplierAgedBalanceField = keyof SupplierAgedBalanceField$Enum;
    export interface SupplierCustomerDocument$Enum {
        customerInvoices: 1;
        supplierInvoices: 2;
    }
    export type SupplierCustomerDocument = keyof SupplierCustomerDocument$Enum;
    export interface SwissVatCodes$Enum {
        substituteValue1: 1;
        substituteValue2: 2;
        substituteValue3: 3;
        substituteValue4: 4;
        substituteValue5: 5;
        substituteValue6: 6;
        substituteValue7: 7;
        substituteValue8: 8;
        substituteValue9: 9;
        substituteValue10: 10;
        substituteValue11: 11;
        substituteValue12: 12;
        substituteValue13: 13;
        substituteValue14: 14;
        substituteValue15: 15;
        substituteValue16: 16;
        substituteValue17: 17;
        substituteValue18: 18;
        substituteValue19: 19;
        substituteValue20: 20;
        substituteValue21: 21;
        substituteValue22: 22;
        substituteValue23: 23;
        substituteValue24: 24;
        substituteValue25: 25;
        substituteValue26: 26;
        substituteValue27: 27;
    }
    export type SwissVatCodes = keyof SwissVatCodes$Enum;
    export interface TableList$Enum {
        accountingEntries: 1;
        analyticalAccounting: 2;
        estimations: 3;
    }
    export type TableList = keyof TableList$Enum;
    export interface TaxAllocation$Enum {
        collectedSales: 1;
        collectedFixedAssets: 2;
        deductiblePurchases: 3;
        deductibleFixedAssets: 4;
        deductibleGS: 5;
        stateRules: 6;
        companyRules: 7;
        collectedGS: 8;
    }
    export type TaxAllocation = keyof TaxAllocation$Enum;
    export interface TaxCodeControl3684$Enum {
        inactive: 1;
        authorization: 2;
        restriction: 3;
    }
    export type TaxCodeControl3684 = keyof TaxCodeControl3684$Enum;
    export interface TaxCreditToRecover$Enum {
        none: 1;
        requestReimbursement: 2;
        carryForwardExcess: 3;
    }
    export type TaxCreditToRecover = keyof TaxCreditToRecover$Enum;
    export interface TaxTypeSelection$Enum {
        collected: 1;
        deductible: 2;
        all: 3;
    }
    export type TaxTypeSelection = keyof TaxTypeSelection$Enum;
    export interface TaxpayerNumber$Enum {
        employerIdentificationNumber: 1;
        socialSecurityNumber: 2;
    }
    export type TaxpayerNumber = keyof TaxpayerNumber$Enum;
    export interface TdbSort2634$Enum {
        none: 1;
        site: 2;
        account: 3;
        dimension: 4;
    }
    export type TdbSort2634 = keyof TdbSort2634$Enum;
    export interface TdbSort$Enum {
        none: 1;
        site: 2;
        account: 3;
        bPs: 4;
        fixedAssets: 5;
    }
    export type TdbSort = keyof TdbSort$Enum;
    export interface TdsFileType$Enum {
        tds: 1;
        tds2: 2;
    }
    export type TdsFileType = keyof TdsFileType$Enum;
    export interface TdsRecordType$Enum {
        startFlag: 1;
        companyHeader: 2;
        siteHeader: 3;
        feeLines: 4;
        declarationSiteTotal: 5;
        companyTotal: 6;
        endFlag: 7;
    }
    export type TdsRecordType = keyof TdsRecordType$Enum;
    export interface Title2607$Enum {
        mr: 1;
        mrs: 2;
        ms: 3;
    }
    export type Title2607 = keyof Title2607$Enum;
    export interface TransferBasis$Enum {
        inAmountsByPeriods: 1;
        inAnnualAmounts: 2;
    }
    export type TransferBasis = keyof TransferBasis$Enum;
    export interface TreasInterface2672$Enum {
        cpta: 1;
        cdc: 2;
        descr: 3;
        codrif: 4;
        nass: 5;
    }
    export type TreasInterface2672 = keyof TreasInterface2672$Enum;
    export interface TreasInterface$Enum {
        cpta: 1;
        cdc: 2;
        descr: 3;
        codrif: 4;
        dope: 5;
        nass: 6;
    }
    export type TreasInterface = keyof TreasInterface$Enum;
    export interface TreasuryOpenItemsSfrpt$Enum {
        descr: 1;
        dope: 2;
        refxrt: 3;
    }
    export type TreasuryOpenItemsSfrpt = keyof TreasuryOpenItemsSfrpt$Enum;
    export interface TreasuryPaymentsSfrpt$Enum {
        descr: 1;
        refxrt: 2;
    }
    export type TreasuryPaymentsSfrpt = keyof TreasuryPaymentsSfrpt$Enum;
    export interface TriggeringConditions$Enum {
        no: 1;
        always: 2;
        confirmation: 3;
    }
    export type TriggeringConditions = keyof TriggeringConditions$Enum;
    export interface TypeOfEconomicReason$Enum {
        notUsed: 1;
        service: 2;
        capitalFlow: 3;
        transitTrade: 4;
    }
    export type TypeOfEconomicReason = keyof TypeOfEconomicReason$Enum;
    export interface TypeOfExtraction$Enum {
        accountRoot: 1;
        accountList: 2;
    }
    export type TypeOfExtraction = keyof TypeOfExtraction$Enum;
    export interface TypeOfRule$Enum {
        normal: 1;
        export: 2;
        taxExempt: 3;
        eu: 4;
    }
    export type TypeOfRule = keyof TypeOfRule$Enum;
    export interface TypeOfSalesPortugal$Enum {
        goods: 1;
        fixedAssets: 2;
        services: 3;
    }
    export type TypeOfSalesPortugal = keyof TypeOfSalesPortugal$Enum;
    export interface VarianceType611$Enum {
        notManaged: 1;
        balanceSheet: 2;
        profitAndLoss: 3;
    }
    export type VarianceType611 = keyof VarianceType611$Enum;
    export interface VatAdjustmentLevel$Enum {
        companyLevel: 1;
        entityLevel: 2;
    }
    export type VatAdjustmentLevel = keyof VatAdjustmentLevel$Enum;
    export interface VatBoxType$Enum {
        title: 1;
        detail: 2;
        total: 3;
        offDeclaration: 4;
    }
    export type VatBoxType = keyof VatBoxType$Enum;
    export interface VatDeclarationDate$Enum {
        accountingDate: 1;
        documentDate: 2;
    }
    export type VatDeclarationDate = keyof VatDeclarationDate$Enum;
    export interface VatDeclarationRecordType$Enum {
        normal: 1;
        unmatching: 2;
        prepayment: 3;
    }
    export type VatDeclarationRecordType = keyof VatDeclarationRecordType$Enum;
    export interface VatDeclarationType$Enum {
        periodic: 1;
        annual: 2;
        recapitulative: 3;
        europeanServices: 4;
    }
    export type VatDeclarationType = keyof VatDeclarationType$Enum;
    export interface VatEntity$Enum {
        issueOperationCollectedTaxAmount: 1;
        taxesDueCollectedVat: 2;
        receiptOperationsDeductibleTaxAmount: 3;
        deductibleTaxesDeductibleVat: 4;
    }
    export type VatEntity = keyof VatEntity$Enum;
    export interface VatManagement658$Enum {
        no: 1;
        prepayment: 2;
        taxRecovery: 3;
        taxCharges: 4;
    }
    export type VatManagement658 = keyof VatManagement658$Enum;
    export interface VatManagement$Enum {
        notSubjected: 1;
        subjected: 2;
        taxAccount: 3;
        euTax: 4;
        prepaymentAccount: 5;
    }
    export type VatManagement = keyof VatManagement$Enum;
    export interface VatOptionsForShipments$Enum {
        vatDebitAllocatedFirst: 1;
        proRata: 2;
    }
    export type VatOptionsForShipments = keyof VatOptionsForShipments$Enum;
    export interface VatReturnReporting$Enum {
        basis: 1;
        amount: 2;
        both: 3;
    }
    export type VatReturnReporting = keyof VatReturnReporting$Enum;
    export interface VatReturnType$Enum {
        monthly: 1;
        quarterly: 2;
        yearly: 3;
    }
    export type VatReturnType = keyof VatReturnType$Enum;
    export interface VatStatementPeriodicity$Enum {
        month: 1;
        quarter: 2;
        year: 3;
    }
    export type VatStatementPeriodicity = keyof VatStatementPeriodicity$Enum;
    export interface VatSubmissionEnvironment$Enum {
        test: 1;
        preProduction: 2;
        production: 3;
        notDefined: 4;
    }
    export type VatSubmissionEnvironment = keyof VatSubmissionEnvironment$Enum;
    export interface VatpayfcyParameter$Enum {
        blocking: 1;
        warning: 2;
    }
    export type VatpayfcyParameter = keyof VatpayfcyParameter$Enum;
    export interface VersionStatus2669$Enum {
        open: 1;
        closed: 2;
    }
    export type VersionStatus2669 = keyof VersionStatus2669$Enum;
    export interface WithholdingCalculationBasis$Enum {
        excludeTaxAmount: 1;
        taxIncludedAmount: 2;
        monthlyTotal: 3;
    }
    export type WithholdingCalculationBasis = keyof WithholdingCalculationBasis$Enum;
    export interface WithholdingThresholdBase$Enum {
        byDocument: 1;
        globalPaymentOrder: 2;
        taxableCorrectedBasis: 3;
    }
    export type WithholdingThresholdBase = keyof WithholdingThresholdBase$Enum;
    export interface YnWarn$Enum {
        no: 1;
        yes: 2;
        inform: 3;
    }
    export type YnWarn = keyof YnWarn$Enum;
    export interface AccountScheme extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        localizedDescription: string;
        localizedShortDescription: string;
    }
    export interface AccountSchemeInput extends ClientNodeInput {
        code?: string;
        localizedDescription?: string;
        localizedShortDescription?: string;
    }
    export interface AccountSchemeBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        localizedDescription: string;
        localizedShortDescription: string;
    }
    export interface AccountScheme$Operations {
        query: QueryOperation<AccountScheme>;
        read: ReadOperation<AccountScheme>;
        aggregate: {
            read: AggregateReadOperation<AccountScheme>;
            query: AggregateQueryOperation<AccountScheme>;
        };
        getDefaults: GetDefaultsOperation<AccountScheme>;
    }
    export interface Account extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        chartOfAccounts: ChartOfAccounts;
        code: string;
        localizedDescription: string;
        localizedShortDescription: string;
    }
    export interface AccountInput extends ClientNodeInput {
        chartOfAccounts?: string;
        code?: string;
        localizedDescription?: string;
        localizedShortDescription?: string;
    }
    export interface AccountBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        chartOfAccounts: ChartOfAccounts;
        code: string;
        localizedDescription: string;
        localizedShortDescription: string;
    }
    export interface Account$Lookups {
        chartOfAccounts: QueryOperation<ChartOfAccounts>;
    }
    export interface Account$Operations {
        query: QueryOperation<Account>;
        read: ReadOperation<Account>;
        aggregate: {
            read: AggregateReadOperation<Account>;
            query: AggregateQueryOperation<Account>;
        };
        lookups(dataOrId: string | { data: AccountInput }): Account$Lookups;
        getDefaults: GetDefaultsOperation<Account>;
    }
    export interface AccountingCode extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        type: AccountingCodeType;
        accountingCode: string;
        chartOfAccounts: ChartOfAccounts;
        localizedDescription: string;
        localizedShortDescription: string;
    }
    export interface AccountingCodeInput extends ClientNodeInput {
        type?: AccountingCodeType;
        accountingCode?: string;
        chartOfAccounts?: string;
        localizedDescription?: string;
        localizedShortDescription?: string;
    }
    export interface AccountingCodeBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        type: AccountingCodeType;
        accountingCode: string;
        chartOfAccounts: ChartOfAccounts;
        localizedDescription: string;
        localizedShortDescription: string;
    }
    export interface AccountingCode$Lookups {
        chartOfAccounts: QueryOperation<ChartOfAccounts>;
    }
    export interface AccountingCode$Operations {
        query: QueryOperation<AccountingCode>;
        read: ReadOperation<AccountingCode>;
        aggregate: {
            read: AggregateReadOperation<AccountingCode>;
            query: AggregateQueryOperation<AccountingCode>;
        };
        lookups(dataOrId: string | { data: AccountingCodeInput }): AccountingCode$Lookups;
        getDefaults: GetDefaultsOperation<AccountingCode>;
    }
    export interface AutomaticJournal extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        description: string;
        shortDescription: string;
    }
    export interface AutomaticJournalInput extends ClientNodeInput {
        code?: string;
        description?: string;
        shortDescription?: string;
    }
    export interface AutomaticJournalBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        description: string;
        shortDescription: string;
    }
    export interface AutomaticJournal$Operations {
        query: QueryOperation<AutomaticJournal>;
        read: ReadOperation<AutomaticJournal>;
        aggregate: {
            read: AggregateReadOperation<AutomaticJournal>;
            query: AggregateQueryOperation<AutomaticJournal>;
        };
        getDefaults: GetDefaultsOperation<AutomaticJournal>;
    }
    export interface BankAccount extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        bank: string;
        description: string;
        shortDescription: string;
    }
    export interface BankAccountInput extends ClientNodeInput {
        bank?: string;
        description?: string;
        shortDescription?: string;
    }
    export interface BankAccountBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        bank: string;
        description: string;
        shortDescription: string;
    }
    export interface BankAccount$Operations {
        query: QueryOperation<BankAccount>;
        read: ReadOperation<BankAccount>;
        aggregate: {
            read: AggregateReadOperation<BankAccount>;
            query: AggregateQueryOperation<BankAccount>;
        };
        getDefaults: GetDefaultsOperation<BankAccount>;
    }
    export interface BillOfLanding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        site: Site;
    }
    export interface BillOfLandingInput extends ClientNodeInput {
        code?: string;
        site?: string;
    }
    export interface BillOfLandingBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        site: Site;
    }
    export interface BillOfLanding$Lookups {
        site: QueryOperation<Site>;
    }
    export interface BillOfLanding$Operations {
        query: QueryOperation<BillOfLanding>;
        read: ReadOperation<BillOfLanding>;
        aggregate: {
            read: AggregateReadOperation<BillOfLanding>;
            query: AggregateQueryOperation<BillOfLanding>;
        };
        lookups(dataOrId: string | { data: BillOfLandingInput }): BillOfLanding$Lookups;
        getDefaults: GetDefaultsOperation<BillOfLanding>;
    }
    export interface ChartOfAccounts extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        localizedDescription: string;
        localizedShortDescription: string;
    }
    export interface ChartOfAccountsInput extends ClientNodeInput {
        code?: string;
        localizedDescription?: string;
        localizedShortDescription?: string;
    }
    export interface ChartOfAccountsBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        localizedDescription: string;
        localizedShortDescription: string;
    }
    export interface ChartOfAccounts$Operations {
        query: QueryOperation<ChartOfAccounts>;
        read: ReadOperation<ChartOfAccounts>;
        aggregate: {
            read: AggregateReadOperation<ChartOfAccounts>;
            query: AggregateQueryOperation<ChartOfAccounts>;
        };
        getDefaults: GetDefaultsOperation<ChartOfAccounts>;
    }
    export interface CostTypeDimensions extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        code: string;
        dimensionType: DimensionType;
        dimension: Dimension;
    }
    export interface CostTypeDimensionsInput extends VitalClientNodeInput {
        denormalizedIndex?: integer | string;
        code?: string;
        dimensionType?: string;
        dimension?: string;
    }
    export interface CostTypeDimensionsBinding extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        code: string;
        dimensionType: DimensionType;
        dimension: Dimension;
    }
    export interface CostTypeDimensions$Lookups {
        dimensionType: QueryOperation<DimensionType>;
        dimension: QueryOperation<Dimension>;
    }
    export interface CostTypeDimensions$Operations {
        query: QueryOperation<CostTypeDimensions>;
        read: ReadOperation<CostTypeDimensions>;
        aggregate: {
            read: AggregateReadOperation<CostTypeDimensions>;
            query: AggregateQueryOperation<CostTypeDimensions>;
        };
        lookups(dataOrId: string | { data: CostTypeDimensionsInput }): CostTypeDimensions$Lookups;
        getDefaults: GetDefaultsOperation<CostTypeDimensions>;
    }
    export interface CustomerDimensions extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        code: string;
        dimensionType: DimensionType;
        dimension: Dimension;
    }
    export interface CustomerDimensionsInput extends VitalClientNodeInput {
        denormalizedIndex?: integer | string;
        code?: string;
        dimensionType?: string;
        dimension?: string;
    }
    export interface CustomerDimensionsBinding extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        code: string;
        dimensionType: DimensionType;
        dimension: Dimension;
    }
    export interface CustomerDimensions$Lookups {
        dimensionType: QueryOperation<DimensionType>;
        dimension: QueryOperation<Dimension>;
    }
    export interface CustomerDimensions$Operations {
        query: QueryOperation<CustomerDimensions>;
        read: ReadOperation<CustomerDimensions>;
        aggregate: {
            read: AggregateReadOperation<CustomerDimensions>;
            query: AggregateQueryOperation<CustomerDimensions>;
        };
        lookups(dataOrId: string | { data: CustomerDimensionsInput }): CustomerDimensions$Lookups;
        getDefaults: GetDefaultsOperation<CustomerDimensions>;
    }
    export interface CustomerInvoiceHeaderCurrencyRates extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        id: string;
        ledger: Ledger;
        ledgerCurrency: Currency;
        multiplyingRate: string;
        dividingRate: string;
    }
    export interface CustomerInvoiceHeaderCurrencyRatesInput extends VitalClientNodeInput {
        denormalizedIndex?: integer | string;
        id?: string;
        ledger?: string;
        ledgerCurrency?: string;
        multiplyingRate?: decimal | string;
        dividingRate?: decimal | string;
    }
    export interface CustomerInvoiceHeaderCurrencyRatesBinding extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        id: string;
        ledger: Ledger;
        ledgerCurrency: Currency;
        multiplyingRate: string;
        dividingRate: string;
    }
    export interface CustomerInvoiceHeaderCurrencyRates$Lookups {
        ledger: QueryOperation<Ledger>;
        ledgerCurrency: QueryOperation<Currency>;
    }
    export interface CustomerInvoiceHeaderCurrencyRates$Operations {
        query: QueryOperation<CustomerInvoiceHeaderCurrencyRates>;
        read: ReadOperation<CustomerInvoiceHeaderCurrencyRates>;
        aggregate: {
            read: AggregateReadOperation<CustomerInvoiceHeaderCurrencyRates>;
            query: AggregateQueryOperation<CustomerInvoiceHeaderCurrencyRates>;
        };
        lookups(
            dataOrId: string | { data: CustomerInvoiceHeaderCurrencyRatesInput },
        ): CustomerInvoiceHeaderCurrencyRates$Lookups;
        getDefaults: GetDefaultsOperation<CustomerInvoiceHeaderCurrencyRates>;
    }
    export interface CustomerInvoiceHeaderDimensions extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        id: string;
        dimensionType: DimensionType;
        dimension: Dimension;
    }
    export interface CustomerInvoiceHeaderDimensionsInput extends VitalClientNodeInput {
        denormalizedIndex?: integer | string;
        id?: string;
        dimensionType?: string;
        dimension?: string;
    }
    export interface CustomerInvoiceHeaderDimensionsBinding extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        id: string;
        dimensionType: DimensionType;
        dimension: Dimension;
    }
    export interface CustomerInvoiceHeaderDimensions$Lookups {
        dimensionType: QueryOperation<DimensionType>;
        dimension: QueryOperation<Dimension>;
    }
    export interface CustomerInvoiceHeaderDimensions$Operations {
        query: QueryOperation<CustomerInvoiceHeaderDimensions>;
        read: ReadOperation<CustomerInvoiceHeaderDimensions>;
        aggregate: {
            read: AggregateReadOperation<CustomerInvoiceHeaderDimensions>;
            query: AggregateQueryOperation<CustomerInvoiceHeaderDimensions>;
        };
        lookups(
            dataOrId: string | { data: CustomerInvoiceHeaderDimensionsInput },
        ): CustomerInvoiceHeaderDimensions$Lookups;
        getDefaults: GetDefaultsOperation<CustomerInvoiceHeaderDimensions>;
    }
    export interface DimensionType extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        dimensionType: string;
        localizedDescription: string;
        localizedShortDescription: string;
    }
    export interface DimensionTypeInput extends ClientNodeInput {
        dimensionType?: string;
        localizedDescription?: string;
        localizedShortDescription?: string;
    }
    export interface DimensionTypeBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        dimensionType: string;
        localizedDescription: string;
        localizedShortDescription: string;
    }
    export interface DimensionType$Operations {
        query: QueryOperation<DimensionType>;
        read: ReadOperation<DimensionType>;
        aggregate: {
            read: AggregateReadOperation<DimensionType>;
            query: AggregateQueryOperation<DimensionType>;
        };
        getDefaults: GetDefaultsOperation<DimensionType>;
    }
    export interface Dimension extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        dimensionType: DimensionType;
        dimension: string;
        localizedDescription: string;
        localizedShortDescription: string;
    }
    export interface DimensionInput extends ClientNodeInput {
        dimensionType?: string;
        dimension?: string;
        localizedDescription?: string;
        localizedShortDescription?: string;
    }
    export interface DimensionBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        dimensionType: DimensionType;
        dimension: string;
        localizedDescription: string;
        localizedShortDescription: string;
    }
    export interface Dimension$Lookups {
        dimensionType: QueryOperation<DimensionType>;
    }
    export interface Dimension$Operations {
        query: QueryOperation<Dimension>;
        read: ReadOperation<Dimension>;
        aggregate: {
            read: AggregateReadOperation<Dimension>;
            query: AggregateQueryOperation<Dimension>;
        };
        lookups(dataOrId: string | { data: DimensionInput }): Dimension$Lookups;
        getDefaults: GetDefaultsOperation<Dimension>;
    }
    export interface DistributionKey extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        numberOfLines: integer;
        localizedDescription: string;
        localizedShortDescription: string;
    }
    export interface DistributionKeyInput extends ClientNodeInput {
        code?: string;
        numberOfLines?: integer | string;
        localizedDescription?: string;
        localizedShortDescription?: string;
    }
    export interface DistributionKeyBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        numberOfLines: integer;
        localizedDescription: string;
        localizedShortDescription: string;
    }
    export interface DistributionKey$Operations {
        query: QueryOperation<DistributionKey>;
        read: ReadOperation<DistributionKey>;
        aggregate: {
            read: AggregateReadOperation<DistributionKey>;
            query: AggregateQueryOperation<DistributionKey>;
        };
        getDefaults: GetDefaultsOperation<DistributionKey>;
    }
    export interface EntryType extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        legislation: MiscellaneousTable;
        localizedDescription: string;
        localizedShortDescription: string;
    }
    export interface EntryTypeInput extends ClientNodeInput {
        code?: string;
        legislation?: string;
        localizedDescription?: string;
        localizedShortDescription?: string;
    }
    export interface EntryTypeBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        legislation: MiscellaneousTable;
        localizedDescription: string;
        localizedShortDescription: string;
    }
    export interface EntryType$Lookups {
        legislation: QueryOperation<MiscellaneousTable>;
    }
    export interface EntryType$Operations {
        query: QueryOperation<EntryType>;
        read: ReadOperation<EntryType>;
        aggregate: {
            read: AggregateReadOperation<EntryType>;
            query: AggregateQueryOperation<EntryType>;
        };
        lookups(dataOrId: string | { data: EntryTypeInput }): EntryType$Lookups;
        getDefaults: GetDefaultsOperation<EntryType>;
    }
    export interface Factor extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        companyName: string;
    }
    export interface FactorInput extends ClientNodeInput {
        code?: string;
        companyName?: string;
    }
    export interface FactorBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        companyName: string;
    }
    export interface Factor$Operations {
        query: QueryOperation<Factor>;
        read: ReadOperation<Factor>;
        aggregate: {
            read: AggregateReadOperation<Factor>;
            query: AggregateQueryOperation<Factor>;
        };
        getDefaults: GetDefaultsOperation<Factor>;
    }
    export interface FiscalYear extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        company: Company;
        ledgerTypeNumber: GeneralLedgerTypes;
        code: integer;
        description: string;
        shortDescription: string;
        startDate: string;
        endDate: string;
        status: FiscalYearReport;
        closingDate: string;
        isAutoLedger: boolean;
        periods: ClientCollection<Period>;
    }
    export interface FiscalYearInput extends ClientNodeInput {
        company?: string;
        ledgerTypeNumber?: GeneralLedgerTypes;
        code?: integer | string;
        description?: string;
        shortDescription?: string;
        startDate?: string;
        endDate?: string;
        status?: FiscalYearReport;
        closingDate?: string;
        isAutoLedger?: boolean | string;
        periods?: Partial<PeriodInput>[];
    }
    export interface FiscalYearBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        company: Company;
        ledgerTypeNumber: GeneralLedgerTypes;
        code: integer;
        description: string;
        shortDescription: string;
        startDate: string;
        endDate: string;
        status: FiscalYearReport;
        closingDate: string;
        isAutoLedger: boolean;
        periods: ClientCollection<Period>;
    }
    export interface FiscalYear$Lookups {
        company: QueryOperation<Company>;
    }
    export interface FiscalYear$Operations {
        query: QueryOperation<FiscalYear>;
        read: ReadOperation<FiscalYear>;
        aggregate: {
            read: AggregateReadOperation<FiscalYear>;
            query: AggregateQueryOperation<FiscalYear>;
        };
        lookups(dataOrId: string | { data: FiscalYearInput }): FiscalYear$Lookups;
        getDefaults: GetDefaultsOperation<FiscalYear>;
    }
    export interface JournalEntryTransaction extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        localizedDescription: string;
        localizedShortDescription: string;
    }
    export interface JournalEntryTransactionInput extends ClientNodeInput {
        code?: string;
        localizedDescription?: string;
        localizedShortDescription?: string;
    }
    export interface JournalEntryTransactionBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        localizedDescription: string;
        localizedShortDescription: string;
    }
    export interface JournalEntryTransaction$Operations {
        query: QueryOperation<JournalEntryTransaction>;
        read: ReadOperation<JournalEntryTransaction>;
        aggregate: {
            read: AggregateReadOperation<JournalEntryTransaction>;
            query: AggregateQueryOperation<JournalEntryTransaction>;
        };
        getDefaults: GetDefaultsOperation<JournalEntryTransaction>;
    }
    export interface Journal extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        legislation: MiscellaneousTable;
        localizedDescription: string;
        localizedShortDescription: string;
    }
    export interface JournalInput extends ClientNodeInput {
        code?: string;
        legislation?: string;
        localizedDescription?: string;
        localizedShortDescription?: string;
    }
    export interface JournalBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        legislation: MiscellaneousTable;
        localizedDescription: string;
        localizedShortDescription: string;
    }
    export interface Journal$Lookups {
        legislation: QueryOperation<MiscellaneousTable>;
    }
    export interface Journal$Operations {
        query: QueryOperation<Journal>;
        read: ReadOperation<Journal>;
        aggregate: {
            read: AggregateReadOperation<Journal>;
            query: AggregateQueryOperation<Journal>;
        };
        lookups(dataOrId: string | { data: JournalInput }): Journal$Lookups;
        getDefaults: GetDefaultsOperation<Journal>;
    }
    export interface Ledger extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        localizedDescription: string;
        localizedShortDescription: string;
    }
    export interface LedgerInput extends ClientNodeInput {
        code?: string;
        localizedDescription?: string;
        localizedShortDescription?: string;
    }
    export interface LedgerBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        localizedDescription: string;
        localizedShortDescription: string;
    }
    export interface Ledger$Operations {
        query: QueryOperation<Ledger>;
        read: ReadOperation<Ledger>;
        aggregate: {
            read: AggregateReadOperation<Ledger>;
            query: AggregateQueryOperation<Ledger>;
        };
        getDefaults: GetDefaultsOperation<Ledger>;
    }
    export interface OpenItem extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        documentType: EntryType;
        documentNumber: string;
        lineNumber: integer;
        openItemLineNumber: integer;
        journalEntryLineInternalNumber: integer;
        company: Company;
        site: Site;
        currency: Currency;
        controlAccount: string;
        businessPartner: BusinessPartner;
        businessPartnerType: BusinessPartnerType;
        payToOrPayByBusinessPartner: BusinessPartner;
        dueDate: string;
        paymentMethod: PaymentMethod;
        paymentType: OpenItemType;
        earlyDiscountOrLateCharge: EarlyDiscountLateCharge;
        sign: integer;
        amountInCurrency: string;
        amountInCompanyCurrency: string;
        paidAmountInCurrency: string;
        paidAmountInCompanyCurrency: string;
        provisionalPaidAmountInCurrency: string;
        provisionalPaidAmountInCompanyCurrency: string;
        canBeReminded: boolean;
        reminderLevel: integer;
        reminderDate: string;
        dispute: MiscellaneousTable;
        paymentApprovalLevel: PaymentApprovalType;
        canBeIncludedInStatement: boolean;
        postedStatus: integer;
        deductedPrepaymentAmount: string;
        prepaymentAmountToDeduct: string;
        fiscalYear: integer;
        period: integer;
        prepaymentInvoiceIssueDate: string;
        isPrepaymentIssued: boolean;
        closedStatus: integer;
        paymentDate: string;
        uniqueNumber: string;
    }
    export interface OpenItemInput extends ClientNodeInput {
        documentType?: string;
        documentNumber?: string;
        lineNumber?: integer | string;
        openItemLineNumber?: integer | string;
        journalEntryLineInternalNumber?: integer | string;
        company?: string;
        site?: string;
        currency?: string;
        controlAccount?: string;
        businessPartner?: string;
        businessPartnerType?: BusinessPartnerType;
        payToOrPayByBusinessPartner?: string;
        dueDate?: string;
        paymentMethod?: string;
        paymentType?: OpenItemType;
        earlyDiscountOrLateCharge?: string;
        sign?: integer | string;
        amountInCurrency?: decimal | string;
        amountInCompanyCurrency?: decimal | string;
        paidAmountInCurrency?: decimal | string;
        paidAmountInCompanyCurrency?: decimal | string;
        provisionalPaidAmountInCurrency?: decimal | string;
        provisionalPaidAmountInCompanyCurrency?: decimal | string;
        canBeReminded?: boolean | string;
        reminderLevel?: integer | string;
        reminderDate?: string;
        dispute?: string;
        paymentApprovalLevel?: PaymentApprovalType;
        canBeIncludedInStatement?: boolean | string;
        postedStatus?: integer | string;
        deductedPrepaymentAmount?: decimal | string;
        prepaymentAmountToDeduct?: decimal | string;
        fiscalYear?: integer | string;
        period?: integer | string;
        prepaymentInvoiceIssueDate?: string;
        isPrepaymentIssued?: boolean | string;
        closedStatus?: integer | string;
        paymentDate?: string;
        uniqueNumber?: string;
    }
    export interface OpenItemBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        documentType: EntryType;
        documentNumber: string;
        lineNumber: integer;
        openItemLineNumber: integer;
        journalEntryLineInternalNumber: integer;
        company: Company;
        site: Site;
        currency: Currency;
        controlAccount: string;
        businessPartner: BusinessPartner;
        businessPartnerType: BusinessPartnerType;
        payToOrPayByBusinessPartner: BusinessPartner;
        dueDate: string;
        paymentMethod: PaymentMethod;
        paymentType: OpenItemType;
        earlyDiscountOrLateCharge: EarlyDiscountLateCharge;
        sign: integer;
        amountInCurrency: string;
        amountInCompanyCurrency: string;
        paidAmountInCurrency: string;
        paidAmountInCompanyCurrency: string;
        provisionalPaidAmountInCurrency: string;
        provisionalPaidAmountInCompanyCurrency: string;
        canBeReminded: boolean;
        reminderLevel: integer;
        reminderDate: string;
        dispute: MiscellaneousTable;
        paymentApprovalLevel: PaymentApprovalType;
        canBeIncludedInStatement: boolean;
        postedStatus: integer;
        deductedPrepaymentAmount: string;
        prepaymentAmountToDeduct: string;
        fiscalYear: integer;
        period: integer;
        prepaymentInvoiceIssueDate: string;
        isPrepaymentIssued: boolean;
        closedStatus: integer;
        paymentDate: string;
        uniqueNumber: string;
    }
    export interface OpenItem$Lookups {
        documentType: QueryOperation<EntryType>;
        company: QueryOperation<Company>;
        site: QueryOperation<Site>;
        currency: QueryOperation<Currency>;
        businessPartner: QueryOperation<BusinessPartner>;
        payToOrPayByBusinessPartner: QueryOperation<BusinessPartner>;
        paymentMethod: QueryOperation<PaymentMethod>;
        earlyDiscountOrLateCharge: QueryOperation<EarlyDiscountLateCharge>;
        dispute: QueryOperation<MiscellaneousTable>;
    }
    export interface OpenItem$Operations {
        query: QueryOperation<OpenItem>;
        read: ReadOperation<OpenItem>;
        aggregate: {
            read: AggregateReadOperation<OpenItem>;
            query: AggregateQueryOperation<OpenItem>;
        };
        lookups(dataOrId: string | { data: OpenItemInput }): OpenItem$Lookups;
        getDefaults: GetDefaultsOperation<OpenItem>;
    }
    export interface Period extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        company: Company;
        ledgerTypeNumber: GeneralLedgerTypes;
        fiscalYear: integer;
        code: integer;
        startDate: string;
        endDate: string;
        status: PeriodFiscalYearStatus;
        closingDate: string;
        isAutoLedger: boolean;
    }
    export interface PeriodInput extends ClientNodeInput {
        company?: string;
        ledgerTypeNumber?: GeneralLedgerTypes;
        fiscalYear?: integer | string;
        code?: integer | string;
        startDate?: string;
        endDate?: string;
        status?: PeriodFiscalYearStatus;
        closingDate?: string;
        isAutoLedger?: boolean | string;
    }
    export interface PeriodBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        company: Company;
        ledgerTypeNumber: GeneralLedgerTypes;
        fiscalYear: integer;
        code: integer;
        startDate: string;
        endDate: string;
        status: PeriodFiscalYearStatus;
        closingDate: string;
        isAutoLedger: boolean;
    }
    export interface Period$Lookups {
        company: QueryOperation<Company>;
    }
    export interface Period$Operations {
        query: QueryOperation<Period>;
        read: ReadOperation<Period>;
        aggregate: {
            read: AggregateReadOperation<Period>;
            query: AggregateQueryOperation<Period>;
        };
        lookups(dataOrId: string | { data: PeriodInput }): Period$Lookups;
        getDefaults: GetDefaultsOperation<Period>;
    }
    export interface ProductCategoryDimensions extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        stockSite: string;
        code: string;
        dimensionType: DimensionType;
        dimension: Dimension;
    }
    export interface ProductCategoryDimensionsInput extends VitalClientNodeInput {
        denormalizedIndex?: integer | string;
        stockSite?: string;
        code?: string;
        dimensionType?: string;
        dimension?: string;
    }
    export interface ProductCategoryDimensionsBinding extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        stockSite: string;
        code: string;
        dimensionType: DimensionType;
        dimension: Dimension;
    }
    export interface ProductCategoryDimensions$Lookups {
        dimensionType: QueryOperation<DimensionType>;
        dimension: QueryOperation<Dimension>;
    }
    export interface ProductCategoryDimensions$Operations {
        query: QueryOperation<ProductCategoryDimensions>;
        read: ReadOperation<ProductCategoryDimensions>;
        aggregate: {
            read: AggregateReadOperation<ProductCategoryDimensions>;
            query: AggregateQueryOperation<ProductCategoryDimensions>;
        };
        lookups(dataOrId: string | { data: ProductCategoryDimensionsInput }): ProductCategoryDimensions$Lookups;
        getDefaults: GetDefaultsOperation<ProductCategoryDimensions>;
    }
    export interface ProductDimensions extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        code: string;
        dimensionType: DimensionType;
        dimension: Dimension;
    }
    export interface ProductDimensionsInput extends VitalClientNodeInput {
        denormalizedIndex?: integer | string;
        code?: string;
        dimensionType?: string;
        dimension?: string;
    }
    export interface ProductDimensionsBinding extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        code: string;
        dimensionType: DimensionType;
        dimension: Dimension;
    }
    export interface ProductDimensions$Lookups {
        dimensionType: QueryOperation<DimensionType>;
        dimension: QueryOperation<Dimension>;
    }
    export interface ProductDimensions$Operations {
        query: QueryOperation<ProductDimensions>;
        read: ReadOperation<ProductDimensions>;
        aggregate: {
            read: AggregateReadOperation<ProductDimensions>;
            query: AggregateQueryOperation<ProductDimensions>;
        };
        lookups(dataOrId: string | { data: ProductDimensionsInput }): ProductDimensions$Lookups;
        getDefaults: GetDefaultsOperation<ProductDimensions>;
    }
    export interface ReminderGroup extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        localizedDescription: string;
        localizedShortDescription: string;
    }
    export interface ReminderGroupInput extends ClientNodeInput {
        code?: string;
        localizedDescription?: string;
        localizedShortDescription?: string;
    }
    export interface ReminderGroupBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        localizedDescription: string;
        localizedShortDescription: string;
    }
    export interface ReminderGroup$Operations {
        query: QueryOperation<ReminderGroup>;
        read: ReadOperation<ReminderGroup>;
        aggregate: {
            read: AggregateReadOperation<ReminderGroup>;
            query: AggregateQueryOperation<ReminderGroup>;
        };
        getDefaults: GetDefaultsOperation<ReminderGroup>;
    }
    export interface RevenueRecognitionRules extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        company: Company;
        code: string;
        project: ProjectLink;
        localizedDescription: string;
        ledger: GeneralLedgerTypes;
        ledgerType: MiscellaneousTable;
        access: Access;
        revenueRecognitionMethod: RevenueRecognitionMethod;
        isActive: boolean;
        revenueType: RevenueRecognitonType;
        dimensionType: string;
        analyticalDimension: string;
    }
    export interface RevenueRecognitionRulesInput extends ClientNodeInput {
        company?: string;
        code?: string;
        project?: string;
        localizedDescription?: string;
        ledger?: GeneralLedgerTypes;
        ledgerType?: string;
        access?: string;
        revenueRecognitionMethod?: RevenueRecognitionMethod;
        isActive?: boolean | string;
        revenueType?: RevenueRecognitonType;
        dimensionType?: string;
        analyticalDimension?: string;
    }
    export interface RevenueRecognitionRulesBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        company: Company;
        code: string;
        project: ProjectLink;
        localizedDescription: string;
        ledger: GeneralLedgerTypes;
        ledgerType: MiscellaneousTable;
        access: Access;
        revenueRecognitionMethod: RevenueRecognitionMethod;
        isActive: boolean;
        revenueType: RevenueRecognitonType;
        dimensionType: string;
        analyticalDimension: string;
    }
    export interface RevenueRecognitionRules$Lookups {
        company: QueryOperation<Company>;
        project: QueryOperation<ProjectLink>;
        ledgerType: QueryOperation<MiscellaneousTable>;
        access: QueryOperation<Access>;
    }
    export interface RevenueRecognitionRules$Operations {
        query: QueryOperation<RevenueRecognitionRules>;
        read: ReadOperation<RevenueRecognitionRules>;
        aggregate: {
            read: AggregateReadOperation<RevenueRecognitionRules>;
            query: AggregateQueryOperation<RevenueRecognitionRules>;
        };
        lookups(dataOrId: string | { data: RevenueRecognitionRulesInput }): RevenueRecognitionRules$Lookups;
        getDefaults: GetDefaultsOperation<RevenueRecognitionRules>;
    }
    export interface StockJournalDimensions extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        stockSite: string;
        isUpdated: boolean;
        product: string;
        effectiveDate: string;
        sequence: integer;
        index: integer;
        dimensionType: DimensionType;
        dimension: Dimension;
    }
    export interface StockJournalDimensionsInput extends VitalClientNodeInput {
        denormalizedIndex?: integer | string;
        stockSite?: string;
        isUpdated?: boolean | string;
        product?: string;
        effectiveDate?: string;
        sequence?: integer | string;
        index?: integer | string;
        dimensionType?: string;
        dimension?: string;
    }
    export interface StockJournalDimensionsBinding extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        stockSite: string;
        isUpdated: boolean;
        product: string;
        effectiveDate: string;
        sequence: integer;
        index: integer;
        dimensionType: DimensionType;
        dimension: Dimension;
    }
    export interface StockJournalDimensions$Lookups {
        dimensionType: QueryOperation<DimensionType>;
        dimension: QueryOperation<Dimension>;
    }
    export interface StockJournalDimensions$Operations {
        query: QueryOperation<StockJournalDimensions>;
        read: ReadOperation<StockJournalDimensions>;
        aggregate: {
            read: AggregateReadOperation<StockJournalDimensions>;
            query: AggregateQueryOperation<StockJournalDimensions>;
        };
        lookups(dataOrId: string | { data: StockJournalDimensionsInput }): StockJournalDimensions$Lookups;
        getDefaults: GetDefaultsOperation<StockJournalDimensions>;
    }
    export interface StockJournalImportDimensions extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        stockSite: string;
        isUpdated: boolean;
        product: string;
        effectiveDate: string;
        sequence: integer;
        index: integer;
        dimensionType: DimensionType;
        dimension: Dimension;
    }
    export interface StockJournalImportDimensionsInput extends VitalClientNodeInput {
        denormalizedIndex?: integer | string;
        stockSite?: string;
        isUpdated?: boolean | string;
        product?: string;
        effectiveDate?: string;
        sequence?: integer | string;
        index?: integer | string;
        dimensionType?: string;
        dimension?: string;
    }
    export interface StockJournalImportDimensionsBinding extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        stockSite: string;
        isUpdated: boolean;
        product: string;
        effectiveDate: string;
        sequence: integer;
        index: integer;
        dimensionType: DimensionType;
        dimension: Dimension;
    }
    export interface StockJournalImportDimensions$Lookups {
        dimensionType: QueryOperation<DimensionType>;
        dimension: QueryOperation<Dimension>;
    }
    export interface StockJournalImportDimensions$Operations {
        query: QueryOperation<StockJournalImportDimensions>;
        read: ReadOperation<StockJournalImportDimensions>;
        aggregate: {
            read: AggregateReadOperation<StockJournalImportDimensions>;
            query: AggregateQueryOperation<StockJournalImportDimensions>;
        };
        lookups(dataOrId: string | { data: StockJournalImportDimensionsInput }): StockJournalImportDimensions$Lookups;
        getDefaults: GetDefaultsOperation<StockJournalImportDimensions>;
    }
    export interface SupplierInvoiceHeaderCurrencyRates extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        id: string;
        ledger: Ledger;
        ledgerCurrency: Currency;
        multiplyingRate: string;
        dividingRate: string;
    }
    export interface SupplierInvoiceHeaderCurrencyRatesInput extends VitalClientNodeInput {
        denormalizedIndex?: integer | string;
        id?: string;
        ledger?: string;
        ledgerCurrency?: string;
        multiplyingRate?: decimal | string;
        dividingRate?: decimal | string;
    }
    export interface SupplierInvoiceHeaderCurrencyRatesBinding extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        id: string;
        ledger: Ledger;
        ledgerCurrency: Currency;
        multiplyingRate: string;
        dividingRate: string;
    }
    export interface SupplierInvoiceHeaderCurrencyRates$Lookups {
        ledger: QueryOperation<Ledger>;
        ledgerCurrency: QueryOperation<Currency>;
    }
    export interface SupplierInvoiceHeaderCurrencyRates$Operations {
        query: QueryOperation<SupplierInvoiceHeaderCurrencyRates>;
        read: ReadOperation<SupplierInvoiceHeaderCurrencyRates>;
        aggregate: {
            read: AggregateReadOperation<SupplierInvoiceHeaderCurrencyRates>;
            query: AggregateQueryOperation<SupplierInvoiceHeaderCurrencyRates>;
        };
        lookups(
            dataOrId: string | { data: SupplierInvoiceHeaderCurrencyRatesInput },
        ): SupplierInvoiceHeaderCurrencyRates$Lookups;
        getDefaults: GetDefaultsOperation<SupplierInvoiceHeaderCurrencyRates>;
    }
    export interface SupplierInvoiceHeaderDimensions extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        id: string;
        dimensionType: DimensionType;
        dimension: Dimension;
    }
    export interface SupplierInvoiceHeaderDimensionsInput extends VitalClientNodeInput {
        denormalizedIndex?: integer | string;
        id?: string;
        dimensionType?: string;
        dimension?: string;
    }
    export interface SupplierInvoiceHeaderDimensionsBinding extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        id: string;
        dimensionType: DimensionType;
        dimension: Dimension;
    }
    export interface SupplierInvoiceHeaderDimensions$Lookups {
        dimensionType: QueryOperation<DimensionType>;
        dimension: QueryOperation<Dimension>;
    }
    export interface SupplierInvoiceHeaderDimensions$Operations {
        query: QueryOperation<SupplierInvoiceHeaderDimensions>;
        read: ReadOperation<SupplierInvoiceHeaderDimensions>;
        aggregate: {
            read: AggregateReadOperation<SupplierInvoiceHeaderDimensions>;
            query: AggregateQueryOperation<SupplierInvoiceHeaderDimensions>;
        };
        lookups(
            dataOrId: string | { data: SupplierInvoiceHeaderDimensionsInput },
        ): SupplierInvoiceHeaderDimensions$Lookups;
        getDefaults: GetDefaultsOperation<SupplierInvoiceHeaderDimensions>;
    }
    export interface BusinessPartnerCompanyExceptionExtension {
        _updateUser: SysUser;
        _createUser: SysUser;
        businessPartner: BusinessPartner;
        company: Company;
        isAuthorizedEntry: boolean;
        contractualPeriod: integer;
        isCashExcluded: boolean;
        electronicInvoiceType: ElectronicInvoiceType;
        mappingCode: Mapping;
        registrationAgreement: string;
        businessPartnerTaxRule: TaxRule;
        customerTaxRule: TaxRule;
        supplierTaxRule: TaxRule;
        customerPaymentTerm: PaymentTerm;
        supplierPaymentTerm: PaymentTerm;
        customerEarlyDiscountOrLateCharge: EarlyDiscountLateCharge;
        supplierEarlyDiscountOrLateCharge: EarlyDiscountLateCharge;
        customerAccountingCode: AccountingCode;
        supplierAccountingCode: AccountingCode;
        paymentBankIsrQr: BankAccount;
    }
    export interface BusinessPartnerCompanyExceptionInputExtension {
        businessPartner?: string;
        company?: string;
        isAuthorizedEntry?: boolean | string;
        contractualPeriod?: integer | string;
        isCashExcluded?: boolean | string;
        electronicInvoiceType?: ElectronicInvoiceType;
        mappingCode?: string;
        registrationAgreement?: string;
        businessPartnerTaxRule?: string;
        customerTaxRule?: string;
        supplierTaxRule?: string;
        customerPaymentTerm?: string;
        supplierPaymentTerm?: string;
        customerEarlyDiscountOrLateCharge?: string;
        supplierEarlyDiscountOrLateCharge?: string;
        customerAccountingCode?: string;
        supplierAccountingCode?: string;
        paymentBankIsrQr?: string;
    }
    export interface BusinessPartnerCompanyExceptionBindingExtension {
        _updateUser: SysUser;
        _createUser: SysUser;
        businessPartner: BusinessPartner;
        company: Company;
        isAuthorizedEntry: boolean;
        contractualPeriod: integer;
        isCashExcluded: boolean;
        electronicInvoiceType: ElectronicInvoiceType;
        mappingCode: Mapping;
        registrationAgreement: string;
        businessPartnerTaxRule: TaxRule;
        customerTaxRule: TaxRule;
        supplierTaxRule: TaxRule;
        customerPaymentTerm: PaymentTerm;
        supplierPaymentTerm: PaymentTerm;
        customerEarlyDiscountOrLateCharge: EarlyDiscountLateCharge;
        supplierEarlyDiscountOrLateCharge: EarlyDiscountLateCharge;
        customerAccountingCode: AccountingCode;
        supplierAccountingCode: AccountingCode;
        paymentBankIsrQr: BankAccount;
    }
    export interface BusinessPartnerCompanyExceptionExtension$Lookups {
        customerAccountingCode: QueryOperation<AccountingCode>;
        supplierAccountingCode: QueryOperation<AccountingCode>;
        paymentBankIsrQr: QueryOperation<BankAccount>;
    }
    export interface BusinessPartnerCompanyExceptionExtension$Operations {
        lookups(
            dataOrId: string | { data: BusinessPartnerCompanyExceptionInput },
        ): BusinessPartnerCompanyExceptionExtension$Lookups;
    }
    export interface BusinessPartnerExtension {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        isActive: boolean;
        category: CustomerCategory;
        customerOrSupplierOriginCategory: string;
        companyName1: string;
        companyName2: string;
        shortCompanyName: string;
        europeanUnionVatNumber: string;
        isIntersite: boolean;
        businessPartnerSite: Site;
        country: Country;
        siteIdentificationNumber: string;
        standardIndustrialClassificationCode: string;
        currency: Currency;
        language: Language;
        acronym: string;
        italianTaxNumber: string;
        fiscalCode: string;
        consolidationGroup: SiteGroupings;
        consolidationCode: string;
        isCustomer: boolean;
        isSupplier: boolean;
        isGrantor: boolean;
        isCarrier: boolean;
        isFactor: boolean;
        isSalesRep: boolean;
        isMiscellaneousBusinessPartner: boolean;
        isProspect: boolean;
        isServiceSupplier: boolean;
        isServiceCaller: boolean;
        defaultAddress: BusinessPartnerAddress;
        defaultContact: BusinessPartnerContact;
        defaultBankId: BusinessPartnerBankDetail;
        bankIdCountry: Country;
        reportAccessCode: Access;
        isMailingProhibited: boolean;
        cfonbPaymentMethod: MiscellaneousTable;
        nonResidentAccount: BusinessPartnerAddress;
        isPhysicalPerson: boolean;
        isCashExcluded: boolean;
        documentType: DocumentType;
        isPublicSector: boolean;
        relatedCompany: RelatedCompanySettings;
        consolidationPartner: BusinessPartner;
        registrationNumber: string;
        vatNumber: string;
        economicOperatorRegistrationAndIdNumber: string;
        serviceCode: string;
        routingCode: string;
        electronicInvoiceType: ElectronicInvoiceType;
        mappingCode: Mapping;
        electronicAddress: string;
        addresses: ClientCollection<BusinessPartnerAddress>;
        contacts: ClientCollection<BusinessPartnerContact>;
        bankDetails: ClientCollection<BusinessPartnerBankDetail>;
        companyException: ClientCollection<BusinessPartnerCompanyException>;
        companyNames: ClientCollection<BusinessPartnerCompanyNames>;
        accountingCode: AccountingCode;
        expenseEntryType: EntryType;
    }
    export interface BusinessPartnerInputExtension {
        code?: string;
        isActive?: boolean | string;
        category?: string;
        customerOrSupplierOriginCategory?: string;
        companyName1?: string;
        companyName2?: string;
        shortCompanyName?: string;
        europeanUnionVatNumber?: string;
        isIntersite?: boolean | string;
        businessPartnerSite?: string;
        country?: string;
        siteIdentificationNumber?: string;
        standardIndustrialClassificationCode?: string;
        currency?: string;
        language?: string;
        acronym?: string;
        italianTaxNumber?: string;
        fiscalCode?: string;
        consolidationGroup?: string;
        consolidationCode?: string;
        isCustomer?: boolean | string;
        isSupplier?: boolean | string;
        isGrantor?: boolean | string;
        isCarrier?: boolean | string;
        isFactor?: boolean | string;
        isSalesRep?: boolean | string;
        isMiscellaneousBusinessPartner?: boolean | string;
        isProspect?: boolean | string;
        isServiceSupplier?: boolean | string;
        isServiceCaller?: boolean | string;
        defaultAddress?: string;
        defaultContact?: string;
        defaultBankId?: string;
        bankIdCountry?: string;
        reportAccessCode?: string;
        isMailingProhibited?: boolean | string;
        cfonbPaymentMethod?: string;
        nonResidentAccount?: string;
        isPhysicalPerson?: boolean | string;
        isCashExcluded?: boolean | string;
        documentType?: DocumentType;
        isPublicSector?: boolean | string;
        relatedCompany?: RelatedCompanySettings;
        consolidationPartner?: string;
        registrationNumber?: string;
        vatNumber?: string;
        economicOperatorRegistrationAndIdNumber?: string;
        serviceCode?: string;
        routingCode?: string;
        electronicInvoiceType?: ElectronicInvoiceType;
        mappingCode?: string;
        electronicAddress?: string;
        addresses?: Partial<BusinessPartnerAddressInput>[];
        contacts?: Partial<BusinessPartnerContactInput>[];
        bankDetails?: Partial<BusinessPartnerBankDetailInput>[];
        companyException?: Partial<BusinessPartnerCompanyExceptionInput>[];
        companyNames?: Partial<BusinessPartnerCompanyNamesInput>[];
        accountingCode?: string;
        expenseEntryType?: string;
    }
    export interface BusinessPartnerBindingExtension {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        isActive: boolean;
        category: CustomerCategory;
        customerOrSupplierOriginCategory: string;
        companyName1: string;
        companyName2: string;
        shortCompanyName: string;
        europeanUnionVatNumber: string;
        isIntersite: boolean;
        businessPartnerSite: Site;
        country: Country;
        siteIdentificationNumber: string;
        standardIndustrialClassificationCode: string;
        currency: Currency;
        language: Language;
        acronym: string;
        italianTaxNumber: string;
        fiscalCode: string;
        consolidationGroup: SiteGroupings;
        consolidationCode: string;
        isCustomer: boolean;
        isSupplier: boolean;
        isGrantor: boolean;
        isCarrier: boolean;
        isFactor: boolean;
        isSalesRep: boolean;
        isMiscellaneousBusinessPartner: boolean;
        isProspect: boolean;
        isServiceSupplier: boolean;
        isServiceCaller: boolean;
        defaultAddress: BusinessPartnerAddress;
        defaultContact: BusinessPartnerContact;
        defaultBankId: BusinessPartnerBankDetail;
        bankIdCountry: Country;
        reportAccessCode: Access;
        isMailingProhibited: boolean;
        cfonbPaymentMethod: MiscellaneousTable;
        nonResidentAccount: BusinessPartnerAddress;
        isPhysicalPerson: boolean;
        isCashExcluded: boolean;
        documentType: DocumentType;
        isPublicSector: boolean;
        relatedCompany: RelatedCompanySettings;
        consolidationPartner: BusinessPartner;
        registrationNumber: string;
        vatNumber: string;
        economicOperatorRegistrationAndIdNumber: string;
        serviceCode: string;
        routingCode: string;
        electronicInvoiceType: ElectronicInvoiceType;
        mappingCode: Mapping;
        electronicAddress: string;
        addresses: ClientCollection<BusinessPartnerAddress>;
        contacts: ClientCollection<BusinessPartnerContact>;
        bankDetails: ClientCollection<BusinessPartnerBankDetail>;
        companyException: ClientCollection<BusinessPartnerCompanyException>;
        companyNames: ClientCollection<BusinessPartnerCompanyNamesBinding>;
        accountingCode: AccountingCode;
        expenseEntryType: EntryType;
    }
    export interface BusinessPartnerExtension$Lookups {
        accountingCode: QueryOperation<AccountingCode>;
        expenseEntryType: QueryOperation<EntryType>;
    }
    export interface BusinessPartnerExtension$Operations {
        lookups(dataOrId: string | { data: BusinessPartnerInput }): BusinessPartnerExtension$Lookups;
    }
    export interface CostTypeExtension {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        site: Site;
        localizedDescription: string;
        localizedShortDescription: string;
        isActive: boolean;
        dimensions: ClientCollection<CostTypeDimensions>;
    }
    export interface CostTypeInputExtension {
        code?: string;
        site?: string;
        localizedDescription?: string;
        localizedShortDescription?: string;
        isActive?: boolean | string;
        dimensions?: Partial<CostTypeDimensionsInput>[];
    }
    export interface CostTypeBindingExtension {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        site: Site;
        localizedDescription: string;
        localizedShortDescription: string;
        isActive: boolean;
        dimensions: ClientCollection<CostTypeDimensionsBinding>;
    }
    export interface CustomerExtension {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: BusinessPartner;
        customerCategory: CustomerCategory;
        billToCustomer: Customer;
        billToCustomerAddress: CustomerAddress;
        payByCustomer: BusinessPartner;
        payByCustomerAddress: BusinessPartnerAddress;
        groupCustomer: Customer;
        riskCustomer: Customer;
        defaultAddress: CustomerAddress;
        defaultShipToAddress: ShipToCustomerAddress;
        defaultContact: CustomerContact;
        isActive: boolean;
        ourSupplierCode: string;
        currency: Currency;
        rateType: ExchangeRateType;
        commissionCategory: CommissionCategory;
        exemptionTaxNumber: string;
        priceOrAmountType: PriceAmountTaxTax;
        creditControl: WorkInProgressControl;
        authorizedCreditAmount: string;
        minimumOrderAmount: string;
        creditInsuranceAmount: string;
        insuranceDate: string;
        insuranceCompany: BusinessPartner;
        reminderType: ReminderType;
        minimumReminderAmount: string;
        canBeMatched: boolean;
        isLoanAllowed: boolean;
        mustPrintAcknowledgment: boolean;
        isOrderClosingAllowed: boolean;
        mustContainOneOrderPerDelivery: boolean;
        businessSector: MiscellaneousTable;
        prospectOrigin: MiscellaneousTable;
        tokenCredit: integer;
        manualAdditionalToken: integer;
        totalTokenCredit: integer;
        necessaryTokensForServiceContract: integer;
        firstContactDate: string;
        firstOrderDate: string;
        lastQuoteDate: string;
        lastContactDate: string;
        nextContactDate: string;
        customerAbcClass: ProductAbcClass;
        printTemplate: PrintTemplate;
        initialDateSinceCustomer: string;
        unavailablePaymentPeriod: UnavailablePeriods;
        isSubjectToTax: boolean;
        isEfatElectronicInvoicingAllowed: boolean;
        contact: CustomerContact;
        startDateforElectronicInvoice: string;
        isElectronicInvoiceAllowed: boolean;
        addresses: ClientCollection<CustomerAddress>;
        contacts: ClientCollection<CustomerContact>;
        bankDetails: ClientCollection<CustomerBankDetail>;
        businessPartner: BusinessPartner;
        shipToCustomers: ClientCollection<ShipToCustomerAddress>;
        acronym: string;
        businessPartnerSite: Site;
        cfonbPaymentMethod: MiscellaneousTable;
        companyName1: string;
        companyName2: string;
        companyNames: ClientCollection<BusinessPartnerCompanyNames>;
        consolidationCode: string;
        consolidationGroup: SiteGroupings;
        consolidationPartner: BusinessPartner;
        country: Country;
        customerOrSupplierOriginCategory: string;
        documentType: DocumentType;
        economicOperatorRegistrationAndIdNumber: string;
        electronicAddress: string;
        electronicInvoiceType: ElectronicInvoiceType;
        europeanUnionVatNumber: string;
        fiscalCode: string;
        invoiceHeaderText: TextStream;
        isCashExcluded: boolean;
        isIntersite: boolean;
        isMailingProhibited: boolean;
        isPhysicalPerson: boolean;
        isPublicSector: boolean;
        isServiceCaller: boolean;
        isServiceSupplier: boolean;
        italianTaxNumber: string;
        language: Language;
        nonResidentAccount: BusinessPartnerAddress;
        orderHeaderText: TextStream;
        registrationNumber: string;
        relatedCompany: RelatedCompanySettings;
        reportAccessCode: Access;
        routingCode: string;
        serviceCode: string;
        shortCompanyName: string;
        siteIdentificationNumber: string;
        standardIndustrialClassificationCode: string;
        vatNumber: string;
        cashTaxRules: ClientCollection<CustomerCashTaxRules>;
        paymentDays: ClientCollection<CustomerPaymentDays>;
        salesReps: ClientCollection<CustomerSalesReps>;
        statisticalGroups: ClientCollection<CustomerStatisticalGroups>;
        taxRule: TaxRule;
        paymentTerm: PaymentTerm;
        earlyDiscountOrLateCharge: EarlyDiscountLateCharge;
        invoicingTerm: InvoicingTerm;
        invoicingElements: ClientCollection<CustomerInvoicingElements>;
        reminderGroup: ReminderGroup;
        factor: Factor;
        paymentBank: BankAccount;
        accountingCode: AccountingCode;
        accountStructure: AccountScheme;
        dimensions: ClientCollection<CustomerDimensions>;
    }
    export interface CustomerInputExtension {
        code?: string;
        customerCategory?: string;
        billToCustomer?: string;
        billToCustomerAddress?: string;
        payByCustomer?: string;
        payByCustomerAddress?: string;
        groupCustomer?: string;
        riskCustomer?: string;
        defaultAddress?: string;
        defaultShipToAddress?: string;
        defaultContact?: string;
        isActive?: boolean | string;
        ourSupplierCode?: string;
        currency?: string;
        rateType?: ExchangeRateType;
        commissionCategory?: CommissionCategory;
        exemptionTaxNumber?: string;
        priceOrAmountType?: PriceAmountTaxTax;
        creditControl?: WorkInProgressControl;
        authorizedCreditAmount?: decimal | string;
        minimumOrderAmount?: decimal | string;
        creditInsuranceAmount?: decimal | string;
        insuranceDate?: string;
        insuranceCompany?: string;
        reminderType?: ReminderType;
        minimumReminderAmount?: decimal | string;
        canBeMatched?: boolean | string;
        isLoanAllowed?: boolean | string;
        mustPrintAcknowledgment?: boolean | string;
        isOrderClosingAllowed?: boolean | string;
        mustContainOneOrderPerDelivery?: boolean | string;
        businessSector?: string;
        prospectOrigin?: string;
        tokenCredit?: integer | string;
        manualAdditionalToken?: integer | string;
        totalTokenCredit?: integer | string;
        necessaryTokensForServiceContract?: integer | string;
        firstContactDate?: string;
        firstOrderDate?: string;
        lastQuoteDate?: string;
        lastContactDate?: string;
        nextContactDate?: string;
        customerAbcClass?: ProductAbcClass;
        printTemplate?: string;
        initialDateSinceCustomer?: string;
        unavailablePaymentPeriod?: string;
        isSubjectToTax?: boolean | string;
        isEfatElectronicInvoicingAllowed?: boolean | string;
        contact?: string;
        startDateforElectronicInvoice?: string;
        isElectronicInvoiceAllowed?: boolean | string;
        addresses?: Partial<CustomerAddressInput>[];
        contacts?: Partial<CustomerContactInput>[];
        bankDetails?: Partial<CustomerBankDetailInput>[];
        businessPartner?: string;
        shipToCustomers?: Partial<ShipToCustomerAddressInput>[];
        acronym?: string;
        businessPartnerSite?: string;
        cfonbPaymentMethod?: string;
        companyName1?: string;
        companyName2?: string;
        companyNames?: Partial<BusinessPartnerCompanyNamesInput>[];
        consolidationCode?: string;
        consolidationGroup?: string;
        consolidationPartner?: string;
        country?: string;
        customerOrSupplierOriginCategory?: string;
        documentType?: DocumentType;
        economicOperatorRegistrationAndIdNumber?: string;
        electronicAddress?: string;
        electronicInvoiceType?: ElectronicInvoiceType;
        europeanUnionVatNumber?: string;
        fiscalCode?: string;
        invoiceHeaderText?: TextStream;
        isCashExcluded?: boolean | string;
        isIntersite?: boolean | string;
        isMailingProhibited?: boolean | string;
        isPhysicalPerson?: boolean | string;
        isPublicSector?: boolean | string;
        isServiceCaller?: boolean | string;
        isServiceSupplier?: boolean | string;
        italianTaxNumber?: string;
        language?: string;
        nonResidentAccount?: string;
        orderHeaderText?: TextStream;
        registrationNumber?: string;
        relatedCompany?: RelatedCompanySettings;
        reportAccessCode?: string;
        routingCode?: string;
        serviceCode?: string;
        shortCompanyName?: string;
        siteIdentificationNumber?: string;
        standardIndustrialClassificationCode?: string;
        vatNumber?: string;
        cashTaxRules?: Partial<CustomerCashTaxRulesInput>[];
        paymentDays?: Partial<CustomerPaymentDaysInput>[];
        salesReps?: Partial<CustomerSalesRepsInput>[];
        statisticalGroups?: Partial<CustomerStatisticalGroupsInput>[];
        taxRule?: string;
        paymentTerm?: string;
        earlyDiscountOrLateCharge?: string;
        invoicingTerm?: string;
        invoicingElements?: Partial<CustomerInvoicingElementsInput>[];
        reminderGroup?: string;
        factor?: string;
        paymentBank?: string;
        accountingCode?: string;
        accountStructure?: string;
        dimensions?: Partial<CustomerDimensionsInput>[];
    }
    export interface CustomerBindingExtension {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: BusinessPartner;
        customerCategory: CustomerCategory;
        billToCustomer: Customer;
        billToCustomerAddress: CustomerAddress;
        payByCustomer: BusinessPartner;
        payByCustomerAddress: BusinessPartnerAddress;
        groupCustomer: Customer;
        riskCustomer: Customer;
        defaultAddress: CustomerAddress;
        defaultShipToAddress: ShipToCustomerAddress;
        defaultContact: CustomerContact;
        isActive: boolean;
        ourSupplierCode: string;
        currency: Currency;
        rateType: ExchangeRateType;
        commissionCategory: CommissionCategory;
        exemptionTaxNumber: string;
        priceOrAmountType: PriceAmountTaxTax;
        creditControl: WorkInProgressControl;
        authorizedCreditAmount: string;
        minimumOrderAmount: string;
        creditInsuranceAmount: string;
        insuranceDate: string;
        insuranceCompany: BusinessPartner;
        reminderType: ReminderType;
        minimumReminderAmount: string;
        canBeMatched: boolean;
        isLoanAllowed: boolean;
        mustPrintAcknowledgment: boolean;
        isOrderClosingAllowed: boolean;
        mustContainOneOrderPerDelivery: boolean;
        businessSector: MiscellaneousTable;
        prospectOrigin: MiscellaneousTable;
        tokenCredit: integer;
        manualAdditionalToken: integer;
        totalTokenCredit: integer;
        necessaryTokensForServiceContract: integer;
        firstContactDate: string;
        firstOrderDate: string;
        lastQuoteDate: string;
        lastContactDate: string;
        nextContactDate: string;
        customerAbcClass: ProductAbcClass;
        printTemplate: PrintTemplate;
        initialDateSinceCustomer: string;
        unavailablePaymentPeriod: UnavailablePeriods;
        isSubjectToTax: boolean;
        isEfatElectronicInvoicingAllowed: boolean;
        contact: CustomerContact;
        startDateforElectronicInvoice: string;
        isElectronicInvoiceAllowed: boolean;
        addresses: ClientCollection<CustomerAddress>;
        contacts: ClientCollection<CustomerContact>;
        bankDetails: ClientCollection<CustomerBankDetail>;
        businessPartner: BusinessPartner;
        shipToCustomers: ClientCollection<ShipToCustomerAddress>;
        acronym: string;
        businessPartnerSite: Site;
        cfonbPaymentMethod: MiscellaneousTable;
        companyName1: string;
        companyName2: string;
        companyNames: ClientCollection<BusinessPartnerCompanyNames>;
        consolidationCode: string;
        consolidationGroup: SiteGroupings;
        consolidationPartner: BusinessPartner;
        country: Country;
        customerOrSupplierOriginCategory: string;
        documentType: DocumentType;
        economicOperatorRegistrationAndIdNumber: string;
        electronicAddress: string;
        electronicInvoiceType: ElectronicInvoiceType;
        europeanUnionVatNumber: string;
        fiscalCode: string;
        invoiceHeaderText: TextStream;
        isCashExcluded: boolean;
        isIntersite: boolean;
        isMailingProhibited: boolean;
        isPhysicalPerson: boolean;
        isPublicSector: boolean;
        isServiceCaller: boolean;
        isServiceSupplier: boolean;
        italianTaxNumber: string;
        language: Language;
        nonResidentAccount: BusinessPartnerAddress;
        orderHeaderText: TextStream;
        registrationNumber: string;
        relatedCompany: RelatedCompanySettings;
        reportAccessCode: Access;
        routingCode: string;
        serviceCode: string;
        shortCompanyName: string;
        siteIdentificationNumber: string;
        standardIndustrialClassificationCode: string;
        vatNumber: string;
        cashTaxRules: ClientCollection<CustomerCashTaxRulesBinding>;
        paymentDays: ClientCollection<CustomerPaymentDaysBinding>;
        salesReps: ClientCollection<CustomerSalesRepsBinding>;
        statisticalGroups: ClientCollection<CustomerStatisticalGroupsBinding>;
        taxRule: TaxRule;
        paymentTerm: PaymentTerm;
        earlyDiscountOrLateCharge: EarlyDiscountLateCharge;
        invoicingTerm: InvoicingTerm;
        invoicingElements: ClientCollection<CustomerInvoicingElementsBinding>;
        reminderGroup: ReminderGroup;
        factor: Factor;
        paymentBank: BankAccount;
        accountingCode: AccountingCode;
        accountStructure: AccountScheme;
        dimensions: ClientCollection<CustomerDimensionsBinding>;
    }
    export interface CustomerExtension$Lookups {
        reminderGroup: QueryOperation<ReminderGroup>;
        factor: QueryOperation<Factor>;
        paymentBank: QueryOperation<BankAccount>;
        accountingCode: QueryOperation<AccountingCode>;
        accountStructure: QueryOperation<AccountScheme>;
    }
    export interface CustomerExtension$Operations {
        lookups(dataOrId: string | { data: CustomerInput }): CustomerExtension$Lookups;
    }
    export interface CustomerInvoiceHeaderExtension {
        _updateUser: SysUser;
        _createUser: SysUser;
        id: string;
        category: InvoiceType;
        sourceModule: ModuleTable;
        billToCustomer: Customer;
        control: string;
        company: Company;
        financialSite: Site;
        accountingDate: string;
        internalNumber: integer;
        sourceDocumentDate: string;
        sourceDocument: string;
        currency: Currency;
        rateType: ExchangeRateType;
        rateDate: string;
        payByBusinessPartner: BusinessPartner;
        payByBusinessPartnerAddress: BusinessPartnerAddress;
        payByBusinessPartnerPostalCode: string;
        payByBusinessPartnerCity: string;
        payByBusinessPartnerState: string;
        payByBusinessPartnerCountry: Country;
        payByBusinessPartnerCountryName: string;
        dueDateCalculationStartDate: string;
        paymentTerm: PaymentTerm;
        earlyDiscountOrLateCharge: EarlyDiscountLateCharge;
        earlyDiscountOrLateChargeRate: string;
        taxRule: TaxRule;
        entityUserCode: MiscellaneousTable;
        isDirectInvoice: boolean;
        intrastatProcessingNumber: integer;
        status: InvoiceStatus;
        originalInvoiceNumber: string;
        debitOrCredit: integer;
        totalAmountIncludingTax: string;
        totalAmountExcludingTax: string;
        totalAmountExcludingTaxInCompanyCurrency: string;
        totalAmountIncludingTaxInCompanyCurrency: string;
        taxReferenceDate: string;
        numberOfTaxes: integer;
        billToCustomerAddress: CustomerAddress;
        billToCustomerPostalCode: string;
        billToCustomerCity: string;
        billToCustomerState: string;
        billToCustomerCountry: Country;
        billToCustomerCountryName: string;
        draftNumber: string;
        stockMovementGroup: MiscellaneousTable;
        fiscalYear: integer;
        period: integer;
        serviceStartDate: string;
        serviceEndDate: string;
        lastServiceAccountedDate: string;
        warehouse: Warehouse;
        isPrinted: boolean;
        isExternalDocument: boolean;
        earlyDiscountOrLateChargeBasis: string;
        versionControlSystemNumber: string;
        isValidatedAddress: boolean;
        priceOrAmountTaxType: PriceAmountTaxTax;
        vatDeclarationNumber: string;
        exportDeclaration: string;
        mandate: Mandate;
        recurringNumber: string;
        recurringInvoicingDate: string;
        numberOfCompanies: integer;
        cashVatTaxRule: boolean;
        derCode: string;
        field40Reason: MiscellaneousTable;
        field41Reason: MiscellaneousTable;
        originalDocumentNumber: string;
        creditMemoReferenceStartDate: string;
        creditMemoReferenceEndDate: string;
        inPaymentSlipWithReferenceNumber: string;
        cancellationStatus: integer;
        project: ProjectLink;
        correctionMethod: CorrectionMethod;
        siteIdentificationNumber: string;
        spanishInvoiceType: SpanishInvoiceType;
        businessProcessType: MiscellaneousTable;
        operationType: TypeOfOperation;
        autoInvoicingSpanish: boolean;
        manualAutoInvoicingSpaGenerated: boolean;
        automaticAutoInvoicingSpaGenerated: boolean;
        destinationGeneration: AutoInvoiceRecipient;
        spanishTaxDate: string;
        billToCustomerAddressLines: ClientCollection<CustomerInvoiceHeaderBillToCustomerAddressLines>;
        billToCustomerCompanyNames: ClientCollection<CustomerInvoiceHeaderBillToCustomerCompanyNames>;
        comments: ClientCollection<CustomerInvoiceHeaderComments>;
        payByBusinessPartnerAddressLines: ClientCollection<CustomerInvoiceHeaderPayByBusinessPartnerAddressLines>;
        payByBusinessPartnerCompanyNames: ClientCollection<CustomerInvoiceHeaderPayByBusinessPartnerCompanyNames>;
        taxes: ClientCollection<CustomerInvoiceHeaderTaxes>;
        entryType: EntryType;
        journal: Journal;
        paymentBank: BankAccount;
        currencyRates: ClientCollection<CustomerInvoiceHeaderCurrencyRates>;
        dimensions: ClientCollection<CustomerInvoiceHeaderDimensions>;
    }
    export interface CustomerInvoiceHeaderInputExtension {
        id?: string;
        category?: InvoiceType;
        sourceModule?: ModuleTable;
        billToCustomer?: string;
        control?: string;
        company?: string;
        financialSite?: string;
        accountingDate?: string;
        internalNumber?: integer | string;
        sourceDocumentDate?: string;
        sourceDocument?: string;
        currency?: string;
        rateType?: ExchangeRateType;
        rateDate?: string;
        payByBusinessPartner?: string;
        payByBusinessPartnerAddress?: string;
        payByBusinessPartnerPostalCode?: string;
        payByBusinessPartnerCity?: string;
        payByBusinessPartnerState?: string;
        payByBusinessPartnerCountry?: string;
        payByBusinessPartnerCountryName?: string;
        dueDateCalculationStartDate?: string;
        paymentTerm?: string;
        earlyDiscountOrLateCharge?: string;
        earlyDiscountOrLateChargeRate?: decimal | string;
        taxRule?: string;
        entityUserCode?: string;
        isDirectInvoice?: boolean | string;
        intrastatProcessingNumber?: integer | string;
        status?: InvoiceStatus;
        originalInvoiceNumber?: string;
        debitOrCredit?: integer | string;
        totalAmountIncludingTax?: decimal | string;
        totalAmountExcludingTax?: decimal | string;
        totalAmountExcludingTaxInCompanyCurrency?: decimal | string;
        totalAmountIncludingTaxInCompanyCurrency?: decimal | string;
        taxReferenceDate?: string;
        numberOfTaxes?: integer | string;
        billToCustomerAddress?: string;
        billToCustomerPostalCode?: string;
        billToCustomerCity?: string;
        billToCustomerState?: string;
        billToCustomerCountry?: string;
        billToCustomerCountryName?: string;
        draftNumber?: string;
        stockMovementGroup?: string;
        fiscalYear?: integer | string;
        period?: integer | string;
        serviceStartDate?: string;
        serviceEndDate?: string;
        lastServiceAccountedDate?: string;
        warehouse?: string;
        isPrinted?: boolean | string;
        isExternalDocument?: boolean | string;
        earlyDiscountOrLateChargeBasis?: decimal | string;
        versionControlSystemNumber?: string;
        isValidatedAddress?: boolean | string;
        priceOrAmountTaxType?: PriceAmountTaxTax;
        vatDeclarationNumber?: string;
        exportDeclaration?: string;
        mandate?: string;
        recurringNumber?: string;
        recurringInvoicingDate?: string;
        numberOfCompanies?: integer | string;
        cashVatTaxRule?: boolean | string;
        derCode?: string;
        field40Reason?: string;
        field41Reason?: string;
        originalDocumentNumber?: string;
        creditMemoReferenceStartDate?: string;
        creditMemoReferenceEndDate?: string;
        inPaymentSlipWithReferenceNumber?: string;
        cancellationStatus?: integer | string;
        project?: string;
        correctionMethod?: CorrectionMethod;
        siteIdentificationNumber?: string;
        spanishInvoiceType?: SpanishInvoiceType;
        businessProcessType?: string;
        operationType?: TypeOfOperation;
        autoInvoicingSpanish?: boolean | string;
        manualAutoInvoicingSpaGenerated?: boolean | string;
        automaticAutoInvoicingSpaGenerated?: boolean | string;
        destinationGeneration?: AutoInvoiceRecipient;
        spanishTaxDate?: string;
        billToCustomerAddressLines?: Partial<CustomerInvoiceHeaderBillToCustomerAddressLinesInput>[];
        billToCustomerCompanyNames?: Partial<CustomerInvoiceHeaderBillToCustomerCompanyNamesInput>[];
        comments?: Partial<CustomerInvoiceHeaderCommentsInput>[];
        payByBusinessPartnerAddressLines?: Partial<CustomerInvoiceHeaderPayByBusinessPartnerAddressLinesInput>[];
        payByBusinessPartnerCompanyNames?: Partial<CustomerInvoiceHeaderPayByBusinessPartnerCompanyNamesInput>[];
        taxes?: Partial<CustomerInvoiceHeaderTaxesInput>[];
        entryType?: string;
        journal?: string;
        paymentBank?: string;
        currencyRates?: Partial<CustomerInvoiceHeaderCurrencyRatesInput>[];
        dimensions?: Partial<CustomerInvoiceHeaderDimensionsInput>[];
    }
    export interface CustomerInvoiceHeaderBindingExtension {
        _updateUser: SysUser;
        _createUser: SysUser;
        id: string;
        category: InvoiceType;
        sourceModule: ModuleTable;
        billToCustomer: Customer;
        control: string;
        company: Company;
        financialSite: Site;
        accountingDate: string;
        internalNumber: integer;
        sourceDocumentDate: string;
        sourceDocument: string;
        currency: Currency;
        rateType: ExchangeRateType;
        rateDate: string;
        payByBusinessPartner: BusinessPartner;
        payByBusinessPartnerAddress: BusinessPartnerAddress;
        payByBusinessPartnerPostalCode: string;
        payByBusinessPartnerCity: string;
        payByBusinessPartnerState: string;
        payByBusinessPartnerCountry: Country;
        payByBusinessPartnerCountryName: string;
        dueDateCalculationStartDate: string;
        paymentTerm: PaymentTerm;
        earlyDiscountOrLateCharge: EarlyDiscountLateCharge;
        earlyDiscountOrLateChargeRate: string;
        taxRule: TaxRule;
        entityUserCode: MiscellaneousTable;
        isDirectInvoice: boolean;
        intrastatProcessingNumber: integer;
        status: InvoiceStatus;
        originalInvoiceNumber: string;
        debitOrCredit: integer;
        totalAmountIncludingTax: string;
        totalAmountExcludingTax: string;
        totalAmountExcludingTaxInCompanyCurrency: string;
        totalAmountIncludingTaxInCompanyCurrency: string;
        taxReferenceDate: string;
        numberOfTaxes: integer;
        billToCustomerAddress: CustomerAddress;
        billToCustomerPostalCode: string;
        billToCustomerCity: string;
        billToCustomerState: string;
        billToCustomerCountry: Country;
        billToCustomerCountryName: string;
        draftNumber: string;
        stockMovementGroup: MiscellaneousTable;
        fiscalYear: integer;
        period: integer;
        serviceStartDate: string;
        serviceEndDate: string;
        lastServiceAccountedDate: string;
        warehouse: Warehouse;
        isPrinted: boolean;
        isExternalDocument: boolean;
        earlyDiscountOrLateChargeBasis: string;
        versionControlSystemNumber: string;
        isValidatedAddress: boolean;
        priceOrAmountTaxType: PriceAmountTaxTax;
        vatDeclarationNumber: string;
        exportDeclaration: string;
        mandate: Mandate;
        recurringNumber: string;
        recurringInvoicingDate: string;
        numberOfCompanies: integer;
        cashVatTaxRule: boolean;
        derCode: string;
        field40Reason: MiscellaneousTable;
        field41Reason: MiscellaneousTable;
        originalDocumentNumber: string;
        creditMemoReferenceStartDate: string;
        creditMemoReferenceEndDate: string;
        inPaymentSlipWithReferenceNumber: string;
        cancellationStatus: integer;
        project: ProjectLink;
        correctionMethod: CorrectionMethod;
        siteIdentificationNumber: string;
        spanishInvoiceType: SpanishInvoiceType;
        businessProcessType: MiscellaneousTable;
        operationType: TypeOfOperation;
        autoInvoicingSpanish: boolean;
        manualAutoInvoicingSpaGenerated: boolean;
        automaticAutoInvoicingSpaGenerated: boolean;
        destinationGeneration: AutoInvoiceRecipient;
        spanishTaxDate: string;
        billToCustomerAddressLines: ClientCollection<CustomerInvoiceHeaderBillToCustomerAddressLinesBinding>;
        billToCustomerCompanyNames: ClientCollection<CustomerInvoiceHeaderBillToCustomerCompanyNamesBinding>;
        comments: ClientCollection<CustomerInvoiceHeaderCommentsBinding>;
        payByBusinessPartnerAddressLines: ClientCollection<CustomerInvoiceHeaderPayByBusinessPartnerAddressLinesBinding>;
        payByBusinessPartnerCompanyNames: ClientCollection<CustomerInvoiceHeaderPayByBusinessPartnerCompanyNamesBinding>;
        taxes: ClientCollection<CustomerInvoiceHeaderTaxesBinding>;
        entryType: EntryType;
        journal: Journal;
        paymentBank: BankAccount;
        currencyRates: ClientCollection<CustomerInvoiceHeaderCurrencyRatesBinding>;
        dimensions: ClientCollection<CustomerInvoiceHeaderDimensionsBinding>;
    }
    export interface CustomerInvoiceHeaderExtension$Lookups {
        entryType: QueryOperation<EntryType>;
        journal: QueryOperation<Journal>;
        paymentBank: QueryOperation<BankAccount>;
    }
    export interface CustomerInvoiceHeaderExtension$Operations {
        lookups(dataOrId: string | { data: CustomerInvoiceHeaderInput }): CustomerInvoiceHeaderExtension$Lookups;
    }
    export interface ProductCategoryExtension {
        _updateUser: SysUser;
        _createUser: SysUser;
        stockSite: Site;
        code: string;
        description: string;
        localizedDescription: string;
        shortDescription: string;
        localizedShortDescription: string;
        isSold: boolean;
        productSequenceNumber: string;
        creationMethod: ProductCreationMode;
        qualityControlManagementMode: SubjectToControl;
        qualityControlAccessCode: string;
        stockUnit: UnitOfMeasure;
        purchaseUnit: UnitOfMeasure;
        salesUnit: UnitOfMeasure;
        statisticUnit: UnitOfMeasure;
        euUnit: UnitOfMeasure;
        purchaseUnitToStockUnitConversionFactor: string;
        salesUnitToStockUnitConversionFactor: string;
        statisticalUnitToStockUnitConversionFactor: string;
        euUnitToStockUnitConversionFactor: string;
        isPurchaseConversionFactorEntryAllowed: boolean;
        isSalesConversionFactorEntryAllowed: boolean;
        weightUnit: UnitOfMeasure;
        stockUnitWeight: string;
        volumeUnit: UnitOfMeasure;
        stockUnitVolume: string;
        labelFormatForStockUnit: GenericPrintReport;
        stockManagementMode: StockManagement;
        managementMode: StandardProductCode;
        isNegativeStockAuthorized: boolean;
        lotSequenceNumber: string;
        serialNumberManagementMode: SerialNumberManagement;
        serialSequenceNumber: string;
        valuationMethod: string;
        expirationManagementMode: ExpirationManagement;
        expirationStockStatus: string;
        userAccessCode: string;
        purchasingPlanningHorizonTimeUnit: LeadTimeUnit;
        purchasingPlanningHorizon: integer;
        purchasingFirmHorizon: integer;
        purchasingFirmHorizonTimeUnit: LeadTimeUnit;
        reorderLeadTime: string;
        buyer: User;
        planner: User;
        purchaseDeliveryTolerance: string;
        isReceived: boolean;
        isMandatoryPurchaseOrderRequest: boolean;
        landedCostCoefficient: string;
        fixedLandedCostPerUnit: string;
        salesPriceOrigin: PriceOrigin;
        percentagePricePurchaseApplied: string;
        configuratorProductLine: string;
        isLocationManaged: boolean;
        salesOrderAllocationRule: string;
        workOrderAllocationRule: string;
        shipmentAllocationRule: string;
        materialConsumptionAllocationRule: string;
        transferAllocationRule: string;
        subcontractReplenishmentAllocationRule: string;
        subcontractConsumptionAllocationRule: string;
        afterSalesAllocationRule: string;
        isStatusAAuthorizedInGlobalAllocation: boolean;
        isStatusQAuthorizedInGlobalAllocation: boolean;
        isStatusRAuthorizedInGlobalAllocation: boolean;
        abcClass: ProductAbcClass;
        stockWithdrawalMode: StockWithdrawal;
        countManagementMode: Count;
        trendProfile: string;
        shrinkagePercent: string;
        planningFirmHorizon: integer;
        planningFirmHorizonTimeUnit: LeadTimeUnit;
        planningRequestHorizon: integer;
        planningRequestHorizonTimeUnit: LeadTimeUnit;
        reorderingPeriodicity: integer;
        reorderingSuggestionType: SuggestionType;
        reorderingSite: Site;
        reorderingPolicy: string;
        stockCoverageInWeeks: integer;
        safetyStock: string;
        reorderingThreshold: string;
        reorderingMaximumStock: string;
        economicOrderQuantity: string;
        technicalLotQuantity: string;
        standardCostUpdate: PriceUpdateMode;
        revisedStandardCostUpdate: PriceUpdateMode;
        budgetStandardCostUpdate: PriceUpdateMode;
        simulatedCostUpdate: PriceUpdateMode;
        isReleasedIfShortage: boolean;
        automaticClosingPercentage: string;
        salesDeliveryTolerance: string;
        salesMinimumQuantity: string;
        salesMaximumQuantity: string;
        isLoanAuthorized: boolean;
        isBackToBackOrderManaged: boolean;
        directBackToBackOrderQuantity: string;
        isPurchased: boolean;
        isManufactured: boolean;
        isSubcontracted: boolean;
        isService: boolean;
        isPhantom: boolean;
        isGeneric: boolean;
        isTool: boolean;
        isDeliverable: boolean;
        isIntermediary: boolean;
        isMaintenance: boolean;
        packagingCapacity: string;
        assignmentRules: string;
        isStockDetailedInPacking: boolean;
        technicalSheet: TechnicalSheet;
        orderWarehouse: string;
        workOrderWarehouse: string;
        shippingWarehouse: string;
        materialConsumptionWarehouse: string;
        internalMovementWarehouse: string;
        subcontractShipmentWarehouse: string;
        subcontractConsumptionWarehouse: string;
        afterSalesWarehouse: string;
        canBeCapitalized: boolean;
        isPackingManaged: boolean;
        sageSalesTax: MiscellaneousTable;
        saftProductType: SafTProductType;
        freightClass: string;
        freightCommodityCode: string;
        isVersionManaged: boolean;
        minorVersionSequence: string;
        majorVersionSequence: string;
        isVersionPreloaded: boolean;
        inventoryProductType: ProductType;
        containerManagement: boolean;
        statisticalGroups: ClientCollection<ProductCategoryStatisticalGroups>;
        costType: CostType;
        lotManagementMode: LotManagementMode;
        traceabilityManagementMode: TraceabilityManagementMode;
        traceabilityLevel: TraceabilityLevel;
        materialCostGroup: MaterialCostGroup;
        reorderingManagementMode: ReorderingManagementMode;
        stockVersionMode: StockVersionMode;
        stockManagementRules: ClientCollection<StockManagementRules>;
        defaultLocations: ClientCollection<ProductCategoryDefaultLocations>;
        overheads: ClientCollection<ProductCategoryOverheads>;
        packingUnits: ClientCollection<ProductCategoryPackingUnits>;
        invoicingTerm: InvoicingTerm;
        taxLevels: ClientCollection<ProductCategoryTaxLevels>;
        accountingCode: AccountingCode;
        dimensions: ClientCollection<ProductCategoryDimensions>;
    }
    export interface ProductCategoryInputExtension {
        stockSite?: string;
        code?: string;
        description?: string;
        localizedDescription?: string;
        shortDescription?: string;
        localizedShortDescription?: string;
        isSold?: boolean | string;
        productSequenceNumber?: string;
        creationMethod?: ProductCreationMode;
        qualityControlManagementMode?: SubjectToControl;
        qualityControlAccessCode?: string;
        stockUnit?: string;
        purchaseUnit?: string;
        salesUnit?: string;
        statisticUnit?: string;
        euUnit?: string;
        purchaseUnitToStockUnitConversionFactor?: decimal | string;
        salesUnitToStockUnitConversionFactor?: decimal | string;
        statisticalUnitToStockUnitConversionFactor?: decimal | string;
        euUnitToStockUnitConversionFactor?: decimal | string;
        isPurchaseConversionFactorEntryAllowed?: boolean | string;
        isSalesConversionFactorEntryAllowed?: boolean | string;
        weightUnit?: string;
        stockUnitWeight?: decimal | string;
        volumeUnit?: string;
        stockUnitVolume?: decimal | string;
        labelFormatForStockUnit?: string;
        stockManagementMode?: StockManagement;
        managementMode?: StandardProductCode;
        isNegativeStockAuthorized?: boolean | string;
        lotSequenceNumber?: string;
        serialNumberManagementMode?: SerialNumberManagement;
        serialSequenceNumber?: string;
        valuationMethod?: string;
        expirationManagementMode?: ExpirationManagement;
        expirationStockStatus?: string;
        userAccessCode?: string;
        purchasingPlanningHorizonTimeUnit?: LeadTimeUnit;
        purchasingPlanningHorizon?: integer | string;
        purchasingFirmHorizon?: integer | string;
        purchasingFirmHorizonTimeUnit?: LeadTimeUnit;
        reorderLeadTime?: decimal | string;
        buyer?: string;
        planner?: string;
        purchaseDeliveryTolerance?: decimal | string;
        isReceived?: boolean | string;
        isMandatoryPurchaseOrderRequest?: boolean | string;
        landedCostCoefficient?: decimal | string;
        fixedLandedCostPerUnit?: decimal | string;
        salesPriceOrigin?: PriceOrigin;
        percentagePricePurchaseApplied?: decimal | string;
        configuratorProductLine?: string;
        isLocationManaged?: boolean | string;
        salesOrderAllocationRule?: string;
        workOrderAllocationRule?: string;
        shipmentAllocationRule?: string;
        materialConsumptionAllocationRule?: string;
        transferAllocationRule?: string;
        subcontractReplenishmentAllocationRule?: string;
        subcontractConsumptionAllocationRule?: string;
        afterSalesAllocationRule?: string;
        isStatusAAuthorizedInGlobalAllocation?: boolean | string;
        isStatusQAuthorizedInGlobalAllocation?: boolean | string;
        isStatusRAuthorizedInGlobalAllocation?: boolean | string;
        abcClass?: ProductAbcClass;
        stockWithdrawalMode?: StockWithdrawal;
        countManagementMode?: Count;
        trendProfile?: string;
        shrinkagePercent?: decimal | string;
        planningFirmHorizon?: integer | string;
        planningFirmHorizonTimeUnit?: LeadTimeUnit;
        planningRequestHorizon?: integer | string;
        planningRequestHorizonTimeUnit?: LeadTimeUnit;
        reorderingPeriodicity?: integer | string;
        reorderingSuggestionType?: SuggestionType;
        reorderingSite?: string;
        reorderingPolicy?: string;
        stockCoverageInWeeks?: integer | string;
        safetyStock?: decimal | string;
        reorderingThreshold?: decimal | string;
        reorderingMaximumStock?: decimal | string;
        economicOrderQuantity?: decimal | string;
        technicalLotQuantity?: decimal | string;
        standardCostUpdate?: PriceUpdateMode;
        revisedStandardCostUpdate?: PriceUpdateMode;
        budgetStandardCostUpdate?: PriceUpdateMode;
        simulatedCostUpdate?: PriceUpdateMode;
        isReleasedIfShortage?: boolean | string;
        automaticClosingPercentage?: decimal | string;
        salesDeliveryTolerance?: decimal | string;
        salesMinimumQuantity?: decimal | string;
        salesMaximumQuantity?: decimal | string;
        isLoanAuthorized?: boolean | string;
        isBackToBackOrderManaged?: boolean | string;
        directBackToBackOrderQuantity?: decimal | string;
        isPurchased?: boolean | string;
        isManufactured?: boolean | string;
        isSubcontracted?: boolean | string;
        isService?: boolean | string;
        isPhantom?: boolean | string;
        isGeneric?: boolean | string;
        isTool?: boolean | string;
        isDeliverable?: boolean | string;
        isIntermediary?: boolean | string;
        isMaintenance?: boolean | string;
        packagingCapacity?: decimal | string;
        assignmentRules?: string;
        isStockDetailedInPacking?: boolean | string;
        technicalSheet?: string;
        orderWarehouse?: string;
        workOrderWarehouse?: string;
        shippingWarehouse?: string;
        materialConsumptionWarehouse?: string;
        internalMovementWarehouse?: string;
        subcontractShipmentWarehouse?: string;
        subcontractConsumptionWarehouse?: string;
        afterSalesWarehouse?: string;
        canBeCapitalized?: boolean | string;
        isPackingManaged?: boolean | string;
        sageSalesTax?: string;
        saftProductType?: SafTProductType;
        freightClass?: string;
        freightCommodityCode?: string;
        isVersionManaged?: boolean | string;
        minorVersionSequence?: string;
        majorVersionSequence?: string;
        isVersionPreloaded?: boolean | string;
        inventoryProductType?: ProductType;
        containerManagement?: boolean | string;
        statisticalGroups?: Partial<ProductCategoryStatisticalGroupsInput>[];
        costType?: string;
        lotManagementMode?: LotManagementMode;
        traceabilityManagementMode?: TraceabilityManagementMode;
        traceabilityLevel?: TraceabilityLevel;
        materialCostGroup?: MaterialCostGroup;
        reorderingManagementMode?: ReorderingManagementMode;
        stockVersionMode?: StockVersionMode;
        stockManagementRules?: Partial<StockManagementRulesInput>[];
        defaultLocations?: Partial<ProductCategoryDefaultLocationsInput>[];
        overheads?: Partial<ProductCategoryOverheadsInput>[];
        packingUnits?: Partial<ProductCategoryPackingUnitsInput>[];
        invoicingTerm?: string;
        taxLevels?: Partial<ProductCategoryTaxLevelsInput>[];
        accountingCode?: string;
        dimensions?: Partial<ProductCategoryDimensionsInput>[];
    }
    export interface ProductCategoryBindingExtension {
        _updateUser: SysUser;
        _createUser: SysUser;
        stockSite: Site;
        code: string;
        description: string;
        localizedDescription: string;
        shortDescription: string;
        localizedShortDescription: string;
        isSold: boolean;
        productSequenceNumber: string;
        creationMethod: ProductCreationMode;
        qualityControlManagementMode: SubjectToControl;
        qualityControlAccessCode: string;
        stockUnit: UnitOfMeasure;
        purchaseUnit: UnitOfMeasure;
        salesUnit: UnitOfMeasure;
        statisticUnit: UnitOfMeasure;
        euUnit: UnitOfMeasure;
        purchaseUnitToStockUnitConversionFactor: string;
        salesUnitToStockUnitConversionFactor: string;
        statisticalUnitToStockUnitConversionFactor: string;
        euUnitToStockUnitConversionFactor: string;
        isPurchaseConversionFactorEntryAllowed: boolean;
        isSalesConversionFactorEntryAllowed: boolean;
        weightUnit: UnitOfMeasure;
        stockUnitWeight: string;
        volumeUnit: UnitOfMeasure;
        stockUnitVolume: string;
        labelFormatForStockUnit: GenericPrintReport;
        stockManagementMode: StockManagement;
        managementMode: StandardProductCode;
        isNegativeStockAuthorized: boolean;
        lotSequenceNumber: string;
        serialNumberManagementMode: SerialNumberManagement;
        serialSequenceNumber: string;
        valuationMethod: string;
        expirationManagementMode: ExpirationManagement;
        expirationStockStatus: string;
        userAccessCode: string;
        purchasingPlanningHorizonTimeUnit: LeadTimeUnit;
        purchasingPlanningHorizon: integer;
        purchasingFirmHorizon: integer;
        purchasingFirmHorizonTimeUnit: LeadTimeUnit;
        reorderLeadTime: string;
        buyer: User;
        planner: User;
        purchaseDeliveryTolerance: string;
        isReceived: boolean;
        isMandatoryPurchaseOrderRequest: boolean;
        landedCostCoefficient: string;
        fixedLandedCostPerUnit: string;
        salesPriceOrigin: PriceOrigin;
        percentagePricePurchaseApplied: string;
        configuratorProductLine: string;
        isLocationManaged: boolean;
        salesOrderAllocationRule: string;
        workOrderAllocationRule: string;
        shipmentAllocationRule: string;
        materialConsumptionAllocationRule: string;
        transferAllocationRule: string;
        subcontractReplenishmentAllocationRule: string;
        subcontractConsumptionAllocationRule: string;
        afterSalesAllocationRule: string;
        isStatusAAuthorizedInGlobalAllocation: boolean;
        isStatusQAuthorizedInGlobalAllocation: boolean;
        isStatusRAuthorizedInGlobalAllocation: boolean;
        abcClass: ProductAbcClass;
        stockWithdrawalMode: StockWithdrawal;
        countManagementMode: Count;
        trendProfile: string;
        shrinkagePercent: string;
        planningFirmHorizon: integer;
        planningFirmHorizonTimeUnit: LeadTimeUnit;
        planningRequestHorizon: integer;
        planningRequestHorizonTimeUnit: LeadTimeUnit;
        reorderingPeriodicity: integer;
        reorderingSuggestionType: SuggestionType;
        reorderingSite: Site;
        reorderingPolicy: string;
        stockCoverageInWeeks: integer;
        safetyStock: string;
        reorderingThreshold: string;
        reorderingMaximumStock: string;
        economicOrderQuantity: string;
        technicalLotQuantity: string;
        standardCostUpdate: PriceUpdateMode;
        revisedStandardCostUpdate: PriceUpdateMode;
        budgetStandardCostUpdate: PriceUpdateMode;
        simulatedCostUpdate: PriceUpdateMode;
        isReleasedIfShortage: boolean;
        automaticClosingPercentage: string;
        salesDeliveryTolerance: string;
        salesMinimumQuantity: string;
        salesMaximumQuantity: string;
        isLoanAuthorized: boolean;
        isBackToBackOrderManaged: boolean;
        directBackToBackOrderQuantity: string;
        isPurchased: boolean;
        isManufactured: boolean;
        isSubcontracted: boolean;
        isService: boolean;
        isPhantom: boolean;
        isGeneric: boolean;
        isTool: boolean;
        isDeliverable: boolean;
        isIntermediary: boolean;
        isMaintenance: boolean;
        packagingCapacity: string;
        assignmentRules: string;
        isStockDetailedInPacking: boolean;
        technicalSheet: TechnicalSheet;
        orderWarehouse: string;
        workOrderWarehouse: string;
        shippingWarehouse: string;
        materialConsumptionWarehouse: string;
        internalMovementWarehouse: string;
        subcontractShipmentWarehouse: string;
        subcontractConsumptionWarehouse: string;
        afterSalesWarehouse: string;
        canBeCapitalized: boolean;
        isPackingManaged: boolean;
        sageSalesTax: MiscellaneousTable;
        saftProductType: SafTProductType;
        freightClass: string;
        freightCommodityCode: string;
        isVersionManaged: boolean;
        minorVersionSequence: string;
        majorVersionSequence: string;
        isVersionPreloaded: boolean;
        inventoryProductType: ProductType;
        containerManagement: boolean;
        statisticalGroups: ClientCollection<ProductCategoryStatisticalGroupsBinding>;
        costType: CostType;
        lotManagementMode: LotManagementMode;
        traceabilityManagementMode: TraceabilityManagementMode;
        traceabilityLevel: TraceabilityLevel;
        materialCostGroup: MaterialCostGroup;
        reorderingManagementMode: ReorderingManagementMode;
        stockVersionMode: StockVersionMode;
        stockManagementRules: ClientCollection<StockManagementRules>;
        defaultLocations: ClientCollection<ProductCategoryDefaultLocationsBinding>;
        overheads: ClientCollection<ProductCategoryOverheadsBinding>;
        packingUnits: ClientCollection<ProductCategoryPackingUnitsBinding>;
        invoicingTerm: InvoicingTerm;
        taxLevels: ClientCollection<ProductCategoryTaxLevelsBinding>;
        accountingCode: AccountingCode;
        dimensions: ClientCollection<ProductCategoryDimensionsBinding>;
    }
    export interface ProductCategoryExtension$Lookups {
        accountingCode: QueryOperation<AccountingCode>;
    }
    export interface ProductCategoryExtension$Operations {
        lookups(dataOrId: string | { data: ProductCategoryInput }): ProductCategoryExtension$Lookups;
    }
    export interface ProductExtension {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        company: Company;
        productCategory: ProductCategory;
        searchKey: string;
        description1: string;
        description2: string;
        description3: string;
        localizedDescription1: string;
        localizedDescription2: string;
        localizedDescription3: string;
        managementMode: StandardProductCode;
        standard: string;
        upc: string;
        productStatus: ProductStatus;
        isPrototype: boolean;
        defaultPotencyInPercentage: string;
        defaultPotencyInInternationalUnit: string;
        serviceLifeStartDate: string;
        serviceLifeEndDate: string;
        storageSheet: string;
        stockUnit: UnitOfMeasure;
        purchaseUnit: UnitOfMeasure;
        salesUnit: UnitOfMeasure;
        statisticalUnit: UnitOfMeasure;
        eeUnit: UnitOfMeasure;
        purchaseUnitToStockUnitConversionFactor: string;
        isPurchaseFactorEntryAllowed: boolean;
        salesUnitToStockUnitConversionFactor: string;
        isSalesFactorEntryAllowed: boolean;
        statisticalUnitToStockUnitConversionFactor: string;
        eeUnitToStockUnitConversionFactor: string;
        weightUnit: UnitOfMeasure;
        productWeight: string;
        volumeUnit: UnitOfMeasure;
        productVolume: string;
        lotSequenceNumber: string;
        serialSequenceNumber: string;
        serialNumberManagementMode: SerialNumberManagement;
        expirationManagementMode: ExpirationManagement;
        expirationStockStatus: string;
        expirationLeadTime: integer;
        checkLeadTime: integer;
        isNegativeStockAuthorized: boolean;
        costGroup: string;
        userAccessCode: Access;
        alternateProduct: Product;
        isIntrastatDeclarationSubmitted: boolean;
        intrastatCommodity: string;
        purchasingPlanningHorizonTimeUnit: LeadTimeUnit;
        purchasingPlanningHorizon: integer;
        purchasingFirmHorizon: integer;
        purchasingFirmHorizonTimeUnit: LeadTimeUnit;
        buyer: User;
        planner: User;
        reorderLeadTime: integer;
        purchaseBasePrice: string;
        landedCostCoefficient: string;
        fixedLandedCostPerUnit: string;
        purchaseDeliveryTolerance: string;
        isReceived: boolean;
        isMandatoryPurchaseOrderRequest: boolean;
        exemptionFlag: string;
        taxFlagStatusLocal: string;
        configuratorProductLine: string;
        configuratorNumericField1: string;
        configuratorNumericField2: string;
        configuratorNumericField3: string;
        configuratorNumericField4: string;
        configuratorNumericField5: string;
        configuratorNumericField6: string;
        configuratorAlphaField1: string;
        configuratorAlphaField2: string;
        configuratorAlphaField3: string;
        configuratorAlphaField4: string;
        configuratorAlphaField5: string;
        configuratorAlphaField6: string;
        configurationJournal: string;
        configuratorBusinessPartner: BusinessPartner;
        configuratorBusinessPartnerReference: string;
        configuratorReferenceProduct: Product;
        configuratorPurgeDate: string;
        isInstalledBaseCreated: boolean;
        voucherCategory: MiscellaneousTable;
        tokensToBeCredited: integer;
        creditUnit: UnitOfMeasure;
        labelFormatForStockUnit: GenericPrintReport;
        bomCodeForAfterSales: BomCodes;
        productTypeForAfterSales: TypeOfProduct;
        isAfterSalesProductIssuedByDefault: boolean;
        daysUnit: UnitOfMeasure;
        hourUnit: UnitOfMeasure;
        minuteUnit: UnitOfMeasure;
        productDensity: string;
        isPurchased: boolean;
        isManufactured: boolean;
        isSubcontracted: boolean;
        isService: boolean;
        isPhantom: boolean;
        isGeneric: boolean;
        isTools: boolean;
        isDeliverable: boolean;
        isSold: boolean;
        isIntermediary: boolean;
        isCapitalized: boolean;
        newStockStatusAfterRecontrol: string;
        useByDateCoefficient: string;
        intrastatFederalStateOrRegion: MiscellaneousTable;
        plmProductReference: string;
        plmLinkedDocuments: string;
        plmProductHistory: string;
        sageSalesTax: MiscellaneousTable;
        allergens: string;
        allergenChangeDate: string;
        allergenBomCode: integer;
        saftProductType: SafTProductType;
        isVersionManaged: boolean;
        minorVersionSequence: string;
        majorVersionSequence: string;
        isVersionPreloaded: boolean;
        productType: ProductType;
        globalTradeItemNumber: string;
        productSites: ClientCollection<ProductSite>;
        supplierProduct: ClientCollection<SupplierProduct>;
        customerProduct: ClientCollection<CustomerProduct>;
        manufacturingText: TextStream;
        picture: BinaryStream;
        purchasingText: TextStream;
        packingUnits: ClientCollection<ProductPackingUnits>;
        statisticalGroups: ClientCollection<ProductStatisticalGroups>;
        costType: CostType;
        stockManagementMode: StockManagement;
        lotManagementMode: LotManagementMode;
        materialCostGroup: MaterialCostGroup;
        traceabilityManagementMode: TraceabilityManagementMode;
        traceabilityLevel: TraceabilityLevel;
        expirationTimeUnit: ExpirationLeadTimeUnits;
        recontrolTimeUnit: ExpirationLeadTimeUnits;
        stockVersionMode: StockVersionMode;
        taxLevels: ClientCollection<ProductTaxLevels>;
        accountingCode: AccountingCode;
        dimensions: ClientCollection<ProductDimensions>;
    }
    export interface ProductInputExtension {
        code?: string;
        company?: string;
        productCategory?: string;
        searchKey?: string;
        description1?: string;
        description2?: string;
        description3?: string;
        localizedDescription1?: string;
        localizedDescription2?: string;
        localizedDescription3?: string;
        managementMode?: StandardProductCode;
        standard?: string;
        upc?: string;
        productStatus?: ProductStatus;
        isPrototype?: boolean | string;
        defaultPotencyInPercentage?: decimal | string;
        defaultPotencyInInternationalUnit?: decimal | string;
        serviceLifeStartDate?: string;
        serviceLifeEndDate?: string;
        storageSheet?: string;
        stockUnit?: string;
        purchaseUnit?: string;
        salesUnit?: string;
        statisticalUnit?: string;
        eeUnit?: string;
        purchaseUnitToStockUnitConversionFactor?: decimal | string;
        isPurchaseFactorEntryAllowed?: boolean | string;
        salesUnitToStockUnitConversionFactor?: decimal | string;
        isSalesFactorEntryAllowed?: boolean | string;
        statisticalUnitToStockUnitConversionFactor?: decimal | string;
        eeUnitToStockUnitConversionFactor?: decimal | string;
        weightUnit?: string;
        productWeight?: decimal | string;
        volumeUnit?: string;
        productVolume?: decimal | string;
        lotSequenceNumber?: string;
        serialSequenceNumber?: string;
        serialNumberManagementMode?: SerialNumberManagement;
        expirationManagementMode?: ExpirationManagement;
        expirationStockStatus?: string;
        expirationLeadTime?: integer | string;
        checkLeadTime?: integer | string;
        isNegativeStockAuthorized?: boolean | string;
        costGroup?: string;
        userAccessCode?: string;
        alternateProduct?: string;
        isIntrastatDeclarationSubmitted?: boolean | string;
        intrastatCommodity?: string;
        purchasingPlanningHorizonTimeUnit?: LeadTimeUnit;
        purchasingPlanningHorizon?: integer | string;
        purchasingFirmHorizon?: integer | string;
        purchasingFirmHorizonTimeUnit?: LeadTimeUnit;
        buyer?: string;
        planner?: string;
        reorderLeadTime?: integer | string;
        purchaseBasePrice?: decimal | string;
        landedCostCoefficient?: decimal | string;
        fixedLandedCostPerUnit?: decimal | string;
        purchaseDeliveryTolerance?: decimal | string;
        isReceived?: boolean | string;
        isMandatoryPurchaseOrderRequest?: boolean | string;
        exemptionFlag?: string;
        taxFlagStatusLocal?: string;
        configuratorProductLine?: string;
        configuratorNumericField1?: decimal | string;
        configuratorNumericField2?: decimal | string;
        configuratorNumericField3?: decimal | string;
        configuratorNumericField4?: decimal | string;
        configuratorNumericField5?: decimal | string;
        configuratorNumericField6?: decimal | string;
        configuratorAlphaField1?: string;
        configuratorAlphaField2?: string;
        configuratorAlphaField3?: string;
        configuratorAlphaField4?: string;
        configuratorAlphaField5?: string;
        configuratorAlphaField6?: string;
        configurationJournal?: string;
        configuratorBusinessPartner?: string;
        configuratorBusinessPartnerReference?: string;
        configuratorReferenceProduct?: string;
        configuratorPurgeDate?: string;
        isInstalledBaseCreated?: boolean | string;
        voucherCategory?: string;
        tokensToBeCredited?: integer | string;
        creditUnit?: string;
        labelFormatForStockUnit?: string;
        bomCodeForAfterSales?: integer | string;
        productTypeForAfterSales?: TypeOfProduct;
        isAfterSalesProductIssuedByDefault?: boolean | string;
        daysUnit?: string;
        hourUnit?: string;
        minuteUnit?: string;
        productDensity?: decimal | string;
        isPurchased?: boolean | string;
        isManufactured?: boolean | string;
        isSubcontracted?: boolean | string;
        isService?: boolean | string;
        isPhantom?: boolean | string;
        isGeneric?: boolean | string;
        isTools?: boolean | string;
        isDeliverable?: boolean | string;
        isSold?: boolean | string;
        isIntermediary?: boolean | string;
        isCapitalized?: boolean | string;
        newStockStatusAfterRecontrol?: string;
        useByDateCoefficient?: decimal | string;
        intrastatFederalStateOrRegion?: string;
        plmProductReference?: string;
        plmLinkedDocuments?: string;
        plmProductHistory?: string;
        sageSalesTax?: string;
        allergens?: string;
        allergenChangeDate?: string;
        allergenBomCode?: integer | string;
        saftProductType?: SafTProductType;
        isVersionManaged?: boolean | string;
        minorVersionSequence?: string;
        majorVersionSequence?: string;
        isVersionPreloaded?: boolean | string;
        productType?: ProductType;
        globalTradeItemNumber?: string;
        supplierProduct?: Partial<SupplierProductInput>[];
        customerProduct?: Partial<CustomerProductInput>[];
        manufacturingText?: TextStream;
        picture?: BinaryStream;
        purchasingText?: TextStream;
        packingUnits?: Partial<ProductPackingUnitsInput>[];
        statisticalGroups?: Partial<ProductStatisticalGroupsInput>[];
        costType?: string;
        stockManagementMode?: StockManagement;
        lotManagementMode?: LotManagementMode;
        materialCostGroup?: MaterialCostGroup;
        traceabilityManagementMode?: TraceabilityManagementMode;
        traceabilityLevel?: TraceabilityLevel;
        expirationTimeUnit?: ExpirationLeadTimeUnits;
        recontrolTimeUnit?: ExpirationLeadTimeUnits;
        stockVersionMode?: StockVersionMode;
        taxLevels?: Partial<ProductTaxLevelsInput>[];
        accountingCode?: string;
        dimensions?: Partial<ProductDimensionsInput>[];
    }
    export interface ProductBindingExtension {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        company: Company;
        productCategory: ProductCategory;
        searchKey: string;
        description1: string;
        description2: string;
        description3: string;
        localizedDescription1: string;
        localizedDescription2: string;
        localizedDescription3: string;
        managementMode: StandardProductCode;
        standard: string;
        upc: string;
        productStatus: ProductStatus;
        isPrototype: boolean;
        defaultPotencyInPercentage: string;
        defaultPotencyInInternationalUnit: string;
        serviceLifeStartDate: string;
        serviceLifeEndDate: string;
        storageSheet: string;
        stockUnit: UnitOfMeasure;
        purchaseUnit: UnitOfMeasure;
        salesUnit: UnitOfMeasure;
        statisticalUnit: UnitOfMeasure;
        eeUnit: UnitOfMeasure;
        purchaseUnitToStockUnitConversionFactor: string;
        isPurchaseFactorEntryAllowed: boolean;
        salesUnitToStockUnitConversionFactor: string;
        isSalesFactorEntryAllowed: boolean;
        statisticalUnitToStockUnitConversionFactor: string;
        eeUnitToStockUnitConversionFactor: string;
        weightUnit: UnitOfMeasure;
        productWeight: string;
        volumeUnit: UnitOfMeasure;
        productVolume: string;
        lotSequenceNumber: string;
        serialSequenceNumber: string;
        serialNumberManagementMode: SerialNumberManagement;
        expirationManagementMode: ExpirationManagement;
        expirationStockStatus: string;
        expirationLeadTime: integer;
        checkLeadTime: integer;
        isNegativeStockAuthorized: boolean;
        costGroup: string;
        userAccessCode: Access;
        alternateProduct: Product;
        isIntrastatDeclarationSubmitted: boolean;
        intrastatCommodity: string;
        purchasingPlanningHorizonTimeUnit: LeadTimeUnit;
        purchasingPlanningHorizon: integer;
        purchasingFirmHorizon: integer;
        purchasingFirmHorizonTimeUnit: LeadTimeUnit;
        buyer: User;
        planner: User;
        reorderLeadTime: integer;
        purchaseBasePrice: string;
        landedCostCoefficient: string;
        fixedLandedCostPerUnit: string;
        purchaseDeliveryTolerance: string;
        isReceived: boolean;
        isMandatoryPurchaseOrderRequest: boolean;
        exemptionFlag: string;
        taxFlagStatusLocal: string;
        configuratorProductLine: string;
        configuratorNumericField1: string;
        configuratorNumericField2: string;
        configuratorNumericField3: string;
        configuratorNumericField4: string;
        configuratorNumericField5: string;
        configuratorNumericField6: string;
        configuratorAlphaField1: string;
        configuratorAlphaField2: string;
        configuratorAlphaField3: string;
        configuratorAlphaField4: string;
        configuratorAlphaField5: string;
        configuratorAlphaField6: string;
        configurationJournal: string;
        configuratorBusinessPartner: BusinessPartner;
        configuratorBusinessPartnerReference: string;
        configuratorReferenceProduct: Product;
        configuratorPurgeDate: string;
        isInstalledBaseCreated: boolean;
        voucherCategory: MiscellaneousTable;
        tokensToBeCredited: integer;
        creditUnit: UnitOfMeasure;
        labelFormatForStockUnit: GenericPrintReport;
        bomCodeForAfterSales: BomCodes;
        productTypeForAfterSales: TypeOfProduct;
        isAfterSalesProductIssuedByDefault: boolean;
        daysUnit: UnitOfMeasure;
        hourUnit: UnitOfMeasure;
        minuteUnit: UnitOfMeasure;
        productDensity: string;
        isPurchased: boolean;
        isManufactured: boolean;
        isSubcontracted: boolean;
        isService: boolean;
        isPhantom: boolean;
        isGeneric: boolean;
        isTools: boolean;
        isDeliverable: boolean;
        isSold: boolean;
        isIntermediary: boolean;
        isCapitalized: boolean;
        newStockStatusAfterRecontrol: string;
        useByDateCoefficient: string;
        intrastatFederalStateOrRegion: MiscellaneousTable;
        plmProductReference: string;
        plmLinkedDocuments: string;
        plmProductHistory: string;
        sageSalesTax: MiscellaneousTable;
        allergens: string;
        allergenChangeDate: string;
        allergenBomCode: integer;
        saftProductType: SafTProductType;
        isVersionManaged: boolean;
        minorVersionSequence: string;
        majorVersionSequence: string;
        isVersionPreloaded: boolean;
        productType: ProductType;
        globalTradeItemNumber: string;
        productSites: ClientCollection<ProductSite>;
        supplierProduct: ClientCollection<SupplierProduct>;
        customerProduct: ClientCollection<CustomerProduct>;
        manufacturingText: TextStream;
        picture: BinaryStream;
        purchasingText: TextStream;
        packingUnits: ClientCollection<ProductPackingUnitsBinding>;
        statisticalGroups: ClientCollection<ProductStatisticalGroupsBinding>;
        costType: CostType;
        stockManagementMode: StockManagement;
        lotManagementMode: LotManagementMode;
        materialCostGroup: MaterialCostGroup;
        traceabilityManagementMode: TraceabilityManagementMode;
        traceabilityLevel: TraceabilityLevel;
        expirationTimeUnit: ExpirationLeadTimeUnits;
        recontrolTimeUnit: ExpirationLeadTimeUnits;
        stockVersionMode: StockVersionMode;
        taxLevels: ClientCollection<ProductTaxLevelsBinding>;
        accountingCode: AccountingCode;
        dimensions: ClientCollection<ProductDimensionsBinding>;
    }
    export interface ProductExtension$Lookups {
        accountingCode: QueryOperation<AccountingCode>;
    }
    export interface ProductExtension$Operations {
        lookups(dataOrId: string | { data: ProductInput }): ProductExtension$Lookups;
    }
    export interface StockJournalExtension {
        _updateUser: SysUser;
        _createUser: SysUser;
        stockSite: Site;
        isUpdated: boolean;
        product: Product;
        effectiveDate: string;
        sequence: integer;
        index: integer;
        fifoDate: string;
        fifoTime: string;
        fifoTier: string;
        owner: string;
        lot: string;
        sublot: string;
        supplierLot: string;
        location: Location;
        warehouse: Warehouse;
        serialNumber: string;
        transactionType: StockTransactionType;
        stockMovementGroup: MiscellaneousTable;
        movementDescription: string;
        project: ProjectLink;
        businessPartner: BusinessPartner;
        documentType: EntryTypeEnum;
        documentId: string;
        documentLine: integer;
        documentTypeOriginal: EntryTypeEnum;
        documentIdOriginal: string;
        documentLineOriginal: integer;
        documentSequenceOriginal: integer;
        adjustementType: EntryTypeEnum;
        adjustementDocumentId: string;
        adjustementDocumentLineId: integer;
        lotCustomField1: string;
        lotCustomField2: string;
        lotCustomField3: string;
        lotCustomField4: string;
        packingUnit: UnitOfMeasure;
        quantityInPackingUnit: string;
        packingUnitToStockUnitConversionFactor: string;
        quantityInStockUnit: string;
        stockUnit: UnitOfMeasure;
        orginialPackingUnit: UnitOfMeasure;
        originalPackingUnitToStockUnitConversionFactor: string;
        orderAmount: string;
        movementValue: string;
        orderVariance: string;
        movementVariance: string;
        orderCost: string;
        valuedCost: string;
        costSource: CostSource;
        secondaryMovementValue: string;
        secondaryMovementVariance: string;
        secondaryValuedCost: string;
        secondaryCostSource: CostSource;
        isAdjusted: boolean;
        varianceNotAbsorbed: string;
        secondaryVarianceNotAbsorbed: string;
        expirationDate: string;
        status: StockStatus;
        potency: string;
        internationalUnitPotency: string;
        activQuantity: string;
        qualityAnalysisRequestId: string;
        isPrinted: boolean;
        isAdjustedMovement: boolean;
        labelFormat: GenericPrintReport;
        numberOfLabels: integer;
        financialSite: Site;
        hasStockInterfacePosted: boolean;
        hasStockAccountingPosted: boolean;
        hasStockAccountingPostedSecondary: boolean;
        identifier1: string;
        identifier2: string;
        intercompany: boolean;
        useByDate: string;
        recontrolDate: string;
        accountingDate: string;
        majorVersion: MajorVersionStatus;
        minorVersion: string;
        startingSerialNumber: string;
        stockCustomField1: string;
        endingSerialNumber: string;
        stockCustomField2: string;
        licensePlateNumber: LicensePlateNumber;
        stockAutomaticJournal: AutomaticJournal;
        journalEntryDocumentType: string;
        dimensions: ClientCollection<StockJournalDimensions>;
    }
    export interface StockJournalInputExtension {
        stockSite?: string;
        isUpdated?: boolean | string;
        product?: string;
        effectiveDate?: string;
        sequence?: integer | string;
        index?: integer | string;
        fifoDate?: string;
        fifoTime?: string;
        fifoTier?: decimal | string;
        owner?: string;
        lot?: string;
        sublot?: string;
        supplierLot?: string;
        location?: string;
        warehouse?: string;
        serialNumber?: string;
        transactionType?: StockTransactionType;
        stockMovementGroup?: string;
        movementDescription?: string;
        project?: string;
        businessPartner?: string;
        documentType?: EntryTypeEnum;
        documentId?: string;
        documentLine?: integer | string;
        documentTypeOriginal?: EntryTypeEnum;
        documentIdOriginal?: string;
        documentLineOriginal?: integer | string;
        documentSequenceOriginal?: integer | string;
        adjustementType?: EntryTypeEnum;
        adjustementDocumentId?: string;
        adjustementDocumentLineId?: integer | string;
        lotCustomField1?: string;
        lotCustomField2?: string;
        lotCustomField3?: decimal | string;
        lotCustomField4?: string;
        packingUnit?: string;
        quantityInPackingUnit?: decimal | string;
        packingUnitToStockUnitConversionFactor?: decimal | string;
        quantityInStockUnit?: decimal | string;
        stockUnit?: string;
        orginialPackingUnit?: string;
        originalPackingUnitToStockUnitConversionFactor?: decimal | string;
        orderAmount?: decimal | string;
        movementValue?: decimal | string;
        orderVariance?: decimal | string;
        movementVariance?: decimal | string;
        orderCost?: decimal | string;
        valuedCost?: decimal | string;
        costSource?: CostSource;
        secondaryMovementValue?: decimal | string;
        secondaryMovementVariance?: decimal | string;
        secondaryValuedCost?: decimal | string;
        secondaryCostSource?: CostSource;
        isAdjusted?: boolean | string;
        varianceNotAbsorbed?: decimal | string;
        secondaryVarianceNotAbsorbed?: decimal | string;
        expirationDate?: string;
        status?: string;
        potency?: decimal | string;
        internationalUnitPotency?: decimal | string;
        activQuantity?: decimal | string;
        qualityAnalysisRequestId?: string;
        isPrinted?: boolean | string;
        isAdjustedMovement?: boolean | string;
        labelFormat?: string;
        numberOfLabels?: integer | string;
        financialSite?: string;
        hasStockInterfacePosted?: boolean | string;
        hasStockAccountingPosted?: boolean | string;
        hasStockAccountingPostedSecondary?: boolean | string;
        identifier1?: string;
        identifier2?: string;
        intercompany?: boolean | string;
        useByDate?: string;
        recontrolDate?: string;
        accountingDate?: string;
        majorVersion?: string;
        minorVersion?: string;
        startingSerialNumber?: string;
        stockCustomField1?: string;
        endingSerialNumber?: string;
        stockCustomField2?: string;
        licensePlateNumber?: string;
        stockAutomaticJournal?: string;
        journalEntryDocumentType?: string;
        dimensions?: Partial<StockJournalDimensionsInput>[];
    }
    export interface StockJournalBindingExtension {
        _updateUser: SysUser;
        _createUser: SysUser;
        stockSite: Site;
        isUpdated: boolean;
        product: Product;
        effectiveDate: string;
        sequence: integer;
        index: integer;
        fifoDate: string;
        fifoTime: string;
        fifoTier: string;
        owner: string;
        lot: string;
        sublot: string;
        supplierLot: string;
        location: Location;
        warehouse: Warehouse;
        serialNumber: string;
        transactionType: StockTransactionType;
        stockMovementGroup: MiscellaneousTable;
        movementDescription: string;
        project: ProjectLink;
        businessPartner: BusinessPartner;
        documentType: EntryTypeEnum;
        documentId: string;
        documentLine: integer;
        documentTypeOriginal: EntryTypeEnum;
        documentIdOriginal: string;
        documentLineOriginal: integer;
        documentSequenceOriginal: integer;
        adjustementType: EntryTypeEnum;
        adjustementDocumentId: string;
        adjustementDocumentLineId: integer;
        lotCustomField1: string;
        lotCustomField2: string;
        lotCustomField3: string;
        lotCustomField4: string;
        packingUnit: UnitOfMeasure;
        quantityInPackingUnit: string;
        packingUnitToStockUnitConversionFactor: string;
        quantityInStockUnit: string;
        stockUnit: UnitOfMeasure;
        orginialPackingUnit: UnitOfMeasure;
        originalPackingUnitToStockUnitConversionFactor: string;
        orderAmount: string;
        movementValue: string;
        orderVariance: string;
        movementVariance: string;
        orderCost: string;
        valuedCost: string;
        costSource: CostSource;
        secondaryMovementValue: string;
        secondaryMovementVariance: string;
        secondaryValuedCost: string;
        secondaryCostSource: CostSource;
        isAdjusted: boolean;
        varianceNotAbsorbed: string;
        secondaryVarianceNotAbsorbed: string;
        expirationDate: string;
        status: StockStatus;
        potency: string;
        internationalUnitPotency: string;
        activQuantity: string;
        qualityAnalysisRequestId: string;
        isPrinted: boolean;
        isAdjustedMovement: boolean;
        labelFormat: GenericPrintReport;
        numberOfLabels: integer;
        financialSite: Site;
        hasStockInterfacePosted: boolean;
        hasStockAccountingPosted: boolean;
        hasStockAccountingPostedSecondary: boolean;
        identifier1: string;
        identifier2: string;
        intercompany: boolean;
        useByDate: string;
        recontrolDate: string;
        accountingDate: string;
        majorVersion: MajorVersionStatus;
        minorVersion: string;
        startingSerialNumber: string;
        stockCustomField1: string;
        endingSerialNumber: string;
        stockCustomField2: string;
        licensePlateNumber: LicensePlateNumber;
        stockAutomaticJournal: AutomaticJournal;
        journalEntryDocumentType: string;
        dimensions: ClientCollection<StockJournalDimensionsBinding>;
    }
    export interface StockJournalExtension$Lookups {
        stockAutomaticJournal: QueryOperation<AutomaticJournal>;
    }
    export interface StockJournalExtension$Operations {
        lookups(dataOrId: string | { data: StockJournalInput }): StockJournalExtension$Lookups;
    }
    export interface StockJournalImportExtension {
        _updateUser: SysUser;
        _createUser: SysUser;
        stockSite: Site;
        isUpdated: boolean;
        product: Product;
        effectiveDate: string;
        sequence: integer;
        index: integer;
        fifoDate: string;
        fifoTime: string;
        fifoTier: string;
        owner: string;
        lot: string;
        sublot: string;
        supplierLot: string;
        location: Location;
        warehouse: Warehouse;
        serialNumber: string;
        transactionType: StockTransactionType;
        stockMovementGroup: MiscellaneousTable;
        movementDescription: string;
        project: ProjectLink;
        businessPartner: BusinessPartner;
        documentType: EntryTypeEnum;
        documentId: string;
        documentLine: integer;
        documentTypeOriginal: EntryTypeEnum;
        documentIdOriginal: string;
        documentLineOriginal: integer;
        documentSequenceOriginal: integer;
        adjustementType: EntryTypeEnum;
        adjustementDocumentId: string;
        adjustementDocumentLineId: integer;
        lotCustomField1: string;
        lotCustomField2: string;
        lotCustomField3: string;
        lotCustomField4: string;
        packingUnit: UnitOfMeasure;
        quantityInPackingUnit: string;
        packingUnitToStockUnitConversionFactor: string;
        quantityInStockUnit: string;
        stockUnit: UnitOfMeasure;
        orginialPackingUnit: UnitOfMeasure;
        originalPackingUnitToStockUnitConversionFactor: string;
        orderAmount: string;
        movementValue: string;
        orderVariance: string;
        movementVariance: string;
        orderCost: string;
        valuedCost: string;
        costSource: CostSource;
        secondaryMovementValue: string;
        secondaryMovementVariance: string;
        secondaryValuedCost: string;
        secondaryCostSource: CostSource;
        isAdjusted: boolean;
        varianceNotAbsorbed: string;
        secondaryVarianceNotAbsorbed: string;
        expirationDate: string;
        status: StockStatus;
        potency: string;
        internationalUnitPotency: string;
        activQuantity: string;
        qualityAnalysisRequestId: string;
        isPrinted: boolean;
        isAdjustedMovement: boolean;
        labelFormat: GenericPrintReport;
        numberOfLabels: integer;
        financialSite: Site;
        hasStockInterfacePosted: boolean;
        hasStockAccountingPosted: boolean;
        hasStockAccountingPostedSecondary: boolean;
        identifier1: string;
        identifier2: string;
        intercompany: boolean;
        useByDate: string;
        recontrolDate: string;
        accountingDate: string;
        majorVersion: MajorVersionStatus;
        minorVersion: string;
        startingSerialNumber: string;
        stockCustomField1: string;
        endingSerialNumber: string;
        stockCustomField2: string;
        licensePlateNumber: LicensePlateNumber;
        stockAutomaticJournal: AutomaticJournal;
        journalEntryDocumentType: string;
        dimensions: ClientCollection<StockJournalImportDimensions>;
    }
    export interface StockJournalImportInputExtension {
        stockSite?: string;
        isUpdated?: boolean | string;
        product?: string;
        effectiveDate?: string;
        sequence?: integer | string;
        index?: integer | string;
        fifoDate?: string;
        fifoTime?: string;
        fifoTier?: decimal | string;
        owner?: string;
        lot?: string;
        sublot?: string;
        supplierLot?: string;
        location?: string;
        warehouse?: string;
        serialNumber?: string;
        transactionType?: StockTransactionType;
        stockMovementGroup?: string;
        movementDescription?: string;
        project?: string;
        businessPartner?: string;
        documentType?: EntryTypeEnum;
        documentId?: string;
        documentLine?: integer | string;
        documentTypeOriginal?: EntryTypeEnum;
        documentIdOriginal?: string;
        documentLineOriginal?: integer | string;
        documentSequenceOriginal?: integer | string;
        adjustementType?: EntryTypeEnum;
        adjustementDocumentId?: string;
        adjustementDocumentLineId?: integer | string;
        lotCustomField1?: string;
        lotCustomField2?: string;
        lotCustomField3?: decimal | string;
        lotCustomField4?: string;
        packingUnit?: string;
        quantityInPackingUnit?: decimal | string;
        packingUnitToStockUnitConversionFactor?: decimal | string;
        quantityInStockUnit?: decimal | string;
        stockUnit?: string;
        orginialPackingUnit?: string;
        originalPackingUnitToStockUnitConversionFactor?: decimal | string;
        orderAmount?: decimal | string;
        movementValue?: decimal | string;
        orderVariance?: decimal | string;
        movementVariance?: decimal | string;
        orderCost?: decimal | string;
        valuedCost?: decimal | string;
        costSource?: CostSource;
        secondaryMovementValue?: decimal | string;
        secondaryMovementVariance?: decimal | string;
        secondaryValuedCost?: decimal | string;
        secondaryCostSource?: CostSource;
        isAdjusted?: boolean | string;
        varianceNotAbsorbed?: decimal | string;
        secondaryVarianceNotAbsorbed?: decimal | string;
        expirationDate?: string;
        status?: string;
        potency?: decimal | string;
        internationalUnitPotency?: decimal | string;
        activQuantity?: decimal | string;
        qualityAnalysisRequestId?: string;
        isPrinted?: boolean | string;
        isAdjustedMovement?: boolean | string;
        labelFormat?: string;
        numberOfLabels?: integer | string;
        financialSite?: string;
        hasStockInterfacePosted?: boolean | string;
        hasStockAccountingPosted?: boolean | string;
        hasStockAccountingPostedSecondary?: boolean | string;
        identifier1?: string;
        identifier2?: string;
        intercompany?: boolean | string;
        useByDate?: string;
        recontrolDate?: string;
        accountingDate?: string;
        majorVersion?: string;
        minorVersion?: string;
        startingSerialNumber?: string;
        stockCustomField1?: string;
        endingSerialNumber?: string;
        stockCustomField2?: string;
        licensePlateNumber?: string;
        expirationDateString?: string;
        stockAutomaticJournal?: string;
        journalEntryDocumentType?: string;
        dimensions?: Partial<StockJournalImportDimensionsInput>[];
    }
    export interface StockJournalImportBindingExtension {
        _updateUser: SysUser;
        _createUser: SysUser;
        stockSite: Site;
        isUpdated: boolean;
        product: Product;
        effectiveDate: string;
        sequence: integer;
        index: integer;
        fifoDate: string;
        fifoTime: string;
        fifoTier: string;
        owner: string;
        lot: string;
        sublot: string;
        supplierLot: string;
        location: Location;
        warehouse: Warehouse;
        serialNumber: string;
        transactionType: StockTransactionType;
        stockMovementGroup: MiscellaneousTable;
        movementDescription: string;
        project: ProjectLink;
        businessPartner: BusinessPartner;
        documentType: EntryTypeEnum;
        documentId: string;
        documentLine: integer;
        documentTypeOriginal: EntryTypeEnum;
        documentIdOriginal: string;
        documentLineOriginal: integer;
        documentSequenceOriginal: integer;
        adjustementType: EntryTypeEnum;
        adjustementDocumentId: string;
        adjustementDocumentLineId: integer;
        lotCustomField1: string;
        lotCustomField2: string;
        lotCustomField3: string;
        lotCustomField4: string;
        packingUnit: UnitOfMeasure;
        quantityInPackingUnit: string;
        packingUnitToStockUnitConversionFactor: string;
        quantityInStockUnit: string;
        stockUnit: UnitOfMeasure;
        orginialPackingUnit: UnitOfMeasure;
        originalPackingUnitToStockUnitConversionFactor: string;
        orderAmount: string;
        movementValue: string;
        orderVariance: string;
        movementVariance: string;
        orderCost: string;
        valuedCost: string;
        costSource: CostSource;
        secondaryMovementValue: string;
        secondaryMovementVariance: string;
        secondaryValuedCost: string;
        secondaryCostSource: CostSource;
        isAdjusted: boolean;
        varianceNotAbsorbed: string;
        secondaryVarianceNotAbsorbed: string;
        expirationDate: string;
        status: StockStatus;
        potency: string;
        internationalUnitPotency: string;
        activQuantity: string;
        qualityAnalysisRequestId: string;
        isPrinted: boolean;
        isAdjustedMovement: boolean;
        labelFormat: GenericPrintReport;
        numberOfLabels: integer;
        financialSite: Site;
        hasStockInterfacePosted: boolean;
        hasStockAccountingPosted: boolean;
        hasStockAccountingPostedSecondary: boolean;
        identifier1: string;
        identifier2: string;
        intercompany: boolean;
        useByDate: string;
        recontrolDate: string;
        accountingDate: string;
        majorVersion: MajorVersionStatus;
        minorVersion: string;
        startingSerialNumber: string;
        stockCustomField1: string;
        endingSerialNumber: string;
        stockCustomField2: string;
        licensePlateNumber: LicensePlateNumber;
        expirationDateString: string;
        stockAutomaticJournal: AutomaticJournal;
        journalEntryDocumentType: string;
        dimensions: ClientCollection<StockJournalImportDimensionsBinding>;
    }
    export interface StockJournalImportExtension$Lookups {
        stockAutomaticJournal: QueryOperation<AutomaticJournal>;
    }
    export interface StockJournalImportExtension$Operations {
        lookups(dataOrId: string | { data: StockJournalImportInput }): StockJournalImportExtension$Lookups;
    }
    export interface SupplierExtension {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: BusinessPartner;
        category: SupplierCategory;
        payToBusinessPartner: BusinessPartner;
        payToBusinessPartnerAddress: BusinessPartnerAddress;
        billBySupplier: Supplier;
        billBySupplierAddress: SupplierAddress;
        groupSupplier: Supplier;
        riskSupplier: Supplier;
        ourCustomerNumberForSupplier: string;
        carrier: Carrier;
        defaultContact: SupplierContact;
        location: string;
        supplierABCClass: ProductAbcClass;
        rateType: ExchangeRateType;
        incoterm: Incoterm;
        intrastatTransportLocation: CountryLocation;
        addressByDefault: SupplierAddress;
        isMultiLineOrder: boolean;
        leadTimeRankingCoefficient: string;
        priceRankingCoefficient: string;
        qualityRankingCoefficient: string;
        quantityRankingCoefficient: string;
        freeRankingCoefficient: string;
        leadTimeRanking: string;
        priceRanking: string;
        qualityRanking: string;
        quantityRanking: string;
        freeRanking: string;
        totalRanking: string;
        creditControl: WorkInProgressControl;
        intrastatIncreaseCoefficient: string;
        mustRemindDelivery: boolean;
        mustRemindAcknowledgment: boolean;
        isDas2Submitted: boolean;
        isActive: boolean;
        isPaymentHeld: boolean;
        mustPrintOrderForm: boolean;
        mustPrintReceiptNote: boolean;
        mustPrintReturnSlip: boolean;
        ourCustomerNameForSupplier: string;
        is281Submitted: boolean;
        amountType: PriceAmountTaxTax;
        isCashVat: boolean;
        cashVatDeadline: string;
        selfBillingCode: string;
        rexNumber: string;
        hasNoWhiteListVerification: boolean;
        isElectronicInvoicingAllowed: boolean;
        contact: SupplierContact;
        startDateForElectronicInvoice: string;
        addresses: ClientCollection<SupplierAddress>;
        contacts: ClientCollection<SupplierContact>;
        acronym: string;
        businessPartnerSite: Site;
        cfonbPaymentMethod: MiscellaneousTable;
        companyName1: string;
        companyName2: string;
        companyNames: ClientCollection<BusinessPartnerCompanyNames>;
        consolidationCode: string;
        consolidationGroup: SiteGroupings;
        consolidationPartner: BusinessPartner;
        country: Country;
        customerOrSupplierOriginCategory: string;
        documentType: DocumentType;
        economicOperatorRegistrationAndIdNumber: string;
        europeanUnionVatNumber: string;
        fiscalCode: string;
        isCashExcluded: boolean;
        isIntersite: boolean;
        isMailingProhibited: boolean;
        isPhysicalPerson: boolean;
        isPublicSector: boolean;
        isServiceCaller: boolean;
        isServiceSupplier: boolean;
        italianTaxNumber: string;
        language: Language;
        nonResidentAccount: BusinessPartnerAddress;
        purchaseOrderText: TextStream;
        registrationNumber: string;
        relatedCompany: RelatedCompanySettings;
        reportAccessCode: Access;
        returnOrderText: TextStream;
        shortCompanyName: string;
        siteIdentificationNumber: string;
        standardIndustrialClassificationCode: string;
        vatNumber: string;
        paymentTerm: PaymentTerm;
        earlyDiscountOrLateCharge: EarlyDiscountLateCharge;
        taxRule: TaxRule;
        accountingCode: AccountingCode;
    }
    export interface SupplierInputExtension {
        code?: string;
        category?: string;
        payToBusinessPartner?: string;
        payToBusinessPartnerAddress?: string;
        billBySupplier?: string;
        billBySupplierAddress?: string;
        groupSupplier?: string;
        riskSupplier?: string;
        ourCustomerNumberForSupplier?: string;
        carrier?: string;
        defaultContact?: string;
        location?: string;
        supplierABCClass?: ProductAbcClass;
        rateType?: ExchangeRateType;
        incoterm?: string;
        intrastatTransportLocation?: CountryLocation;
        addressByDefault?: string;
        isMultiLineOrder?: boolean | string;
        leadTimeRankingCoefficient?: decimal | string;
        priceRankingCoefficient?: decimal | string;
        qualityRankingCoefficient?: decimal | string;
        quantityRankingCoefficient?: decimal | string;
        freeRankingCoefficient?: decimal | string;
        leadTimeRanking?: decimal | string;
        priceRanking?: decimal | string;
        qualityRanking?: decimal | string;
        quantityRanking?: decimal | string;
        freeRanking?: decimal | string;
        totalRanking?: decimal | string;
        creditControl?: WorkInProgressControl;
        intrastatIncreaseCoefficient?: decimal | string;
        mustRemindDelivery?: boolean | string;
        mustRemindAcknowledgment?: boolean | string;
        isDas2Submitted?: boolean | string;
        isActive?: boolean | string;
        isPaymentHeld?: boolean | string;
        mustPrintOrderForm?: boolean | string;
        mustPrintReceiptNote?: boolean | string;
        mustPrintReturnSlip?: boolean | string;
        ourCustomerNameForSupplier?: string;
        is281Submitted?: boolean | string;
        amountType?: PriceAmountTaxTax;
        isCashVat?: boolean | string;
        cashVatDeadline?: string;
        selfBillingCode?: string;
        rexNumber?: string;
        hasNoWhiteListVerification?: boolean | string;
        isElectronicInvoicingAllowed?: boolean | string;
        contact?: string;
        startDateForElectronicInvoice?: string;
        addresses?: Partial<SupplierAddressInput>[];
        contacts?: Partial<SupplierContactInput>[];
        acronym?: string;
        businessPartnerSite?: string;
        cfonbPaymentMethod?: string;
        companyName1?: string;
        companyName2?: string;
        companyNames?: Partial<BusinessPartnerCompanyNamesInput>[];
        consolidationCode?: string;
        consolidationGroup?: string;
        consolidationPartner?: string;
        country?: string;
        customerOrSupplierOriginCategory?: string;
        documentType?: DocumentType;
        economicOperatorRegistrationAndIdNumber?: string;
        europeanUnionVatNumber?: string;
        fiscalCode?: string;
        isCashExcluded?: boolean | string;
        isIntersite?: boolean | string;
        isMailingProhibited?: boolean | string;
        isPhysicalPerson?: boolean | string;
        isPublicSector?: boolean | string;
        isServiceCaller?: boolean | string;
        isServiceSupplier?: boolean | string;
        italianTaxNumber?: string;
        language?: string;
        nonResidentAccount?: string;
        purchaseOrderText?: TextStream;
        registrationNumber?: string;
        relatedCompany?: RelatedCompanySettings;
        reportAccessCode?: string;
        returnOrderText?: TextStream;
        shortCompanyName?: string;
        siteIdentificationNumber?: string;
        standardIndustrialClassificationCode?: string;
        vatNumber?: string;
        paymentTerm?: string;
        earlyDiscountOrLateCharge?: string;
        taxRule?: string;
        accountingCode?: string;
    }
    export interface SupplierBindingExtension {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: BusinessPartner;
        category: SupplierCategory;
        payToBusinessPartner: BusinessPartner;
        payToBusinessPartnerAddress: BusinessPartnerAddress;
        billBySupplier: Supplier;
        billBySupplierAddress: SupplierAddress;
        groupSupplier: Supplier;
        riskSupplier: Supplier;
        ourCustomerNumberForSupplier: string;
        carrier: Carrier;
        defaultContact: SupplierContact;
        location: string;
        supplierABCClass: ProductAbcClass;
        rateType: ExchangeRateType;
        incoterm: Incoterm;
        intrastatTransportLocation: CountryLocation;
        addressByDefault: SupplierAddress;
        isMultiLineOrder: boolean;
        leadTimeRankingCoefficient: string;
        priceRankingCoefficient: string;
        qualityRankingCoefficient: string;
        quantityRankingCoefficient: string;
        freeRankingCoefficient: string;
        leadTimeRanking: string;
        priceRanking: string;
        qualityRanking: string;
        quantityRanking: string;
        freeRanking: string;
        totalRanking: string;
        creditControl: WorkInProgressControl;
        intrastatIncreaseCoefficient: string;
        mustRemindDelivery: boolean;
        mustRemindAcknowledgment: boolean;
        isDas2Submitted: boolean;
        isActive: boolean;
        isPaymentHeld: boolean;
        mustPrintOrderForm: boolean;
        mustPrintReceiptNote: boolean;
        mustPrintReturnSlip: boolean;
        ourCustomerNameForSupplier: string;
        is281Submitted: boolean;
        amountType: PriceAmountTaxTax;
        isCashVat: boolean;
        cashVatDeadline: string;
        selfBillingCode: string;
        rexNumber: string;
        hasNoWhiteListVerification: boolean;
        isElectronicInvoicingAllowed: boolean;
        contact: SupplierContact;
        startDateForElectronicInvoice: string;
        addresses: ClientCollection<SupplierAddress>;
        contacts: ClientCollection<SupplierContact>;
        acronym: string;
        businessPartnerSite: Site;
        cfonbPaymentMethod: MiscellaneousTable;
        companyName1: string;
        companyName2: string;
        companyNames: ClientCollection<BusinessPartnerCompanyNames>;
        consolidationCode: string;
        consolidationGroup: SiteGroupings;
        consolidationPartner: BusinessPartner;
        country: Country;
        customerOrSupplierOriginCategory: string;
        documentType: DocumentType;
        economicOperatorRegistrationAndIdNumber: string;
        europeanUnionVatNumber: string;
        fiscalCode: string;
        isCashExcluded: boolean;
        isIntersite: boolean;
        isMailingProhibited: boolean;
        isPhysicalPerson: boolean;
        isPublicSector: boolean;
        isServiceCaller: boolean;
        isServiceSupplier: boolean;
        italianTaxNumber: string;
        language: Language;
        nonResidentAccount: BusinessPartnerAddress;
        purchaseOrderText: TextStream;
        registrationNumber: string;
        relatedCompany: RelatedCompanySettings;
        reportAccessCode: Access;
        returnOrderText: TextStream;
        shortCompanyName: string;
        siteIdentificationNumber: string;
        standardIndustrialClassificationCode: string;
        vatNumber: string;
        paymentTerm: PaymentTerm;
        earlyDiscountOrLateCharge: EarlyDiscountLateCharge;
        taxRule: TaxRule;
        accountingCode: AccountingCode;
    }
    export interface SupplierExtension$Lookups {
        accountingCode: QueryOperation<AccountingCode>;
    }
    export interface SupplierExtension$Operations {
        lookups(dataOrId: string | { data: SupplierInput }): SupplierExtension$Lookups;
    }
    export interface SupplierInvoiceHeaderExtension {
        _updateUser: SysUser;
        _createUser: SysUser;
        id: string;
        category: InvoiceType;
        purchaseInvoiceCategory: PurchaseInvoiceCategory;
        sourceModule: ModuleTable;
        billBySupplier: Supplier;
        control: string;
        company: Company;
        site: Site;
        accountingDate: string;
        internalNumber: integer;
        internalReference: string;
        sourceDocumentDate: string;
        sourceDocument: string;
        currency: Currency;
        rateType: ExchangeRateType;
        rateDate: string;
        isDAS2Submitted: boolean;
        payToBusinessPartner: BusinessPartner;
        dueDateCalculationStartDate: string;
        paymentTerm: PaymentTerm;
        earlyDiscountOrLateCharge: EarlyDiscountLateCharge;
        earlyDiscountOrLateChargeRate: string;
        taxRule: TaxRule;
        isEuropeanUnionInvoice: boolean;
        intrastatProcessingNumber: integer;
        status: PurchasingInvoiceStatus;
        paymentApproval: PaymentApprovalType;
        originalInvoiceNumber: string;
        debitOrCredit: integer;
        totalAmountIncludingTax: string;
        totalAmountExcludingTax: string;
        totalAmountIncludingTaxInCompanyCurrency: string;
        totalAmountExcludingTaxInCompanyCurrency: string;
        taxReferenceDate: string;
        numberOfTaxes: integer;
        billBySupplierAddress: SupplierAddress;
        billBySupplierPostalCode: string;
        billBySupplierCity: string;
        billBySupplierState: string;
        billBySupplierCountry: Country;
        billBySupplierCountryName: string;
        payToBusinessPartnerAddress: BusinessPartnerAddress;
        payToBusinessPartnerPostalCode: string;
        payToBusinessPartnerCity: string;
        payToBusinessPartnerState: string;
        payToBusinessPartnerCountry: Country;
        payToBusinessPartnerCountryName: string;
        incoterm: Incoterm;
        incotermTown: string;
        intrastatTransportLocation: CountryLocation;
        europeanUnionIdentification: string;
        forwardingAgent: Carrier;
        forwardingAgentAddress: SupplierAddress;
        fiscalYear: integer;
        period: integer;
        serviceStartDate: string;
        serviceEndDate: string;
        lastServiceAccountedDate: string;
        unblockUser: User;
        unblockDate: string;
        unblockAmount: string;
        matchStatus: MatchStatusEnum;
        earlyDiscountOrLateChargeBasis: string;
        priceOrAmountType: PriceAmountTaxTax;
        singleCustomsDocumentDate: string;
        singleCustomsDocumentReference: string;
        singleCustomsDocumentBusinessPartnerCode: Supplier;
        derCode: string;
        versionControlSystemNumber: string;
        priceOrAmountTaxType: PriceAmountTaxTax;
        recurringNumber: string;
        importTaxAmountNumber: string;
        recurringInvoicingDate: string;
        numberOfCompanies: integer;
        cashVatTaxRule: boolean;
        field40Reason: MiscellaneousTable;
        field41Reason: MiscellaneousTable;
        originalDocumentNumber: string;
        inPaymentSlipWithReferenceLine: string;
        bankId: string;
        project: ProjectLink;
        numberOfInvoiceCopies: integer;
        billBySupplierAddressLines: ClientCollection<SupplierInvoiceHeaderBillBySupplierAddressLines>;
        billBySupplierCompanyNames: ClientCollection<SupplierInvoiceHeaderBillBySupplierCompanyNames>;
        comments: ClientCollection<SupplierInvoiceHeaderComments>;
        payToBusinessPartnerAddressLines: ClientCollection<SupplierInvoiceHeaderPayToBusinessPartnerAddressLines>;
        payToBusinessPartnerCompanyNames: ClientCollection<SupplierInvoiceHeaderPayToBusinessPartnerCompanyNames>;
        taxes: ClientCollection<SupplierInvoiceHeaderTaxes>;
        entryType: EntryType;
        journal: Journal;
        currencyRates: ClientCollection<SupplierInvoiceHeaderCurrencyRates>;
        dimensions: ClientCollection<SupplierInvoiceHeaderDimensions>;
    }
    export interface SupplierInvoiceHeaderInputExtension {
        id?: string;
        category?: InvoiceType;
        purchaseInvoiceCategory?: PurchaseInvoiceCategory;
        sourceModule?: ModuleTable;
        billBySupplier?: string;
        control?: string;
        company?: string;
        site?: string;
        accountingDate?: string;
        internalNumber?: integer | string;
        internalReference?: string;
        sourceDocumentDate?: string;
        sourceDocument?: string;
        currency?: string;
        rateType?: ExchangeRateType;
        rateDate?: string;
        isDAS2Submitted?: boolean | string;
        payToBusinessPartner?: string;
        dueDateCalculationStartDate?: string;
        paymentTerm?: string;
        earlyDiscountOrLateCharge?: string;
        earlyDiscountOrLateChargeRate?: decimal | string;
        taxRule?: string;
        isEuropeanUnionInvoice?: boolean | string;
        intrastatProcessingNumber?: integer | string;
        status?: PurchasingInvoiceStatus;
        paymentApproval?: PaymentApprovalType;
        originalInvoiceNumber?: string;
        debitOrCredit?: integer | string;
        totalAmountIncludingTax?: decimal | string;
        totalAmountExcludingTax?: decimal | string;
        totalAmountIncludingTaxInCompanyCurrency?: decimal | string;
        totalAmountExcludingTaxInCompanyCurrency?: decimal | string;
        taxReferenceDate?: string;
        numberOfTaxes?: integer | string;
        billBySupplierAddress?: string;
        billBySupplierPostalCode?: string;
        billBySupplierCity?: string;
        billBySupplierState?: string;
        billBySupplierCountry?: string;
        billBySupplierCountryName?: string;
        payToBusinessPartnerAddress?: string;
        payToBusinessPartnerPostalCode?: string;
        payToBusinessPartnerCity?: string;
        payToBusinessPartnerState?: string;
        payToBusinessPartnerCountry?: string;
        payToBusinessPartnerCountryName?: string;
        incoterm?: string;
        incotermTown?: string;
        intrastatTransportLocation?: CountryLocation;
        europeanUnionIdentification?: string;
        forwardingAgent?: string;
        forwardingAgentAddress?: string;
        fiscalYear?: integer | string;
        period?: integer | string;
        serviceStartDate?: string;
        serviceEndDate?: string;
        lastServiceAccountedDate?: string;
        unblockUser?: string;
        unblockDate?: string;
        unblockAmount?: decimal | string;
        matchStatus?: MatchStatusEnum;
        earlyDiscountOrLateChargeBasis?: decimal | string;
        priceOrAmountType?: PriceAmountTaxTax;
        singleCustomsDocumentDate?: string;
        singleCustomsDocumentReference?: string;
        singleCustomsDocumentBusinessPartnerCode?: string;
        derCode?: string;
        versionControlSystemNumber?: string;
        priceOrAmountTaxType?: PriceAmountTaxTax;
        recurringNumber?: string;
        importTaxAmountNumber?: string;
        recurringInvoicingDate?: string;
        numberOfCompanies?: integer | string;
        cashVatTaxRule?: boolean | string;
        field40Reason?: string;
        field41Reason?: string;
        originalDocumentNumber?: string;
        inPaymentSlipWithReferenceLine?: string;
        bankId?: string;
        project?: string;
        numberOfInvoiceCopies?: integer | string;
        billBySupplierAddressLines?: Partial<SupplierInvoiceHeaderBillBySupplierAddressLinesInput>[];
        billBySupplierCompanyNames?: Partial<SupplierInvoiceHeaderBillBySupplierCompanyNamesInput>[];
        comments?: Partial<SupplierInvoiceHeaderCommentsInput>[];
        payToBusinessPartnerAddressLines?: Partial<SupplierInvoiceHeaderPayToBusinessPartnerAddressLinesInput>[];
        payToBusinessPartnerCompanyNames?: Partial<SupplierInvoiceHeaderPayToBusinessPartnerCompanyNamesInput>[];
        taxes?: Partial<SupplierInvoiceHeaderTaxesInput>[];
        entryType?: string;
        journal?: string;
        currencyRates?: Partial<SupplierInvoiceHeaderCurrencyRatesInput>[];
        dimensions?: Partial<SupplierInvoiceHeaderDimensionsInput>[];
    }
    export interface SupplierInvoiceHeaderBindingExtension {
        _updateUser: SysUser;
        _createUser: SysUser;
        id: string;
        category: InvoiceType;
        purchaseInvoiceCategory: PurchaseInvoiceCategory;
        sourceModule: ModuleTable;
        billBySupplier: Supplier;
        control: string;
        company: Company;
        site: Site;
        accountingDate: string;
        internalNumber: integer;
        internalReference: string;
        sourceDocumentDate: string;
        sourceDocument: string;
        currency: Currency;
        rateType: ExchangeRateType;
        rateDate: string;
        isDAS2Submitted: boolean;
        payToBusinessPartner: BusinessPartner;
        dueDateCalculationStartDate: string;
        paymentTerm: PaymentTerm;
        earlyDiscountOrLateCharge: EarlyDiscountLateCharge;
        earlyDiscountOrLateChargeRate: string;
        taxRule: TaxRule;
        isEuropeanUnionInvoice: boolean;
        intrastatProcessingNumber: integer;
        status: PurchasingInvoiceStatus;
        paymentApproval: PaymentApprovalType;
        originalInvoiceNumber: string;
        debitOrCredit: integer;
        totalAmountIncludingTax: string;
        totalAmountExcludingTax: string;
        totalAmountIncludingTaxInCompanyCurrency: string;
        totalAmountExcludingTaxInCompanyCurrency: string;
        taxReferenceDate: string;
        numberOfTaxes: integer;
        billBySupplierAddress: SupplierAddress;
        billBySupplierPostalCode: string;
        billBySupplierCity: string;
        billBySupplierState: string;
        billBySupplierCountry: Country;
        billBySupplierCountryName: string;
        payToBusinessPartnerAddress: BusinessPartnerAddress;
        payToBusinessPartnerPostalCode: string;
        payToBusinessPartnerCity: string;
        payToBusinessPartnerState: string;
        payToBusinessPartnerCountry: Country;
        payToBusinessPartnerCountryName: string;
        incoterm: Incoterm;
        incotermTown: string;
        intrastatTransportLocation: CountryLocation;
        europeanUnionIdentification: string;
        forwardingAgent: Carrier;
        forwardingAgentAddress: SupplierAddress;
        fiscalYear: integer;
        period: integer;
        serviceStartDate: string;
        serviceEndDate: string;
        lastServiceAccountedDate: string;
        unblockUser: User;
        unblockDate: string;
        unblockAmount: string;
        matchStatus: MatchStatusEnum;
        earlyDiscountOrLateChargeBasis: string;
        priceOrAmountType: PriceAmountTaxTax;
        singleCustomsDocumentDate: string;
        singleCustomsDocumentReference: string;
        singleCustomsDocumentBusinessPartnerCode: Supplier;
        derCode: string;
        versionControlSystemNumber: string;
        priceOrAmountTaxType: PriceAmountTaxTax;
        recurringNumber: string;
        importTaxAmountNumber: string;
        recurringInvoicingDate: string;
        numberOfCompanies: integer;
        cashVatTaxRule: boolean;
        field40Reason: MiscellaneousTable;
        field41Reason: MiscellaneousTable;
        originalDocumentNumber: string;
        inPaymentSlipWithReferenceLine: string;
        bankId: string;
        project: ProjectLink;
        numberOfInvoiceCopies: integer;
        billBySupplierAddressLines: ClientCollection<SupplierInvoiceHeaderBillBySupplierAddressLinesBinding>;
        billBySupplierCompanyNames: ClientCollection<SupplierInvoiceHeaderBillBySupplierCompanyNamesBinding>;
        comments: ClientCollection<SupplierInvoiceHeaderCommentsBinding>;
        payToBusinessPartnerAddressLines: ClientCollection<SupplierInvoiceHeaderPayToBusinessPartnerAddressLinesBinding>;
        payToBusinessPartnerCompanyNames: ClientCollection<SupplierInvoiceHeaderPayToBusinessPartnerCompanyNamesBinding>;
        taxes: ClientCollection<SupplierInvoiceHeaderTaxesBinding>;
        entryType: EntryType;
        journal: Journal;
        currencyRates: ClientCollection<SupplierInvoiceHeaderCurrencyRatesBinding>;
        dimensions: ClientCollection<SupplierInvoiceHeaderDimensionsBinding>;
    }
    export interface SupplierInvoiceHeaderExtension$Lookups {
        entryType: QueryOperation<EntryType>;
        journal: QueryOperation<Journal>;
    }
    export interface SupplierInvoiceHeaderExtension$Operations {
        lookups(dataOrId: string | { data: SupplierInvoiceHeaderInput }): SupplierInvoiceHeaderExtension$Lookups;
    }
    export interface Package {
        '@sage/x3-finance-data/AccountScheme': AccountScheme$Operations;
        '@sage/x3-finance-data/Account': Account$Operations;
        '@sage/x3-finance-data/AccountingCode': AccountingCode$Operations;
        '@sage/x3-finance-data/AutomaticJournal': AutomaticJournal$Operations;
        '@sage/x3-finance-data/BankAccount': BankAccount$Operations;
        '@sage/x3-finance-data/BillOfLanding': BillOfLanding$Operations;
        '@sage/x3-finance-data/ChartOfAccounts': ChartOfAccounts$Operations;
        '@sage/x3-finance-data/CostTypeDimensions': CostTypeDimensions$Operations;
        '@sage/x3-finance-data/CustomerDimensions': CustomerDimensions$Operations;
        '@sage/x3-finance-data/CustomerInvoiceHeaderCurrencyRates': CustomerInvoiceHeaderCurrencyRates$Operations;
        '@sage/x3-finance-data/CustomerInvoiceHeaderDimensions': CustomerInvoiceHeaderDimensions$Operations;
        '@sage/x3-finance-data/DimensionType': DimensionType$Operations;
        '@sage/x3-finance-data/Dimension': Dimension$Operations;
        '@sage/x3-finance-data/DistributionKey': DistributionKey$Operations;
        '@sage/x3-finance-data/EntryType': EntryType$Operations;
        '@sage/x3-finance-data/Factor': Factor$Operations;
        '@sage/x3-finance-data/FiscalYear': FiscalYear$Operations;
        '@sage/x3-finance-data/JournalEntryTransaction': JournalEntryTransaction$Operations;
        '@sage/x3-finance-data/Journal': Journal$Operations;
        '@sage/x3-finance-data/Ledger': Ledger$Operations;
        '@sage/x3-finance-data/OpenItem': OpenItem$Operations;
        '@sage/x3-finance-data/Period': Period$Operations;
        '@sage/x3-finance-data/ProductCategoryDimensions': ProductCategoryDimensions$Operations;
        '@sage/x3-finance-data/ProductDimensions': ProductDimensions$Operations;
        '@sage/x3-finance-data/ReminderGroup': ReminderGroup$Operations;
        '@sage/x3-finance-data/RevenueRecognitionRules': RevenueRecognitionRules$Operations;
        '@sage/x3-finance-data/StockJournalDimensions': StockJournalDimensions$Operations;
        '@sage/x3-finance-data/StockJournalImportDimensions': StockJournalImportDimensions$Operations;
        '@sage/x3-finance-data/SupplierInvoiceHeaderCurrencyRates': SupplierInvoiceHeaderCurrencyRates$Operations;
        '@sage/x3-finance-data/SupplierInvoiceHeaderDimensions': SupplierInvoiceHeaderDimensions$Operations;
    }
    export interface GraphApi
        extends Package,
            SageX3InvoicingData$Package,
            SageX3ManufacturingData$Package,
            SageX3MasterData$Package,
            SageX3ProjectManagementData$Package,
            SageX3StockData$Package,
            SageX3Structure$Package,
            SageX3System$Package,
            SageXtremAppMetadata$Package,
            SageXtremX3SystemUtils$Package {}
}
declare module '@sage/x3-finance-data-api' {
    export type * from '@sage/x3-finance-data-api-partial';
}
declare module '@sage/x3-invoicing-data-api-partial' {
    import type { GraphApi as GraphApiExtension } from '@sage/x3-finance-data-api';
    export interface GraphApi extends GraphApiExtension {}
}
declare module '@sage/x3-manufacturing-data-api-partial' {
    import type { GraphApi as GraphApiExtension } from '@sage/x3-finance-data-api';
    export interface GraphApi extends GraphApiExtension {}
}
declare module '@sage/x3-master-data-api-partial' {
    import type { GraphApi as GraphApiExtension } from '@sage/x3-finance-data-api';
    export interface GraphApi extends GraphApiExtension {}
}
declare module '@sage/x3-project-management-data-api-partial' {
    import type { GraphApi as GraphApiExtension } from '@sage/x3-finance-data-api';
    export interface GraphApi extends GraphApiExtension {}
}
declare module '@sage/x3-stock-data-api-partial' {
    import type { GraphApi as GraphApiExtension } from '@sage/x3-finance-data-api';
    export interface GraphApi extends GraphApiExtension {}
}
declare module '@sage/x3-structure-api-partial' {
    import type { GraphApi as GraphApiExtension } from '@sage/x3-finance-data-api';
    export interface GraphApi extends GraphApiExtension {}
}
declare module '@sage/x3-system-api-partial' {
    import type { GraphApi as GraphApiExtension } from '@sage/x3-finance-data-api';
    export interface GraphApi extends GraphApiExtension {}
}
declare module '@sage/xtrem-app-metadata-api-partial' {
    import type { GraphApi as GraphApiExtension } from '@sage/x3-finance-data-api';
    export interface GraphApi extends GraphApiExtension {}
}
declare module '@sage/xtrem-x3-system-utils-api-partial' {
    import type { GraphApi as GraphApiExtension } from '@sage/x3-finance-data-api';
    export interface GraphApi extends GraphApiExtension {}
}
declare module '@sage/x3-master-data-api-partial' {
    import type {
        BusinessPartnerBindingExtension,
        BusinessPartnerCompanyExceptionBindingExtension,
        BusinessPartnerCompanyExceptionExtension,
        BusinessPartnerCompanyExceptionExtension$Lookups,
        BusinessPartnerCompanyExceptionExtension$Operations,
        BusinessPartnerCompanyExceptionInputExtension,
        BusinessPartnerExtension,
        BusinessPartnerExtension$Lookups,
        BusinessPartnerExtension$Operations,
        BusinessPartnerInputExtension,
        CustomerBindingExtension,
        CustomerExtension,
        CustomerExtension$Lookups,
        CustomerExtension$Operations,
        CustomerInputExtension,
        ProductBindingExtension,
        ProductCategoryBindingExtension,
        ProductCategoryExtension,
        ProductCategoryExtension$Lookups,
        ProductCategoryExtension$Operations,
        ProductCategoryInputExtension,
        ProductExtension,
        ProductExtension$Lookups,
        ProductExtension$Operations,
        ProductInputExtension,
        SupplierBindingExtension,
        SupplierExtension,
        SupplierExtension$Lookups,
        SupplierExtension$Operations,
        SupplierInputExtension,
    } from '@sage/x3-finance-data-api';
    export interface BusinessPartnerCompanyException extends BusinessPartnerCompanyExceptionExtension {}
    export interface BusinessPartnerCompanyExceptionBinding extends BusinessPartnerCompanyExceptionBindingExtension {}
    export interface BusinessPartnerCompanyExceptionInput extends BusinessPartnerCompanyExceptionInputExtension {}
    export interface BusinessPartnerCompanyException$Lookups extends BusinessPartnerCompanyExceptionExtension$Lookups {}
    export interface BusinessPartnerCompanyException$Operations
        extends BusinessPartnerCompanyExceptionExtension$Operations {}
    export interface BusinessPartner extends BusinessPartnerExtension {}
    export interface BusinessPartnerBinding extends BusinessPartnerBindingExtension {}
    export interface BusinessPartnerInput extends BusinessPartnerInputExtension {}
    export interface BusinessPartner$Lookups extends BusinessPartnerExtension$Lookups {}
    export interface BusinessPartner$Operations extends BusinessPartnerExtension$Operations {}
    export interface Customer extends CustomerExtension {}
    export interface CustomerBinding extends CustomerBindingExtension {}
    export interface CustomerInput extends CustomerInputExtension {}
    export interface Customer$Lookups extends CustomerExtension$Lookups {}
    export interface Customer$Operations extends CustomerExtension$Operations {}
    export interface ProductCategory extends ProductCategoryExtension {}
    export interface ProductCategoryBinding extends ProductCategoryBindingExtension {}
    export interface ProductCategoryInput extends ProductCategoryInputExtension {}
    export interface ProductCategory$Lookups extends ProductCategoryExtension$Lookups {}
    export interface ProductCategory$Operations extends ProductCategoryExtension$Operations {}
    export interface Product extends ProductExtension {}
    export interface ProductBinding extends ProductBindingExtension {}
    export interface ProductInput extends ProductInputExtension {}
    export interface Product$Lookups extends ProductExtension$Lookups {}
    export interface Product$Operations extends ProductExtension$Operations {}
    export interface Supplier extends SupplierExtension {}
    export interface SupplierBinding extends SupplierBindingExtension {}
    export interface SupplierInput extends SupplierInputExtension {}
    export interface Supplier$Lookups extends SupplierExtension$Lookups {}
    export interface Supplier$Operations extends SupplierExtension$Operations {}
}
declare module '@sage/x3-project-management-data-api-partial' {
    import type {
        CostTypeBindingExtension,
        CostTypeExtension,
        CostTypeInputExtension,
    } from '@sage/x3-finance-data-api';
    export interface CostType extends CostTypeExtension {}
    export interface CostTypeBinding extends CostTypeBindingExtension {}
    export interface CostTypeInput extends CostTypeInputExtension {}
}
declare module '@sage/x3-invoicing-data-api-partial' {
    import type {
        CustomerInvoiceHeaderBindingExtension,
        CustomerInvoiceHeaderExtension,
        CustomerInvoiceHeaderExtension$Lookups,
        CustomerInvoiceHeaderExtension$Operations,
        CustomerInvoiceHeaderInputExtension,
        SupplierInvoiceHeaderBindingExtension,
        SupplierInvoiceHeaderExtension,
        SupplierInvoiceHeaderExtension$Lookups,
        SupplierInvoiceHeaderExtension$Operations,
        SupplierInvoiceHeaderInputExtension,
    } from '@sage/x3-finance-data-api';
    export interface CustomerInvoiceHeader extends CustomerInvoiceHeaderExtension {}
    export interface CustomerInvoiceHeaderBinding extends CustomerInvoiceHeaderBindingExtension {}
    export interface CustomerInvoiceHeaderInput extends CustomerInvoiceHeaderInputExtension {}
    export interface CustomerInvoiceHeader$Lookups extends CustomerInvoiceHeaderExtension$Lookups {}
    export interface CustomerInvoiceHeader$Operations extends CustomerInvoiceHeaderExtension$Operations {}
    export interface SupplierInvoiceHeader extends SupplierInvoiceHeaderExtension {}
    export interface SupplierInvoiceHeaderBinding extends SupplierInvoiceHeaderBindingExtension {}
    export interface SupplierInvoiceHeaderInput extends SupplierInvoiceHeaderInputExtension {}
    export interface SupplierInvoiceHeader$Lookups extends SupplierInvoiceHeaderExtension$Lookups {}
    export interface SupplierInvoiceHeader$Operations extends SupplierInvoiceHeaderExtension$Operations {}
}
declare module '@sage/x3-stock-data-api-partial' {
    import type {
        StockJournalBindingExtension,
        StockJournalExtension,
        StockJournalExtension$Lookups,
        StockJournalExtension$Operations,
        StockJournalInputExtension,
    } from '@sage/x3-finance-data-api';
    export interface StockJournal extends StockJournalExtension {}
    export interface StockJournalBinding extends StockJournalBindingExtension {}
    export interface StockJournalInput extends StockJournalInputExtension {}
    export interface StockJournal$Lookups extends StockJournalExtension$Lookups {}
    export interface StockJournal$Operations extends StockJournalExtension$Operations {}
}
declare module '@sage/x3-manufacturing-data-api-partial' {
    import type {
        StockJournalImportBindingExtension,
        StockJournalImportExtension,
        StockJournalImportExtension$Lookups,
        StockJournalImportExtension$Operations,
        StockJournalImportInputExtension,
    } from '@sage/x3-finance-data-api';
    export interface StockJournalImport extends StockJournalImportExtension {}
    export interface StockJournalImportBinding extends StockJournalImportBindingExtension {}
    export interface StockJournalImportInput extends StockJournalImportInputExtension {}
    export interface StockJournalImport$Lookups extends StockJournalImportExtension$Lookups {}
    export interface StockJournalImport$Operations extends StockJournalImportExtension$Operations {}
}
